2022-11-07  Gavin Smith  <gavinsmith0123@gmail.com>

	* README-hacking: remove to-do item

2022-11-07  Gavin Smith  <gavinsmith0123@gmail.com>

	7.0

	* configure.ac, NEWS, util/texi2dvi, util/texi2pdf: version

2022-11-07  Gavin Smith  <gavinsmith0123@gmail.com>

	* README-hacking: reorder official releases tasks

2022-11-07  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/Makefile.am (wwwdoc-build, wwwdoc-install): handle
	new manuals texi2any_api and texi2any_internals

2022-11-07  Gavin Smith  <gavinsmith0123@gmail.com>

	* README-hacking: not making diffs any more

2022-11-07  Gavin Smith  <gavinsmith0123@gmail.com>

	* NEWS: final edit

2022-11-07  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.tex (\mtadjustprotcode): Use new count \countC
	instead of reusing \countB which appears to clash with \pdfgettoks,
	leading to an error "pdfTeX warning (dest): name{} has 
        been referenced but does not exist, replaced by a fixed one" always
	being output.

2022-11-07  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi
	(Cross Reference Parts, Other Customization Variables):
	Reword to avoid underful and overful hboxes.

2022-11-06  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.tex (\doindexsegment):
	Issue warning on empty sort key.  Suggestion from Werner.

2022-11-06  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Indexing Commands):
	Advice on empty index sort keys.  Report from Werner.

2022-11-01  Patrice Dumas  <pertusus@free.fr>

	* doc/texinfo.texi (Internationalization of Document Strings):
	Describe use of us-ascii as a "special use" as it does not
	follow usual gettext conventions.

2022-11-01  Patrice Dumas  <pertusus@free.fr>, and
            Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (@documentencoding): Mention possibility
	of ASCII transliteration.  Don't say "UTF-8 character in
	the output encoding", as this can only mean one encoding (UTF-8).
	Reorder to say "8-bit character in the output encoding".

	(Internationalization of Document Strings): State accent commands
	have to be used in us-ascii translations, but that these may
	be inconvenient.

2022-10-29  Gavin Smith  <gavinsmith0123@gmail.com>

	pretest 6.8.91

	* configure.ac: version

2022-10-28  Vincent Lefevre <vincent@vinc17.net>  (tiny change)

	* doc/texinfo.texi (Writing a Node, Conditional Commands):
	Fix typos.

2022-10-27  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/t/paragraph.t: use intended formatter in tests

2022-10-27  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/Texinfo/Convert/Line.pm: remove
	* tp/t/paragraph.t: copy line formatter constructor from Line.pm

2022-10-27  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/Texinfo/Convert/UnFilled.pm: remove unused module.

2022-10-27  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/Texinfo/Convert/Plaintext.pm (process_printindex): Reuse
	line formatter for all index entries in an index.

2022-10-27  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/Texinfo/Convert/Plaintext.pm (_convert) <node name quoting>:
	Optimise for the usual case where the node name is simple text,
	in which case avoid calling convert_line.

2022-10-27  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/Texinfo/Convert/Plaintext.pm (new_formatter): Access 'conf'
	hash directly for efficiency, rather than calling get_conf.

2022-10-27  Gavin Smith  <gavinsmith0123@gmail.com>

	* README-hacking: more on Devel::NYTProf

2022-10-25  Patrice Dumas  <pertusus@free.fr>

	Use \[..\] for @displaymath in LaTeX output

	* tp/Texinfo/Convert/LaTeX.pm (_convert): use \[..\] instead of $$..$$
	as it is better to use \[ in LaTeX, $$ being a TeX primitive.  Report
	from Vincent Lefèvre.

2022-10-25  Patrice Dumas  <pertusus@free.fr>

	Use \[..\] for @displaymath for LaTeX in tex4ht and latex2html

	* tp/ext/latex2html.pm (l2h_process), tp/ext/tex4ht.pm
	(tex4ht_prepare): use \[..\] instead of $$..$$ as it is better to
	use \[ in LaTeX, $$ being a TeX primitive.  Report from Vincent
	Lefèvre.

2022-10-25  Patrice Dumas  <pertusus@free.fr>

	* tp/maintain/copy_change_file_name_encoding.pl: change the character
	appearing in the test of 8bit encoded include file, as it may be
	special on Windows.  Report from Gavin.

2022-10-25  Patrice Dumas  <pertusus@free.fr>

	* tp/maintain/copy_change_file_name_encoding.pl: use a character
	appearing in more 8bit encodings in the test of 8bit encoded
	include file.  Eli Zaretskii idea.

2022-10-26  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/t/test_utils.pl (filter_tree_keys): Do not output 'parent'
	keys in tree.  This makes the output files much smaller and also
	makes the tests a bit faster.

2022-10-25  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (@minus): Do not state that '-' always produces
	a hyphen in fixed-width fonts, as this may not be true.
	Report from Vincent Lefèvre.

2022-10-25  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/Makefile.am (distlean-local, CLEANFILES, DISTCLEANFILES):
	Remove references to blib, pm_to_blib and Makefile.old files
	and directories.  These are relics of an old Perl build system
	that is no longer present.  Remove reference to 'texi2any-perl'
	file, not present anywhere.

2022-10-25  Gavin Smith  <gavinsmith0123@gmail.com>

	* Makefile.am, README, README-hacking: Do not distribute the
	contrib/ subdirectory.  This shrinks the .tar.xz file to
	5.2 MB.

2022-10-25  Gavin Smith  <gavinsmith0123@gmail.com>

	* js/Makefile.am (EXTRA_DIST): Do not distribute 'examples'
	directory.  This shrinks .tar.xz file from 5.9 MB to 5.5 MB.

2022-10-25  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/tests/formatting/an_ïmage.png: Shrink image to reduce
	use of space.

2022-10-25  Gavin Smith  <gavinsmith0123@gmail.com>

	* info/scan.c (scan_node_contents): Free node contents if
	N_WasRewritten flag is set.  This avoids a memory leak in
	the t/index-search.sh test.

2022-10-25  Gavin Smith  <gavinsmith0123@gmail.com>

	* README-hacking: advice on valgrind

2022-10-25  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (@minus): Do not state that '-' produces
	a minus sign inside @math as results differ for different output
	formats.  Report from Vincent Lefèvre.

2022-10-25  Gavin Smith  <gavinsmith0123@gmail.com>

	awk check

	* configure.ac: Rewrite awk check to use
	AC_PATH_PROGS_FEATURE_CHECK.  Check for user-defined functions.
	Suggestion from Bruno Haible.  Check for "awk" before trying other
	program names.

2022-10-25  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi: Limit references to the XML output, as
	it is not likely to be useful.  Eliminate references to
	"TexinfoXML" or "Texinfo-XML".
	(Overview): Do not mention PostScript format.  Mention EPUB 3 and
	LaTeX.  Do not say that using Emacs is "especially convenient".
	(Output Formats) <XML>: Edit.  Make it more prominent that the XML
	format is not usable.

2022-10-25  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Translations.pm (gdt): replace argument variable name
	$context with $replaced_substrings, as it could be confused with
	message context.

2022-10-25  Patrice Dumas  <pertusus@free.fr>

	* po/Makevars (XGETTEXT_OPTIONS): add -k__p:1c,2 for __p() in perl.

2022-10-24  Patrice Dumas  <pertusus@free.fr>

	Fix/add @direntry for texi2any_api and texi2any_internals

	* doc/texi2any_api.texi, doc/tp_api/Makefile.am (EXTRA_DIST),
	texi2any_internals_preamble.texi: fix the texi2any_api @direntry
	to refer to texi2any_api.
	Add a @dircategory/@direntry to texi2any_internals by putting the
	preamble in texi2any_internals_preamble.texi and setting the
	preamble argument of pod2texi.
	Report from Andreas Schwab.

2022-10-24  Patrice Dumas  <pertusus@free.fr>

	* Pod-Simple-Texinfo/pod2texi.pl, doc/tp_api/Makefile.am:
	no @setfilename output if --setfilename is not given in argument
	of pod2texi.pl.
	Remove --setfilename from the rule generating texi2any_internals.texi.

2022-10-24  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/Texinfo/Convert/HTML.pm (_convert_menu_entry_type):
	Initialize a variable.

	This avoids error "Use of uninitialized value $href in string ne..."
	when running the test suite.

2022-10-24  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Cross Reference Parts, Marking Text, @set @value)
	(Command List, Tips): Change "formatters" to "processors" in some
	places where we are not clearly talking about formatting a visual
	layout.

2022-10-24  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (HTML Xref): Do not describe the "details"
	as "unfortunately complex".

2022-10-24  Gavin Smith  <gavinsmith0123@gmail.com>

	* configure.ac (TI_AWK): Reorder to check for awk after gawk.

2022-10-24  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Conditional Nesting): Edit.  Do not
	vaguely describe the subject as "tricky".  Ignore some
	text.

2022-10-24  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Reporting Bugs): Mention 'git diff'.  Do
	not encourage sending large input files in bug reports.
	(Output Formats): Remove useless word "brief".
	(@enumerate): Remove "brief" and some self-referential text.
	(@set @clear @value): Edit and shorten.
	(HTML CSS): Edit.  Remove @ignore'd text.

2022-10-24  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi: Prefer "texi2any" to "makeinfo" throughout.

2022-10-24  Gavin Smith  <gavinsmith0123@gmail.com>

	* README-hacking: Add agendum for next release
	* README: Revise - https for URL's, mention LaTeX and EPUB 3 output,
	info.texi not part of Texinfo distribution, prefer "texi2any" to
	"makeinfo".

2022-10-23  Patrice Dumas  <pertusus@free.fr>

	* Pod-Simple-Texinfo/prove.sh: remove -w from prove arguments for old
	prove.  Report from Eli Zaretskii.

2022-10-23  Patrice Dumas  <pertusus@free.fr>

	* tp/tests/run_parser_all.sh (check_need_command_line_unicode),
	tp/tests/many_input_files/*non_ascii*.sh: skip tests needing
	UTF-8 encoded non-ASCII characters on the command line on Windows,
	as the shell may interpret those characters to be encoded in the
	current user codeset and pass them incorrectly to the programs.
	Report from Eli Zaretskii.

2022-10-23  Patrice Dumas  <pertusus@free.fr>

	* tp/tests/run_parser_all.sh,
	tp/maintain/copy_change_file_name_encoding.pl: consider that
	recoding of file name to Latin1 as needed by some tests is not
	reliable on Windows, as the non-ASCII character may be stored
	in the filesystem as an Unicode point using the current codepage
	to convert, and not the Latin1 encoding expected from the Perl code.
	Add comments to explain that.  Report from Eli Zaretskii.

2022-10-23  Patrice Dumas  <pertusus@free.fr>

	* configure.ac (HOST_IS_WINDOWS_VARIABLE), tp/defs.in: add variable
	set to yes if host is Windows.

2022-10-23  Gavin Smith  <gavinsmith0123@gmail.com>

	* configure.ac (TI_AWK): Check for "nawk" before awk, as
	plain awk on Solaris 11.4 is an archaic version lacking features
	we need, like user-defined functions.  Report from Bruno Haible.

2022-10-23  Bruno Haible  <bruno@clisp.org>

	Fix install-info tests on mingw

	 * install-info/tests/defs.in [mingw]: Set diff to
	'diff --strip-trailing-cr'.
	 * install-info/tests: Use ${diff} in all tests.

2022-10-23  Gavin Smith  <gavinsmith0123@gmail.com>

	Avoid calling Perl version of 'free'

	* tp/Texinfo/XS/parsetexi/api.c (reset_parser):
	Do not call 'free' - do everything via functions in other files.

	* tp/Texinfo/XS/parsetexi/api.c
	(set_input_file_name_encoding, conf_set_input_file_name_encoding)
	(set_locale_encoding, conf_set_locale_encoding)
	(set_documentlanguage_override, conf_set_documentlanguage_override):
	Provide wrappers with names starting with 'conf_', and move the
	implementations to other files.

	* tp/Texinfo/XS/parsetexi/input.c
	(set_input_file_name_encoding, set_locale_encoding): Add.  Allow
	null arguments.
	* tp/Texinfo/XS/parsetexi/parser.c
	(set_documentlanguage_override): Add.  Allow null argument.
	(set_documentlanguage):  Allow null argument.

	Report from Eli, who got "Free to wrong pool" error.

2022-10-23  Gavin Smith  <gavinsmith0123@gmail.com>

	* install-info/tests/README: Complete list of tests (not
	updated since 2014).
	* install-info/tests/ii-0054-test: Remove commented-out code.
	* install-info/tests/ii-0056-test: Correct test number and update
	reference results.

2022-10-23  Patrice Dumas  <pertusus@free.fr>

	* tp/ext/epub3.pm (epub_setup): use / as file separator for
	INFO_JS_DIR, which is used both for HTML paths, requiring / and
	paths to files on the filesystem, for which / may not be native,
	but works for Unix and Windows paths.  Report from Eli Zaretskii.

2022-10-23  Patrice Dumas  <pertusus@free.fr>

	Avoid UTF-8 encoded file name in make rule prerequisite

	* tp/maintain/copy_change_file_name_encoding.pl, tp/tests/Makefile.am:
	convert to latin1 from plain ASCII filename, substituting accented
	letters in tp/maintain/copy_change_file_name_encoding.pl.  Report from
	Eli Zaretskii.

2022-10-23  Gavin Smith  <gavinsmith0123@gmail.com>

	* info/t/where-dir-file.sh: Remove $ from argument to grep,
	as this causes problems on mingw-w64 where ginfo outputs
	lines with CRLF line endings but the grep program does not
	handle them specially.  Report from Bruno Haible.

2022-10-23  Eli Zaretskii  <eliz@gnu.org>, and
            Gavin Smith    <gavinsmith0123@gmail.com>

	* tp/texi2any.pl [MS-Windows]: If loading I18N::Langinfo doesn't
	work, then get codepage with GetACP() using Win32::API module.

2022-10-22  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/Texinfo/XS/XSParagraph.xs,
	* tp/Texinfo/XS/parsetexi/api.c
	[defined _WIN32 && !defined __CYGWIN__]:
	'#undef free' after including "perl.h" (which includes stdlib.h
	from Gnulib) and before including "XSUB.h" to avoid warnings
	about redefining symbols in Perl headers that Gnulib already
	redefined.  From Eli.

2022-10-22  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/Texinfo/XS/configure.ac: Attempt to disable gnulib
	definitions for fdopen, mktemp and putenv on MS-Windows by
	setting variables with GL_GNULIB_MDA_ prefixes.

2022-10-22  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Minimum): Minor grammar fix.

2022-10-22  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/ParserNonXS.pm (_parse_line_command_args): set
	definfoenclose defined command nesting.

2022-10-22  Eli Zaretskii  <eliz@gnu.org>

	* tp/Texinfo/XS/parsetexi/api.c
	(reset_parser, set_documentlanguage_override)
	(set_input_file_name_encoding, set_locale_encoding): Add dTHX.

2022-10-22  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/ParserNonXS.pm, tp/Texinfo/XS/parsetexi/command_data.txt,
	tp/Texinfo/XS/parsetexi/parser.c (check_valid_nesting): set @*heading
	heading customization variables as contain_simple_text.  Modify perl
	Parser to handle in_heading_spec_commands similarly as XS parser.

2022-10-22  Patrice Dumas  <pertusus@free.fr>

	* tp/ext/tex4ht.pm (tex4ht_process): sort formats for processing order
	to get a more reproducible output and messages order.

2022-10-22  Patrice Dumas  <pertusus@free.fr>

	Full coverage of contain_plain_text and contain_simple_text

	* tp/Texinfo/XS/parsetexi/command_data.txt, tp/Texinfo/ParserNonXS.pm,
	tp/Texinfo/XS/parsetexi/parser.c (check_valid_nesting): add explicit
	contain_plain_text and contain_simple_text flags to all commands
	instead of using conditionals.  Use contain_plain_text instead of
	contain_simple_text for LINE_text and LINE_specific.

2022-10-21  Gavin Smith  <gavinsmith0123@gmail.com>

	Save and restore LC_MESSAGES

	* tp/Texinfo/Translations.pm (gdt):
	Save and restore LC_MESSAGES rather than LC_ALL, as this seems
	safer than switching LC_ALL and not switching it back (see change
	on 2022-10-20).  Don't do this on MS-Windows where there were
	problems before with LC_MESSAGES (see change on 2021-02-27).

2022-10-21  Patrice Dumas  <pertusus@free.fr>

	* doc/refcard/txicmdcheck (read_refidx): filter out @sortas.

2022-10-21  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Inserting a Backslash):
	Add function index entries for @\.

2022-10-21  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Inserting an Ampersand):
	Add function index entries for @&.

2022-10-21  Patrice Dumas  <pertusus@free.fr>

	Update refcard to match manual

	* doc/refcard/txirefcard.tex: changes all over to match better
	with the evolution of the language and the Texinfo manual and other
	output formats than TeX and Info.

2022-10-20  Patrice Dumas  <pertusus@free.fr>

	Add @subentry, @seealso, @seeentry and @thissection* to refcard

	* doc/refcard/txirefcard.tex (Indices, Page headers and footers):
	add information on @subentry, @seealso, @seeentry and @thissection*.

2022-10-20  Patrice Dumas  <pertusus@free.fr>

	* doc/texinfo.texi (Predefined Indices): add findex entries for
	index entry commands based on two letter index names, such as
	@cpindex.  Add a sentence to explain that index entry commands
	based on two letter index names are valid.

2022-10-20  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Command List): Add @thissection,
	@thissectionname, @thissectionnum.  From Patrice.

2022-10-20  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/refcard/txicmdcheck (read_tp):
	Filter out @tpindex, etc., as we document @tindex etc. instead.
	From Patrice.

2022-10-20  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Advanced Indexing): Index @subentry
	without its leading @.
	(Command List): Add @seealso, @seeentry, @subentry.  From Patrice.

2022-10-20  Patrice Dumas  <pertusus@free.fr>

	* doc/refcard/txicmdcheck (read_tp): filter out obsolete @refill.

2022-10-20  Patrice Dumas  <pertusus@free.fr>

	* doc/texinfo.texi (Debugging with @TeX{}): remove obsolete @refill in
	example.

2022-10-20  Patrice Dumas  <pertusus@free.fr>

	* doc/refcard/txicmdcheck: minor, use directly hashes in some cases.

2022-10-20  Gavin Smith  <gavinsmith0123@gmail.com>

	Do not restore LC_ALL

	* tp/Texinfo/Translations.pm (gdt):
	Do not restore LC_ALL as this appears to override LC_CTYPE, at
	least on DragonFlyBSD 5.9, and LC_CTYPE needs to be set correctly for
	correct iteration over UTF-8 strings by mbrtowc in the XS paragraph
	formatting module.

	* doc/Makefile.am (Texinfo/Commands.pm): Add $(srcdir) to rule.

2022-10-19  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/Makefile.am (Texinfo/Commands.pm): Avoid $< as it is not
	supposed to be as portable
	* NEWS: edit

2022-10-19  Patrice Dumas  <pertusus@free.fr>

	* doc/refcard/txicmdcheck: use strict, explicit scalar.

2022-10-19  Patrice Dumas  <pertusus@free.fr>

	Better cutomization variables coverage by checking separately commands

	* doc/refcard/txivarcheck (main, read_refman), tp/Texinfo/Common.pm,
	util/txicustomvars: compare manual and lists from code and output
	separately Texinfo @-commands as customization variables and other
	customization variables.  Add --commands option to txicustomvars
	to show the global commands with a customization variable only.

	* doc/texinfo.texi (Customization Variables for @@-Commands):
	add missing customization variables for @-commands.

2022-10-19  Patrice Dumas  <pertusus@free.fr>

	* tp/ext/tex4ht.pm (tex4ht_prepare): fix typo in error messages.

2022-10-19  Patrice Dumas  <pertusus@free.fr>

	* doc/texinfo.texi (@command{texi2html}): add customization that
	should be used for the former texi2html --short-ext option.

2022-10-19  Gavin Smith  <gavinsmith0123@gmail.com>

	* NEWS: minor corrections

2022-10-19  Gavin Smith  <gavinsmith0123@gmail.com>

	pretest 6.8.90

	* configure.ac: version
	(AM_INIT_AUTOMAKE): Add dist-xz
	* info/info.c, install-info/install-info.c, tp/texi2any.pl,
	util/texi2dvi, util/texi2pdf: version, 2022.

2022-10-19  Gavin Smith  <gavinsmith0123@gmail.com>

	Fix compiler warnings

	* tp/Texinfo/XS/parsetexi/end_line.c
	(end_line_misc_line): Initialise a variable to make it clearer
	that it is not used uninitialised.
	* tp/Texinfo/XS/parsetexi/parser.c (isolate_last_space_internal):
	Move a declaration to the start of a block.

2022-10-19  Gavin Smith  <gavinsmith0123@gmail.com>

	Fix compiler warnings

	* tp/Texinfo/XS/parsetexi/context_stack.c
	(current_context, current_region),
	* tp/Texinfo/XS/parsetexi/end_line.c
	(end_line_starting_block, end_line_misc_line, end_line),
	* tp/Texinfo/XS/parsetexi/handle_commands.c
	(handle_other_command, handle_line_command),
	* tp/Texinfo/XS/parsetexi/input.c
	(convert_to_utf8, input_push_file)
	* tp/Texinfo/XS/parsetexi/parser.c:
	(isolate_last_space_internal, process_remaining_on_line):

	Fix warnings re declaration before statement, unused variables,
	unused labels.

2022-10-19  Gavin Smith  <gavinsmith0123@gmail.com>

	Address some compiler warnings

	* info/infopath.c (infopath_add),
	* info/session.c (menu_digit, forward_move_node_structure):
	Add brackets around assignment in condition.
	* info/man.c (check_manpage_node): Remove unused variables.

2022-10-19  Gavin Smith  <gavinsmith0123@gmail.com>

	* README-hacking: update advice on configuring for compiler warnings

2022-10-19  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/Texinfo/Common.pm (@variable_string_settables):
	Remove obsolete NODE_FILE_EXTENSION, SHORTEXTN.
	* doc/texinfo.texi (texi2html): Remove reference to SHORTEXTN.

2022-10-19  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/Texinfo/Common.pm (@variable_string_settables):
	Remove unused and undocumented FILE_NAMES_ENCODING_NAME.

2022-10-19  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/Texinfo/Common.pm (@variable_string_settables):
	Declare with "our" rather than "my" to allow "make vcheck"
	to work under doc/refcard/.

2022-10-19  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/refcard/txirefcard.tex: 2022, 7.0.

2022-10-19  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo-tex-test.texi (Macros): Add @page to allow
	test to be checked properly.

2022-10-19  Gavin Smith  <gavinsmith0123@gmail.com>

	refcard updates

	* doc/refcard/txicmdcheck: Remove exceptions for obsolete and removed
	commands.
	* doc/refcard/txirefcard.tex: Default encoding is UTF-8, not US-ASCII.
	Add @iflatex, @latex, @microtype.

2022-10-19  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (@-Command List): Add @latex.

2022-10-19  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/refcard/txicmdcheck: Change "refman" to "appendix" to
	make it easier to find where command is missing from.

2022-10-19  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Raw Formatter Commands):
	Add index entries for @docbook.

2022-10-19  Patrice Dumas  <pertusus@free.fr>

	* tp/init/book.pm (book_element_file_name): explicit return value
	for the second return value of the function.

2022-10-19  Gavin Smith  <gavinsmith0123@gmail.com>

	* configue.ac (TEXINFO_DTD_VERSION): Make this 7.0.

2022-10-19  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo-tex-test.texi (Acronyms): Minor edits.

2022-10-19  Gavin Smith  <gavinsmith0123@gmail.com>

	* README-hacking: Edit instructions on util/srclist-txi

2022-10-19  Gavin Smith  <gavinsmith0123@gmail.com>

	* util/srclist-txi, util/srclist.txt: Remove handing of
	automake files as "autoreconf" should take care of this.

2022-10-19  Gavin Smith  <gavinsmith0123@gmail.com>

	* README-hacking: Edit instructions on gnulib upgrade.

2022-10-19  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/tp_api/Makefile.am (AUTOMAKE_OPTIONS): Remove
	'no-installinfo' flag to build and install texinfo_internals.info.

2022-10-19  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/Makefile.am: Update for Chinese translation files.

2022-10-19  Wu XiangCheng  <bobwxc@yeah.net>

	* NEWS: Fix typo
	* doc/txi-zh.tex: Fix a space.

2022-10-19  Patrice Dumas  <pertusus@free.fr>

	* doc/texi2any_api.texi: update manual names in links to
	texi2any_internals.

2022-10-19  Patrice Dumas  <pertusus@free.fr>

	Rename texi2any modules and API manuals and distribute API manual

	* doc/Makefile.am (AM_MAKEINFOFLAGS, info_TEXINFOS, DISTCLEANFILES),
	doc/texi2any_api.texi: rename customization_api.texi as
	texi2any_api.texi.  Gavin suggestion.  Build and distribute
	texi2any_api manual.  Use AM_MAKEINFOFLAGS to set
	INFO_SPECIAL_CHARS_WARNING=0 since links to texi2any_internals
	manual produce many warnings.

	* doc/tp_api/Makefile.am (info_TEXINFOS), autogen.sh: rename
	tp_api.texi as texi2any_internals.texi.  Gavin suggestion.

2022-10-18  Wu XiangCheng  <bobwxc@yeah.net>

	* doc/txi-zh.tex (\Ynumbered): Override.

2022-10-18  Gavin Smith  <gavinsmith0123@gmail.com>

	Page ref hook

	* doc/texinfo.tex (\xrefX, \putpageref): Split out
	macro to print "page NUMBER".
	* doc/txi-zh.tex: Use to reverse the word order.
	From Wu XiangCheng.

2022-10-18  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/txi-zh.tex: Override \thischapterAppendix,
	\thischapterChapter, \thissectionDef.  From Wu XiangCheng.

2022-10-18  Gavin Smith  <gavinsmith0123@gmail.com>

	Translation hooks for chapter/section title

	* doc/texinfo.tex
	(\chapmacro, \thischapterAppendix, \thischapterChapter):
	Separate out definitions for \thischapter to allow them to
	be overridden in Chinese, where the word order is different.
	(\sectionheading, \thissectionDef): Likewise.

2022-10-18  Wu XiangCheng  <bobwxc@yeah.net>

	texinfo-zh.tex

	* doc/texinfo-zh.tex, doc/txi-zh.tex: New files, partially
	based on doc/texinfo-ja.tex and txi-ja.tex.

	* doc/short-sample-zh.tex: New file.

	* NEWS: Mention.

2022-10-18  Gavin Smith  <gavinsmith0123@gmail.com>

	More efficient subnode dumping

	* info/session.c (dump_node_to_stream): Take a FILE_BUFFER *
	argument rather than a filename.  Only get nodes from this file
	buffer, using info_get_node_of_file_buffer.  This avoids looking
	for the file for every node when dumping subnodes.
	(dump_nodes_to_file): Call info_find_file before calling
	dump_node_to_stream.

	Hilmar Preusse reported that "info python3.8 >/dev/null" had
	extremely high memory usage.  python3.8.info.gz was over 4MB
	in size, and had more than 4500 nodes.

2022-10-18  Gavin Smith  <gavinsmith0123@gmail.com>

	* info/filesys.c (info_find_fullpath): Change a comment.

2022-10-18  Gavin Smith  <gavinsmith0123@gmail.com>

	* info/man.c (check_manpage_node):
	Call get_manpage_node if exit status from man -w PAGE was 2.

2022-10-17  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (@quotation): Do not state that
	HTML uses <blockquote>.  From Patrice.

2022-10-17  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (@quotation): Reinstate
	Patrice's new text as it is better.

2022-10-17  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Inserting an Ampersand): Edit.

2022-10-17  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Printing Indices & Menus):
	Remove recently added word "currently".

2022-10-17  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Indexing Commands):
	Remove apparently useless sentence.  Change @code font
	to typewriter font.

2022-10-17  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Inserting Quotation Marks):
	Make discussion generic across output formats.  Account
	for fact that Info output is not pure ASCII any more
	so `` and '' do not necessarily become ".

2022-10-17  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Inserting a Backslash): Revert
	recent change.

2022-10-17  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Indices): Remove word "typically".

2022-10-17  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Footnote Commands): Revert recent change.
	Change "printed manual or book" to "printed output formats".

2022-10-17  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Image Syntax): Remove word "usually".

2022-10-17  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (@listoffloats): Edit.  Move output-format
	specific text to end of node.

2022-10-17  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (@table): Edit and condense discussion
	of blank lines.

2022-10-17  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (@minus): Remove duplicate text about
	@minus in a fixed width font.  Do not discuss @minus as an
	@itemize argument as this is already covered at the relevant node.

2022-10-17  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (@w) <$Id$>: Be clearer that the issue
	may be with output files.
	(@ifset @ifclear): Minor grammar fix "in output" -> "in the output".

2022-10-17  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (@raggedright): Minor edits.

2022-10-17  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (@exdent): Grammar/style change.  State
	that font style changes depend on output format.

2022-10-17  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (@kbd): State that font style change depends
	on output format.
	(@abbr, Block Enclosing Commands) Remove useless and confusing word
	"usually".  If it isn't true in some cases we should say or
	at least hint what those cases are.

2022-10-17  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (@code): Move treatment of Info/plaintext
	output together and reinstate some removed text.

2022-10-17  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Defining New Texinfo Commands):
	State that @definfoenclose is deprecated.  Do not
	self-congratulatorily describe @alias as "convenient".

2022-10-17  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (@cartouche): Partially revert changes.
	Be explicit about the effect of @group.

2022-10-17  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Raw Formatter Commands):
	Remove @ignore'd block completely.

2022-10-17  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Footnote Styles): Revert changes.

2022-10-17  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (@lisp): Revert change to "@example lisp"
	because this node is specifically about @lisp.

2022-10-17  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (@quotation): Revert recent changes to
	avoid needless equivocation.

2022-10-17  Gavin Smith  <gavinsmith0123@gmail.com>

	Reversions

	* doc/texinfo.texi (@cite, @code, @dfn, @acronym)
	(@email, @emph @strong, Smallcaps, Fonts):
	Revert recent changes that removed clear and useful
	information on the output of Texinfo commands in various
	output formats.

2022-10-17  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Raise/lower sections): Discuss effect
	on menus in a single paragraph and move test elsewhere.

2022-10-17  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (@key): Remove text with convention for GNU
	manuals as that doesn't belong here, but rather in a GNU
	standards document.

2022-10-17  Patrice Dumas  <pertusus@free.fr>

	Add TODO items, index commands in HTML, @titlepage, metadata...

2022-10-16  Patrice Dumas  <pertusus@free.fr>

	* doc/texinfo.texi (@code{@@unnumberedsubsec @@appendixsubsec
	@@subheading}, @code{@@cite}, Indicating, Quotations and Examples)
	(Lists and Tables, @code{@@listoffloats}, Inserting Images)
	(Footnote Commands, Footnote Styles, Indices, Special Insertions)
	(@code{@@- @@hyphenation}, @code{@@w})
	(@code{@@ifset @@ifclear}, Defining New Texinfo Commands):
	remove too detailed information on formatting.  Changed the
	text to highlight that the format is not fixed.  Avoid being
	unneedingly precise on the formatting of each output format, try
	instead to group types of formatting together.

	* doc/texinfo.texi (@node Raise/lower sections): constraint
	on menu only if not automatic menus.

	* doc/texinfo.texi (@code{@@cartouche}): use 'Highlighting Blocks'
	in section name to emphasize the semantic meaning.

	* doc/texinfo.texi (@code{@@lisp}, Glyphs for Programming): use
	@example list instead of @lisp.

	* doc/texinfo.texi (Inserting an Ampersand): describe the bold
	formatting as formatting and not has having a semantic meaning.

	* doc/texinfo.texi (Inserting Math): ref to tex4ht customization,
	\mathopsup not in LaTeX.

	* doc/texinfo.texi (Raw Formatter Commands): the description of other
	raw formats in Texinfo XML is incorrect, put it in an @ignore block.

	* tp/Texinfo/Convert/LaTeX.pm (%LaTeX_no_arg_brace_commands): use
	'\mathtt{\backslash{}}' for backslashchar to be in line with the
	Texinfo manual.

2022-10-16  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Inserting Math): Do not state that
	LaTeX commands can be used inside @math/@displaymath.
	Use @ not \ for Texinfo commands.  Reference
	T4H_MATH_CONVERSION for LaTeX output.

2022-10-16  Gavin Smith  <gavinsmith0123@gmail.com>

	* info/man.c (check_manpage_node, get_manpage_from_formatter):
	Apply ! operator to result of freopen, to silence obnoxious gcc
	warning.

2022-10-16  Gavin Smith  <gavinsmith0123@gmail.com>

	* system.h (ALSO_NULL_DEVICE): Remove unused.

2022-10-16  Gavin Smith  <gavinsmith0123@gmail.com>

	Check for man page with 'man -w'

	* info/man.c (check_manpage_node): New function, to check if
	man page exists with 'man -w'.  This is much faster for large
	man pages.
	(find_man_formatter): Cache return value.
	* info/info.c (get_initial_file): Use check_manpage_node instead
	of get_manpage_node.

	'info -w ffmpeg-all' was reported to be slow by Hilmar Preusse.
	'ffmpeg-all' is an especially long man page, so takes a longer time
	for nroff to format.

2022-10-16  Gavin Smith  <gavinsmith0123@gmail.com>

	* info/info.c (main) <--output>: Exit with status of 1, not 0,
	if there was an error.  Report from Hilmar Preusse <hille42@web.de>.

2022-10-15  Jakub Wilk  <jwilk@jwilk.net>  (tiny change)

	* doc/texinfo.texi (Info Format Cross Reference): Fix punctuation.

2022-10-15  Gavin Smith  <gavinsmith0123@gmail.com>

	Fix cartouche right edge 

	* doc/texinfo.tex (\cartouche): Reduce \cartinner and \cartouter
	to line up right edge with the text block.  Report from Werner
	3rd September.

2022-10-15  Patrice Dumas  <pertusus@free.fr>

	* doc/texinfo.texi (@node HTML Customization Variables): in the
	HTML_MATH entry, refer to the specific t4h options.  Also state that
	CONVERT_TO_LATEX_IN_MATH is set if HTML_MATH is set.

2022-10-15  Patrice Dumas  <pertusus@free.fr>

	* tp/texi2any.pl (GetOptions): add --iflatex.

	* tp/ext/tex4ht.pm (tex4ht_prepare): use \documentclass instead of
	\documentstyle, for latex type conversion.

2022-10-15  Patrice Dumas  <pertusus@free.fr>

	* tp/ext/latex2html.pm (l2h_process, l2h_convert_command),
	tp/ext/tex4ht.pm (tex4ht_prepare, tex4ht_convert_command): register
	formatting of latex block.
	Do not output any message nor any file for blocks that are
	not expanded.

2022-10-15  Patrice Dumas  <pertusus@free.fr>

	add @latex to l2h and use CONVERT_TO_LATEX_IN_MATH

	* doc/texinfo.texi (@command{latex2html} Customization Variables),
	tp/ext/latex2html.pm (l2h_process): select @latex blocks too.  If
	CONVERT_TO_LATEX_IN_MATH is set, convert input tree element content to
	LaTeX instead of Texinfo.

	* tp/ext/tex4ht.pm (tex4ht_prepare): actually output latex blocks.

2022-10-15  Patrice Dumas  <pertusus@free.fr>

	* tp/ext/tex4ht.pm (tex4ht_process_format): remove leading and
	trailing spaces in case of @math.  Report from Vincent Lefèvre.

2022-10-15  Patrice Dumas  <pertusus@free.fr>

	add @latex to t4h and some customization

	* doc/texinfo.texi (@command{tex4ht} Customization Variables),
	tp/Texinfo/Common.pm (@variable_string_settables), tp/ext/tex4ht.pm
	(tex4ht_prepare): add T4H_MATH_CONVERSION, T4H_TEX_CONVERSION and
	T4H_LATEX_CONVERSION as customization variables to select which
	type of conversion to use for math commands, @tex and @latex.

	* tp/ext/tex4ht.pm (tex4ht_prepare): if CONVERT_TO_LATEX_IN_MATH
	is set, and conversion type is latex, convert input tree element
	content to LaTeX instead of Texinfo.

2022-10-14  Patrice Dumas  <pertusus@free.fr>

	Use explicit \mathit for slates @-commands in math

	* tp/Texinfo/Convert/LaTeX.pm: for slanted indicatric commands,
	such as @var in math use \mathit instead of no command, as
	the space between the letters in argument can be important for some
	letters (such as ff), corresponding to letters being multiplied
	rather than to words, which is a better interpretation for
	@-command arguments.  Report from Vincent Lefèvre.

2022-10-14  Patrice Dumas  <pertusus@free.fr>

	Add simple customization of accent commands formatting in HTML

	* doc/customization_api.texi, tp/Texinfo/Config.pm
	($GNUT_accent_command_formatting_info)
	(texinfo_register_accent_command_formatting)
	(GNUT_get_accent_command_formatting), tp/Texinfo/Convert/Converter.pm
	(xml_numeric_entity_accent), tp/Texinfo/Convert/HTML.pm
	(_accent_entities_html_accent)
	(_accent_entities_numeric_entities_accent, _convert_accent_command)
	(converter_initialize), tp/init/html32.pm: add
	texinfo_register_accent_command_formatting and
	GNUT_get_accent_command_formatting to register simple accent
	formatting information.  Rename Texinfo::Convert::Converter
	_format_numeric_entities_accent as xml_numeric_entity_accent.
	Add _accent_entities_html_accent() and
	_accent_entities_numeric_entities_accent() functions in
	HTML.pm called by _convert_accent_command that are similar with
	XML accent formatting functions in Texinfo::Convert::Converter, but
	use the simple accent formatting information registered by the user.

2022-10-14  Patrice Dumas  <pertusus@free.fr>

	Format @*ref node out of main document to determine if quoted

	* tp/Texinfo/Convert/Info.pm (converter_line_warn)
	(converter_line_error), tp/Texinfo/Convert/Plaintext.pm
	(converter_line_warn, converter_line_error, _convert):
	add converter_line_warn and converter_line_error to intercept calls
	to line_warn and line_error in case a silent conversion is needed,
	with 'silent' set for converter.
	Convert the @*ref commands node outside of the main document
	formatting before converting the node normally, to determine if it
	needs to be quoted.

	* tp/Texinfo/Convert/Info.pm (add_text_to_count),
	tp/Texinfo/Convert/Plaintext.pm(add_text_to_count): rename
	add_text_count to add_text_to_count.

2022-10-13  Patrice Dumas  <pertusus@free.fr>

	* tp/init/html32.pm: do not use &minus;, protect with
	html32_format_protect_text to avoid &quot;.

2022-10-13  Patrice Dumas  <pertusus@free.fr>

	Use &minus; for @minus{} in HTML output

	* tp/Texinfo/Convert/Converter.pm
	(%xml_text_entity_no_arg_commands_formatting): use &minus; for
	@minus{}.  Report from Vincent Lefèvre.

2022-10-12  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/LaTeX.pm: setup %description_command_format in
	one loop.  Changes in comments.

2022-10-12  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/LaTeX.pm (_push_new_context): initialize
	all the possible keys.  Changes in comments.

2022-10-12  Patrice Dumas  <pertusus@free.fr>

	* doc/texinfo.texi (Inserting Math): do not described twice the
	output for HTML.  Report from Vincent Lefèvre.

2022-10-12  Patrice Dumas  <pertusus@free.fr>

	Document that microtype is off in the default case in LaTeX output

	* doc/texinfo.texi (Microtypography): explain that LaTeX font may not
	be scalable, that microtypography is off in the default case, how to
	turn it on and get scalable fonts.

2022-10-11  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/LaTeX.pm (%ignored_commands, _convert):
	explicitly ignore errormsg.  Recognize an empty string as conversion
	of %LaTeX_in_heading_commands_formatting commands.

2022-10-11  Patrice Dumas  <pertusus@free.fr>

	* util/htmlxref.cnf: corrections reported by Tzvetelin Katchov.
	Remove old reftex, fix coreutils, cpio, diffutils and gtypist mono
	urls, fix mono type of emacs-muse.

2022-10-11  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/Converter.pm (_normalize_filename_case)
	(set_tree_unit_file, set_file_path, _set_tree_units_files),
	tp/Texinfo/Convert/HTML.pm (_html_set_pages_files): split set_file_path
	out of set_tree_unit_file to set file path for each file name,
	which should be done for each file name, and therefore with a
	different function than set_tree_unit_file, which is called for each
	tree unit element.  Add _normalize_filename_case to be used in both
	set_tree_unit_file and set_file_path.

2022-10-11  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/HTML.pm (_set_root_commands_targets_node_files):
	handle undef returned by user defined node_file_name by reusing
	the default file name.

	* tp/Texinfo/Convert/HTML.pm (_html_set_pages_files): always use
	targets node_filename to determine a node file name.

	* tp/Texinfo/Convert/Converter.pm (_set_tree_units_files): use
	a variable in code for clarity.

2022-10-10  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Common.pm: add code (not active) to check
	that settable commands are contained in global commands.

	* tp/Texinfo/ParserNonXS.pm: set %global_multiple_commands
	and %global_unique_commands using the corresponding Texinfo::Commands
	hashes.

2022-10-10  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/HTML.pm (_html_set_pages_files): call
	set_tree_unit_file only once per tree unit, gather file names and
	file paths in a hash.

	* tp/Texinfo/Convert/HTML.pm (tree_unit_file_name), tp/init/book.pm:
	allow to customize both the file name and the file path.

2022-10-09  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/HTML.pm (_html_set_pages_files)
	(_prepare_special_elements, output): do not call set_tree_unit_file
	in _prepare_special_elements, it will be called in
	_html_set_pages_files if needed.  Initialize file counters in
	_html_set_pages_files.  If $document_name is not set in
	_prepare_special_elements, do not try to set a separate special
	element file name.

2022-10-09  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/IXIN.pm, tp/Texinfo/Convert/Text.pm
	(brace_no_arg_command, _convert), tp/Texinfo/Convert/Unicode.pm,
	tp/Texinfo/Convert/Utils.pm: avoid autovivification if not needed.
	Only put @def* name element in contents to be converted if defined.

2022-10-09  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/DocBook.pm, tp/Texinfo/Convert/TexinfoMarkup.pm:
	avoid autovivification if not needed.

2022-10-09  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/LaTeX.pm (_prepare_conversion): avoid
	autovivification if not needed.  Better initialization of conversion
	state in _prepare_conversion().

2022-10-09  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/Plaintext.pm (convert_tree, convert): avoid
	autovivification if not needed.  Better initialization of conversion
	state.

2022-10-09  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/HTML.pm (_initialize_output_state): avoid
	autovivification if not needed.  Add _initialize_output_state
	to initialize conversion state for a document output.

2022-10-09  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/Converter.pm (initialize_tree_units_files)
	(set_tree_unit_file, _set_tree_units_files, table_item_content_tree),
	tp/Texinfo/Convert/HTML.pm (_html_set_pages_files, output):
	add a function, initialize_tree_units_files to initialize hashes used
	in set_tree_unit_file and 'file_counters'.  Add a file path argument
	to set_tree_unit_file and use the function to set file path when non
	split too.  Initialize structures more explicitly.

	* tp/Texinfo/Convert/Converter.pm (output): use a hash directly,
	renamed as %files_filehandle from %files to associate filehandles.

2022-10-09  Patrice Dumas  <pertusus@free.fr>

	* tp/ext/*.pm, tp/init/*.pm: check that there is no incorrect
	autovivification, initialize explicitly.

	* tp/init/highlight_syntax.pm: update to match with changes in
	default example formatting.

	* tp/Texinfo/Convert/HTML.pm, tp/init/highlight_syntax.pm:
	reindent.

	Correct spelling of explicitly in different files.

2022-10-08  Patrice Dumas  <pertusus@free.fr>

	* util/htmlxref.cnf: corrections reported by Tzvetelin Katchov.
	Replace dmd by shepherd, remove pages not found, update some urls.

2022-10-08  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/Texinfo/Convert/LaTeX.pm: Change \GNUTexinfo- prefix
	to \Texinfo- throughout, both for brevity and to make it
	easier for others to make their own non-GNU version of Texinfo.

2022-10-08  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Generic Translator texi2any):
	Change @table @asis to @display to compress vertical spacing
	in LaTeX output.

2022-10-08  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/Texinfo/Convert/LaTeX.pm (_index_entry): Always output
	a sort key for cases like '@cindex @code{aaa} bbb' where the
	index text uses \commands.

2022-10-08  Patrice Dumas  <pertusus@free.fr>

	* Pod-Simple-Texinfo/lib/Pod/Simple/Texinfo.pm
	(_texinfo_handle_element_end): set explanation to the third argument
	of @ref and not the second such that it is used for all the output
	formats.

2022-10-08  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/Texinfo/Convert/LaTeX.pm (_latex_header) <indices>:
	Avoid extra heading before indices.

2022-10-08  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/Texinfo/Convert/LaTeX.pm (_protect_index_text):
	Protect \ before ", so @"a outputs as "\""a.
	(_protect_text): Do not call _protect_index_text.
	(_index_entry): Call _protect_index_test as needed.

2022-10-08  Patrice Dumas  <pertusus@free.fr>

	* Pod-Simple-Texinfo/lib/Pod/Simple/Texinfo.pm
	(_texinfo_handle_element_start, _prepend_internal_section_manual)
	(_convert_pod_simple_tree): add _convert_pod_simple_tree to convert a
	Pod::Simple::SimpleTree, or Pod::Simple::LinkSection trees to Texinfo
	using the same functions as the pull parser.  Use that function
	to convert L manual and L section to Texinfo code.  Add an argument to
	_prepend_internal_section_manual to avoid protection in case manual
	argument is already Texinfo.

	* Pod-Simple-Texinfo/lib/Pod/Simple/Texinfo.pm (_convert_pod_tokens):
	rename _convert_pod as _convert_pod_tokens.

2022-10-08  Patrice Dumas  <pertusus@free.fr>

	* Pod-Simple-Texinfo/lib/Pod/Simple/Texinfo.pm
	(_texinfo_handle_element_start, _texinfo_handle_text)
	(_texinfo_handle_element_end): use handle functions similar to
	those used in Pod::Simple to be able to use the different Pod::Simple
	parser styles more easily.  Put @accumulated_output
	in $self->{'texinfo_accumulated'} and @format_stack in
	$self->{'texinfo_stack'}.  Replace token modification after <X>
	to remove a leading space by setting
	$self->{'texinfo_ignore_leading_spaces'}.

2022-10-08  Patrice Dumas  <pertusus@free.fr>

	* Pod-Simple-Texinfo/lib/Pod/Simple/Texinfo.pm,
	Pod-Simple-Texinfo/pod2texi.pl: add comments to explain the issue with
	formatting section in L.  Also add code in comment to show the
	Pod::Simple tree.

2022-10-05  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Common.pm, tp/Texinfo/Commands.pod,
	doc/tp_api/Makefile.am (tp_api_dependencies, dist_modules_DATA),
	tp/Texinfo/XS/parsetexi/command_data.txt,
	tp/Texinfo/XS/parsetexi/commands.h: move Pod documentation on
	hashes in Texinfo::Commands out of tp/Texinfo/Common.pm to
	tp/Texinfo/Commands.pod. Add more information in
	tp/Texinfo/XS/parsetexi/command_data.txt and
	tp/Texinfo/XS/parsetexi/commands.h.

2022-10-05  Gavin Smith  <gavinsmith0123@gmail.com>

	* util/texi2dvi (decide_aux_files_method): Change an error
	message to be less confusing.

2022-10-02  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Common.pm, tp/Texinfo/ParserNonXS.pm,
	tp/Texinfo/XS/parsetexi/command_data.txt,
	tp/Texinfo/XS/parsetexi/commands.c (close_preformatted_command),
	tp/Texinfo/XS/parsetexi/commands.h, tp/Texinfo/XS/parsetexi/parser.c
	(begin_paragraph, process_remaining_on_line): add close_paragraph
	flag in command_data.txt.  Remove %close_paragraph_commands from
	Texinfo::Common.  Remove the close_paragraph_command function.

2022-10-02  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Common.pm, tp/Texinfo/Convert/DocBook.pm,
	tp/Texinfo/Convert/HTML.pm, tp/Texinfo/Convert/LaTeX.pm,
	tp/Texinfo/Convert/NodeNameNormalization.pm,
	tp/Texinfo/Convert/Plaintext.pm,tp/Texinfo/Convert/Text.pm,
	tp/Texinfo/XS/parsetexi/command_data.txt: set letter_no_arg flag
	in command_data.txt and remove %letter_no_arg_commands from
	Common.pm.

2022-10-02  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Common.pm, tp/Texinfo/Convert/DocBook.pm,
	tp/Texinfo/Convert/HTML.pm, tp/Texinfo/Convert/TexinfoMarkup.pm,
	tp/Texinfo/ParserNonXS.pm: remove %context_brace_commands, instead
	check if brace_commands type is set to context.

2022-10-02  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Common.pm, tp/Texinfo/ParserNonXS.pm,
	tp/maintain/regenerate_commands_perl_info.pl: generate
	%commands_args_number in regenerate_commands_perl_info.pl, remove
	from Texinfo::Common.

2022-10-02  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Common.pm, tp/Texinfo/Convert/*.pm,
	tp/Texinfo/Structuring.pm, tp/Texinfo/Transformations.pm,
	tp/Texinfo/XS/parsetexi/command_data.txt,
	tp/Texinfo/XS/parsetexi/commands.h, tp/init/book.pm,
	tp/init/highlight_syntax.pm: use information from Texinfo::Commands,
	remove the corresponding hashes from Texinfo::Common.  Move comments
	from Common.pm to command_data.txt and commands.h.

2022-10-02  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Common.pm, tp/Texinfo/Convert/Utils.pm
	(definition_category_tree), tp/Texinfo/ParserNonXS.pm
	(_process_remaining_on_line),
	tp/maintain/regenerate_commands_perl_info.pl: define %command_index
	in ParserNonXS.pm, not in Common.pm.  Update
	definition_category_tree() to use directly the command names.
	Remove %deprecated_commands from Common.pm, do not use values
	of %deprecated_commands, only the keys.  Generate %index_names
	in regenerate_commands_perl_info.pl and output code that adds
	default index commands to %line_commands.

	* util/txixml2texi.pl, tp/Texinfo/ParserNonXS.pm: use information
	from Texinfo::Commands.

2022-10-02  Patrice Dumas  <pertusus@free.fr>

	* tp/Makefile.am, maintain/regenerate_commands_perl_info.pl:
	hardcode output file name in regenerate_commands_perl_info.pl, to
	avoid emptying the result file because of the redirection if the
	command failed completely.

2022-10-02  Patrice Dumas  <pertusus@free.fr>

	* NEWS, tp/Texinfo/ParserNonXS.pm,
	tp/Texinfo/XS/parsetexi/command_data.txt,
	tp/Texinfo/XS/parsetexi/commands.h, tp/Texinfo/XS/parsetexi/parser.c
	(check_valid_nesting): add contain_simple_text flag.  Set @w to be
	contain_simple_text, plain text is too restrictive, there are many
	uses of indicatric commands in @w in the Texinfo manual.

2022-10-02  Patrice Dumas  <pertusus@free.fr>

	* maintain/regenerate_commands_perl_info.pl, Makefile.am: rename
	maintain/regenerate_perl_command_infos.pl as
	maintain/regenerate_commands_perl_info.pl.  Distribute the script.
	Remove _LINE in item_LINE.

2022-10-01  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/Texinfo/Convert/LaTeX.pm (index_entry): Strip | from
	sort key as otherwise there can be manged output in the .idx
	file with a "hyperindexformat" string that appears to be added
	by the hyperref package.
	* tp/t/latex_tests.t (vbar_in_index): New test.

2022-10-02  Patrice Dumas  <pertusus@free.fr>

	Generate automatically perl commands information hashes

	* maintain/regenerate_perl_command_infos.pl, Makefile.am: generate
	automatically Texinfo/Commands.pm using the information from
	tp/Texinfo/XS/parsetexi/command_data.txt.

2022-10-02  Patrice Dumas  <pertusus@free.fr>

	Warn if @-commands other than accent, glyphs and symbols appear in @w

	* tp/Texinfo/Common.pm (%contain_plain_text_commands),
	tp/Texinfo/XS/parsetexi/command_data.txt, NEWS: add w to contain_plain_text.

	* tp/Texinfo/Common.pm (%variadic_commands),
	tp/Texinfo/ParserNonXS.pm: use the %variadic_commands hash for
	variadic commands instead of setting %commands_args_number to
	variadic.

2022-10-02  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Common.pm (%contain_plain_text_commands),
	tp/Texinfo/ParserNonXS.pm (%plain_text_commands),
	tp/Texinfo/XS/parsetexi/command_data.txt,
	tp/Texinfo/XS/parsetexi/commands.h, tp/Texinfo/XS/parsetexi/parser.c
	(check_valid_nesting): add a contain_plain_text flag/hash to warn
	if 'dmn', 'key', 'hyphenation', 'sortas' contain anything else
	than accent and glyph commands (similar as accent commands).

2022-10-02  Patrice Dumas  <pertusus@free.fr>

	 * tp/Texinfo/XS/parsetexi/command_data.txt,
	 tp/Texinfo/XS/parsetexi/commands.h: add BLOCK_preformatted and
	 BLOCK_math for consistency with perl parser.

2022-10-01  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/Texinfo/Convert/LaTeX.pm (_convert) <@\>: Output as \backslash{}
	in math context.

2022-10-02  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Common.pm (%def_alias_commands),
	tp/Texinfo/ParserNonXS.pm (_parse_def): add %def_alias_commands
	and use for consistency with XS parser.

	* tp/Texinfo/Common.pm, tp/Texinfo/Convert/HTML.pm
	(%HTML_align_commands), tp/Texinfo/ParserNonXS.pm: remove
	%region_commands and %align_commands.  Set %HTML_align_commands in
	HTML.pm as the set of align commands choosen is not generic.

	* tp/Texinfo/Common.pm (%block_commands): set align and other
	block commands to type 'other'.

	* tp/Texinfo/XS/parsetexi/command_data.txt,
	tp/Texinfo/XS/parsetexi/commands.h: add BLOCK_def for consistency
	with perl parser.

	* tp/Texinfo/ParserNonXS.pm (_pop_block_command_contexts)
	(_close_brace_command, _close_all_style_commands, _end_paragraph)
	(_end_preformatted, _close_current, _close_commands),
	tp/Texinfo/XS/parsetexi/close.c (pop_block_command_contexts)
	(close_brace_command, close_all_style_commands, close_current)
	(close_commands), tp/Texinfo/XS/parsetexi/parser.c (end_paragraph)
	(end_preformatted): add pop_block_command_contexts to pop block
	commands context when closing block commands.  Change variable names
	to closed_block_command to show that the argument can only be a block
	command.

2022-10-02  Patrice Dumas  <pertusus@free.fr>

	Warn if @| appears out of a heading specification

	* tp/Texinfo/Common.pm (%in_heading_spec_commands),
	tp/Texinfo/Convert/LaTeX.pm (_convert)
	%LaTeX_in_heading_commands_formatting),
	tp/Texinfo/XS/parsetexi/command_data.txt,
	tp/Texinfo/XS/parsetexi/commands.h,
	tp/Texinfo/XS/parsetexi/handle_commands.c (handle_other_command),
	tp/Texinfo/XS/parsetexi/parser.c (check_valid_nesting): rename
	in_heading as in_heading_spec in XS parser to match perl.  Set @| to
	be in in_heading_spec.  In LaTeX.pm, rename
	%LaTeX_in_heading_spec_commands as
	%LaTeX_in_heading_commands_formatting and use that source of
	information to select the corresponding commands to format.

2022-10-01  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/TexinfoMarkup.pm (_convert): collect trailing
	spaces in @def* bracketed content.

	* util/txixml2texi.pl: output leading spaces for bracketed container
	and trailing spaces at the right place for the different types of
	commands.

2022-10-01  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/TexinfoMarkup.pm (_convert): on block command
	lines, output empty elements for all the variadic elements, including
	the last non variadic element, which has the same name as the variadic
	element, to have a correct count on elements, as the element name
	appearing last cannot be used to add commas for empty elements.
	Keep the last non-variadic empty argument to be able to prepend it to
	be able to reconstitute trailing empty arguments in the original
	Texinfo code.

2022-10-01  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/Texinfo/Convert/LaTeX.pm (_latex_header):
	Redefine \_ so to allow line breaking at underscore.  Update TODO
	agendum.

2022-10-01  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Contents): State that @shortcontents
	is not implemented for LaTeX output.  From Patrice.

2022-10-01  Gavin Smith  <gavinsmith0123@gmail.com>

	Do not warn for @shortcontents in LaTeX

	* tp/Texinfo/Convert/LaTeX.pm (convert) <@shortcontents>:
	Do not issue a warning for @shortcontents or @summarycontents.
	From Patrice.

2022-10-01  Gavin Smith  <gavinsmith0123@gmail.com>

	LaTeX disable hyphenation on def line

	* tp/Texinfo/Convert/LaTeX.on (_convert) <def line>:
	Set \hyphenpenalty to 10000.

2022-10-01  Patrice Dumas  <pertusus@free.fr>

	Do not add empty isolated trailing spaces

	* tp/Texinfo/ParserNonXS.pm (_isolate_trailing_space)
	(_isolate_last_space, _process_remaining_on_line),
	tp/Texinfo/XS/parsetexi/parser.c (isolate_trailing_space):
	only add element when isolating trailing spaces if there
	are indeed spaces to isolate.  Modify perl parser code to
	be more like XS parser code.

2022-10-01  Gavin Smith  <gavinsmith0123@gmail.com>

	Warn for @shortcontents in LaTeX

	* tp/Texinfo/Convert/LaTeX.pm (convert) <@shortcontents>:
	Issue a warning if @shortcontents or @summarycontents
	is used.  Add a comment in TODO section saying that we may
	not have to implement it.

2022-10-01  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/Texinfo/XS/parsetexi/api.c: Initialize a variable that
	we check is non-null.

2022-10-01  Patrice Dumas  <pertusus@free.fr>

	* util/txixml2texi.pl: handle variadic commands.  Disambiguate markup
	argument elements with command name as the a markup argument element
	can be associated to more than one @-command.

2022-10-01  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/Plaintext.pm (process_printindex): use scalar()
	on hash keys, not on hash to detect if empty.

2022-10-01  Gavin Smith  <gavinsmith0123@gmail.com>

	* README-hacking: note that gettextize can downgrade files

2022-10-01  Gavin Smith  <gavinsmith0123@gmail.com>

	* README-hacking: more advice on gnulib-tool --add-import

2022-10-01  Gavin Smith  <gavinsmith0123@gmail.com>

	Update gnulib.

	* (top-level), tp/Texinfo/XS: Run gnulib-tool --add-import.

2022-10-01  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.tex (\image): Add more space around @center @image.

2022-10-01  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/TexinfoMarkup.pm (_convert): keep the last empty
	argument of a brace command to be able to reconstitute trailing empty
	arguments in the original Texinfo code.

2022-10-01  Patrice Dumas  <pertusus@free.fr>

	* util/texinfo.dtd: update for change in spaces attributes.

2022-10-01  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/TexinfoMarkup.pm (_convert): set leading spaces
	for columnfraction.

2022-10-01  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/TexinfoMarkup.pm (_convert): collect index
	entry end line spaces, which is important to get space before
	@subentry.

2022-10-01  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/Texinfo/Convert/LaTeX.pm (_latex_header): Load microtype package
	only if "@microtype" command was used in document.

2022-10-01  Gavin Smith  <gavinsmith0123@gmail.com>

	@center @image spacing

	* doc/texinfo.tex (\image): Separate out the code for
	@center @image more.  Attempt to fix spacing before @center
	@image.  Report from Werner.

2022-10-01  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/TexinfoMarkup.pm (_convert), util/texinfo.dtd,
	util/txixml2texi.pl: if the default command as argument for itemize
	is inserted, put it in a formattingcommand, with an automatic
	attribute set to on.  Use that information in txixml2texi.

	* util/txixml2texi.pl: handle rmacro.

2022-10-01  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/TexinfoMarkup.pm (_convert): add spaces attribute
	for 'specific' line commands.

2022-10-01  Patrice Dumas  <pertusus@free.fr>

	* util/txixml2texi.pl: output spaces explicitly.  Output user-defined
	index entry command name.

2022-10-01  Patrice Dumas  <pertusus@free.fr>

	* util/txixml2texi.pl: separate accent formatting.  Always output the
	braces and the spaces right after command if they are specified for
	an accent.

2022-10-01  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Common.pm (%formatted_line_commands)
	(%formatted_nobrace_commands, %formattable_line_commands)
	(_informative_command_value), tp/Texinfo/Convert/HTML.pm,
	tp/Texinfo/Convert/IXIN.pm, tp/Texinfo/Convert/LaTeX.pm,
	tp/Texinfo/Convert/Plaintext.pm, tp/Texinfo/Convert/TexinfoMarkup.pm
	(_convert), tp/Texinfo/Convert/Text.pm,
	tp/Texinfo/Convert/TextContent.pm, util/txixml2texi.pl: remove
	%other_commands and %misc_commands.  Split %formatted_misc_commands as
	%formatted_line_commands and %formatted_nobrace_commands. Rename
	%formattable_misc_commands as %formattable_line_commands.  Rename
	similarly other variables in converters.

	* util/txixml2texi.pl: update %no_arg_commands_formatting handling
	for changes in markup attributes.

2022-09-30  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/DocBook.pm (_convert): format separately
	nobrace and line commands.  Do not use the type of line command to
	format line commands.

2022-09-30  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Common.pm (%nobrace_symbol_text, %nobrace_commands),
	tp/Texinfo/ParserNonXS.pm (_process_remaining_on_line),
	tp/Texinfo/Convert/Converter.pm, tp/Texinfo/Convert/DocBook.pm,
	tp/Texinfo/Convert/HTML.pm, tp/Texinfo/Convert/LaTeX.pm,
	tp/Texinfo/Convert/NodeNameNormalization.pm,
	tp/Texinfo/Convert/Plaintext.pm, tp/Texinfo/Convert/TexinfoMarkup.pm,
	tp/Texinfo/Convert/Text.pm, tp/Texinfo/Convert/TextContent.pm: rename
	former %nobrace_commands as %nobrace_symbol_text.  Set
	%nobrace_commands according to
	tp/Texinfo/XS/parsetexi/command_data.txt.  Handle all the
	%nobrace_commands together.

2022-09-30  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/XS/parsetexi/command_data.txt,
	tp/Texinfo/XS/parsetexi/handle_commands.c (handle_other_command),
	tp/Texinfo/XS/parsetexi/parser.c (check_valid_nesting)
	(process_remaining_on_line): merge commands with CF_other flag with
	commands with CF_nobrace flag.  Add NOBRACE_symbol type for symbols
	without brace.  Rename OTHER_skipspace as NOBRACE_skipspace.  Rename
	OTHER_noarg as NOBRACE_other.  Handle all the CF_nobrace commands in
	handle_other_command, which means moving the handling of
	NOBRACE_symbol commands from process_remaining_on_line to
	handle_other_command.

	* tp/Texinfo/XS/parsetexi/close.c (close_commands),
	tp/Texinfo/XS/parsetexi/context_stack.c
	(in_preformatted_context_not_menu), tp/Texinfo/XS/parsetexi/parser.c
	(check_valid_nesting, parse_texi): check CF_* in addition to .data in
	some places to be sure that the value is for the right type of
	command.

2022-09-30  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Common.pm, tp/Texinfo/Convert/DocBook.pm,
	tp/Texinfo/Convert/HTML.pm, tp/Texinfo/Convert/LaTeX.pm,
	tp/Texinfo/Convert/Plaintext.pm, tp/Texinfo/Convert/TexinfoMarkup.pm,
	tp/Texinfo/Convert/Text.pm, tp/Texinfo/ParserNonXS.pm
	(_process_remaining_on_line),
	tp/Texinfo/XS/parsetexi/command_data.txt,
	tp/Texinfo/XS/parsetexi/commands.h, tp/Texinfo/XS/parsetexi/parser.c
	(check_valid_nesting), tp/Texinfo/XS/parsetexi/separator.c
	(handle_open_brace, handle_close_brace, handle_comma): replace
	%inline_commands/CF_inline with the brace command inline type/BRACE_inline.

2022-09-30  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Common.pm (%in_heading_spec_commands),
	tp/Texinfo/Convert/LaTeX.pm, tp/Texinfo/ParserNonXS.pm: rename
	%in_heading_commands as %in_heading_spec_commands.

	* tp/Texinfo/Convert/HTML.pm (converter_initialize): value is now
	in brace commands.

	* tp/Texinfo/ParserNonXS.pm: rename %in_*commands hashes and
	associated commands hashes.

2022-09-29  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Common.pm, tp/Texinfo/XS/parsetexi/command_data.txt,
	tp/Texinfo/XS/parsetexi/commands.h: use BRACE_special for
	special commands with braces, instead of BRACE_other with is
	now used for brance commands in which leading and trailing spaces
	are kept, and used for @dmn and @titlefont.  Set @indicateurl and @key
	as BRACE_style_code commands.

2022-09-29  Gavin Smith  <gavinsmith0123@gmail.com>

	* README-hacking, tp/Texinfo/XS/parsetexi/README:
	valgrind --leak-check for parsetexi.

2022-09-29  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/HTML.pm (_convert_printindex_command):
	pop document context when there is no output.

2022-09-29  Patrice Dumas  <pertusus@free.fr>

	Gather @seealso and @seeentry index entries with other entries

	* tp/Texinfo/ParserNonXS.pm (_enter_index_entry),
	tp/Texinfo/XS/parsetexi/api.c (build_single_index_data),
	tp/Texinfo/Convert/HTML.pm (_convert_printindex_command)
	(_prepare_index_entries, output_internal_links),
	tp/Texinfo/Convert/Plaintext.pm (process_printindex),
	tp/init/chm.pm: keep index entries with @seealso or @seeentry
	with other index entries in 'index_names' index 'index_entries'.
	Ignore these index entries, if needed, in converters.

	* tp/Texinfo/Convert/Plaintext.pm (process_printindex): do not
	output the index header if all the index entries are ignored.

2022-09-29  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/ParserNonXS.pm (_enter_index_entry),
	tp/Texinfo/XS/parsetexi/api.c (build_single_index_data),
	tp/Texinfo/Convert/*.pm, tp/Texinfo/Common.pm,
	tp/Texinfo/Structuring.pm, tp/Texinfo/Transformations.pm,
	tp/Texinfo/Translations.pm, tp/init/chm.pm: change index structure key
	names to have more specific names.

2022-09-29  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/ParserNonXS.pm (_enter_index_entry): initialize 'index_entries'
	to an empty array for the index even if the entry being processed has
	seeentry or seealso and won't be pushed on the 'index_entries' array.

2022-09-28  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Transformations.pm (_protect_hashchar_at_line_beginning)
	(protect_hashchar_at_line_beginning): use a hash to mark elements that
	should be protected instead of modifying the tree by putting an
	temporary internal key in 'extra'.

	* tp/Texinfo/Transformations.pm (_print_down_menus): avoid unneeded
	autovivification.

2022-09-28   Charles Reilly  <git.2022@charlesreilly.com>  (tiny change)

	* info/indices (index_offset, info_index_search)
	(info_next_index_match, create_virtual_index): Initialize
	index_offset to -1 rather than 0 to avoid missing the first
	index entry.

2022-09-28  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Structuring.pm: avoid unneeded autovivification.

2022-09-28  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Config.pm: initialize hashes and determine valid keys by
	looking directly at the initialized hashes.

	* tp/Texinfo/Config.pm (texinfo_get_conf): abort if
	GNUT_initialize_config() has not been called before texinfo_get_conf()
	is called.

	* tp/t/test_utils.pl (test): call Texinfo::Config::GNUT_initialize_config
	before calling Texinfo::Config files.

2022-09-28  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Common.pm (output_files_initialize),
	tp/Texinfo/Convert/Converter.pm (converter),
	tp/Texinfo/Convert/Text.pm (output), tp/texi2any.pl: add
	output_files_initialize() to initialize the structures of the output
	files API.

	* tp/Texinfo/Common.pm (parse_node_manual, set_global_document_command)
	(set_output_encodings, modify_tree): avoid erroneous autovivification,
	initialize more cleanly.

2022-09-28  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Transformations.pm (set_menus_node_directions): handle
	simple menus.

	* tp/t/test_utils.pl: rename $result as $tree.  Order the different
	steps to match what is done in the main program.  Add tree
	transformations to tests.

2022-09-27  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Transformations.pm (menu_to_simple_menu): avoid a
	undefined value message.

2022-09-27  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/ParserNonXS.pm: check that autovivification does not
	create unexpected structures, and hides missing initializations.

2022-09-27  Patrice Dumas  <pertusus@free.fr>

	* Pod-Simple-Texinfo/lib/Pod/Simple/Texinfo.p (_convert_pod): fix
	Texinfo::Common::code_style_commands to be the modified
	Texinfo::Common::brace_code_commands.

2022-09-27  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Common.pm (%brace_commands, %internal_commands),
	tp/Texinfo/XS/parsetexi/command_data.txt,
	tp/Texinfo/XS/parsetexi/commands.h: put value in brace commands.
	Put internal commands (currently only txiinternalvalue) in
	specific hash, and use specific flag/data.

	* tp/Texinfo/XS/parsetexi/commands.c (item_line_command):
	use BLOCK_item_line.

2022-09-27  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Common.pm (%commands_args_number): merge
	%brace_commands_args_number and %block_commands_args_number in
	%commands_args_number, and add the number of arguments of node too,
	matching the XS parser.

	* tp/Texinfo/ParserNonXS.pm (_process_remaining_on_line),
	tp/Texinfo/XS/parsetexi/handle_commands.c (handle_line_command):
	Use the number of arguments of node more like other commands
	both in the perl and the XS parser.

2022-09-27  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Common.pm (%heading_spec_commands),
	tp/Texinfo/ParserNonXS.pm, tp/Texinfo/XS/parsetexi/command_data.txt,
	tp/Texinfo/XS/parsetexi/commands.h,
	tp/Texinfo/XS/parsetexi/handle_commands.c (handle_other_command),
	tp/Texinfo/XS/parsetexi/parser.c (check_valid_nesting): rename
	%headings_specification_commands as %heading_spec_commands to match XS
	Parser.  Replace LINE_heading_spec data in XS parser to heading_spec
	flag, and and add math flag, to match with perl Parser.

2022-09-26  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Common.pm, tp/Texinfo/Convert/DocBook.pm
	(converter_initialize, _convert), tp/Texinfo/Convert/HTML.pm,
	tp/Texinfo/Convert/LaTeX.pm, tp/Texinfo/Convert/Plaintext.pm
	(_convert), tp/Texinfo/Convert/TexinfoMarkup.pm,
	tp/Texinfo/ParserNonXS.pm (_close_current, _end_line)
	(_process_remaining_on_line, _parse_texi),
	tp/Texinfo/XS/parsetexi/close.c (close_current, close_commands),
	tp/Texinfo/XS/parsetexi/command_data.txt,
	tp/Texinfo/XS/parsetexi/commands.c (close_paragraph_command),
	tp/Texinfo/XS/parsetexi/commands.h, tp/Texinfo/XS/parsetexi/end_line.c
	(end_line_starting_block), tp/Texinfo/XS/parsetexi/handle_commands.c
	(handle_block_command), tp/Texinfo/XS/parsetexi/parser.c
	(check_valid_nesting, process_remaining_on_line):
	remove %raw_commands and %format_raw_commands, use %block_commands
	values instead, adding 'format_raw'.  In XS Parser, set and use
	BLOCK_format_raw instead of the flag CF_format_raw.  In some
	converters, set %format_raw_commands locally.

2022-09-26  Werner Lemberg  <wl@gnu.org>

	* doc/texinfo.tex: Add character protrusion support for XeTeX.

	(top-level, \microtypeON, \microtypeOFF): Do it.

2022-09-26  Werner Lemberg  <wl@gnu.org>

	* doc/texinfo.tex: Fix character protrusion in `@microtype`.

	First of all, character protrusion wasn't activated at all. 
	Additionally, the code from the original `protcode.tex` was added
	incompletely, causing far too large protrusion values.

	* doc/texinfo.tex (\countB): New counter.
	(\mtadjustprotcode, \mtadjustcp): New macros.
	(\mtsetprotcode): Call `\mtadjustprotcode` to scale protrusion
	values correctly.
	(\microtypeON, \microtypeOFF): Switch on or off character
	protrusion.

2022-09-26  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Common.pm (%nobrace_commands),
	tp/Texinfo/Convert/Converter.pm, tp/Texinfo/Convert/HTML.pm,
	tp/Texinfo/Convert/LaTeX.pm, tp/Texinfo/Convert/Plaintext.pm,
	tp/Texinfo/Convert/NodeNameNormalization.pm,
	tp/Texinfo/Convert/Text.pm, tp/Texinfo/Convert/TextContent.pm,
	tp/Texinfo/ParserNonXS.pm: rename %no_brace_commands as
	%nobrace_commands to be more in line with XS parser.

	* tp/Texinfo/Common.pm, tp/Texinfo/Convert/DocBook.pm
	(@all_style_commands, _convert), tp/Texinfo/Convert/HTML.pm
	(@all_style_commands, _convert), tp/Texinfo/Convert/Plaintext.pm
	(_convert), tp/Texinfo/Convert/TexinfoMarkup.pm (_convert): remove
	%style_commands and %regular_font_style_commands, use %brace_commands
	values instead.

	* tp/Texinfo/Common.pm (%brace_code_commands),
	tp/Texinfo/Convert/Converter.pm, tp/Texinfo/Convert/HTML.pm,
	tp/Texinfo/Convert/LaTeX.pm, tp/Texinfo/Convert/Plaintext.pm,
	tp/Texinfo/Convert/Text.pm: rename %code_style_commands as
	%brace_code_commands.

	* tp/Texinfo/Convert/NodeNameNormalization.pm: change in spacing.

2022-09-26  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Common.pm (%blockitem_commands),
	tp/Texinfo/Convert/TextContent.pm, tp/Texinfo/ParserNonXS.pm: rename
	%block_item_commands as %blockitem_commands to be more consistent with
	XS parser.

	* tp/Texinfo/XS/parsetexi/command_data.txt,
	tp/Texinfo/XS/parsetexi/commands.c (close_paragraph_command),
	tp/Texinfo/XS/parsetexi/commands.h,
	tp/Texinfo/XS/parsetexi/handle_commands.c (handle_line_command),
	tp/Texinfo/XS/parsetexi/parser.c (check_valid_nesting): rename
	CF_sectioning as CF_sectioning_heading to be more consistent with Perl
	parser.

	* tp/Texinfo/Common.pm, tp/Texinfo/Convert/DocBook.pm,
	tp/Texinfo/Convert/LaTeX.pm (_convert),
	tp/Texinfo/Convert/Plaintext.pm (_convert), tp/Texinfo/ParserNonXS.pm
	(_close_command_cleanup, _item_container_parent, _item_line_parent)
	(_end_line, _parent_of_command_as_argument,
	_process_remaining_on_line), tp/Texinfo/XS/parsetexi/command_data.txt,
	tp/Texinfo/XS/parsetexi/commands.h, util/txixml2texi.pl: use item_line
	and item_container as types for block commands, instead of
	%item_container_command and %item_line_commands. Remove
	%item_container_command and %item_line_commands.

	* tp/Texinfo/Convert/HTML.pm: remove useless code.

2022-09-26  Patrice Dumas  <pertusus@free.fr>

	Document Microtypography in LaTeX output

	* doc/texinfo.texi (Microtypography): document that cm-super
	fonts package is needed for microtypography and that there will
	be errors with the default fonts.

2022-09-26  Patrice Dumas  <pertusus@free.fr>

	Microtype in LaTeX

	* tp/Texinfo/Convert/LaTeX.pm (%LaTeX_fixed_width_environments)
	(_latex_header, _convert): implement microytpe in LaTeX output.

2022-09-26  Patrice Dumas  <pertusus@free.fr>

	* TODO: user-defined macros as argument to @table and @itemize

	* doc/texinfo.texi (Defining Macros): say that Texinfo commands
	should not be redefined as macro earlier, and make it part of the
	design of user defined macros.

2022-09-25  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Common.pm, tp/Texinfo/Convert/DocBook.pm (_convert),
	tp/Texinfo/Convert/HTML.pm (in_preformatted),
	tp/Texinfo/Convert/LaTeX.pm, tp/Texinfo/Convert/Plaintext.pm,
	tp/Texinfo/ParserNonXS.pm, tp/Texinfo/Transformations.pm
	(menu_to_simple_menu): use $block_commands{$command} eq 'menu'
	instead of %menu_commands. Remove %menu_commands.

	* tp/Texinfo/XS/parsetexi/close.c (close_current, close_commands),
	tp/Texinfo/XS/parsetexi/command_data.txt,
	tp/Texinfo/XS/parsetexi/commands.h,
	tp/Texinfo/XS/parsetexi/context_stack.c
	(in_preformatted_context_not_menu), tp/Texinfo/XS/parsetexi/end_line.c
	(end_line_starting_block, end_line_misc_line),
	tp/Texinfo/XS/parsetexi/handle_commands.c (handle_block_command):
	use new BLOCK_menu command data instad of CF_menu flag.

	* tp/texi2any.pl: show the name of the module failing to load if the
	converter module require failed.

2022-09-25  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Common.pm (%block_commands, %block_commands_args_number),
	tp/Texinfo/ParserNonXS.pm (_process_remaining_on_line),
	tp/Texinfo/XS/parsetexi/command_data.txt,
	tp/Texinfo/XS/parsetexi/commands.h,
	tp/Texinfo/XS/parsetexi/handle_commands.c (handle_block_command):
	separate type of block command from number of arguments for
	perl too.  Set variadic to be a flag in the XS parser.

2022-09-25  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Microtypography), NEWS: Document @microtype.

2022-09-25  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Common.pm (%brace_commands, %brace_commands_args_number),
	tp/Texinfo/Convert/LaTeX.pm, tp/Texinfo/Convert/Plaintext.pm,
	tp/Texinfo/ParserNonXS.pm (_end_line, _process_remaining_on_line),
	tp/Texinfo/XS/parsetexi/command_data.txt,
	tp/Texinfo/XS/parsetexi/commands.h,
	tp/Texinfo/XS/parsetexi/handle_commands.c (handle_open_brace)
	(handle_close_brace):
	separate number of brace arguments in %brace_commands_args_number and
	%brace_commands types in perl too.  Use 'arguments'/BRACE_arguments
	for the brace commands types that were selected by a positive number
	of arguments previously.  Use noarg/BRACE_noarg.

2022-09-25  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Common.pm (%line_commands), tp/Texinfo/Convert/DocBook.pm
	(_convert), tp/Texinfo/Convert/TexinfoMarkup.pm (_convert),
	tp/Texinfo/ParserNonXS.pm (_end_line),
	tp/Texinfo/XS/parsetexi/command_data.txt,
	tp/Texinfo/XS/parsetexi/end_line.c (end_line_misc_line),
	tp/Texinfo/XS/parsetexi/parser.c (check_valid_nesting): use
	a new type for command line, 'specific' for line @-commands with
	specific args, such as @printindex, @alias... that had previously
	a positive number as type.

	* tp/Texinfo/XS/parsetexi/handle_commands.c (handle_block_command):
	use args_number.
	
	* tp/Texinfo/XS/parsetexi/end_line.c (end_line_starting_block),
	tp/Texinfo/XS/parsetexi/parser.c (check_valid_nesting):
	use BRACE_noarg instead of 0.

	* tp/Texinfo/XS/parsetexi/commands.c (add_texinfo_command),
	tp/Texinfo/XS/parsetexi/end_line.c (parse_line_command_args): set
	args_number for user defined commands.

2022-09-25  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/XS/parsetexi/command_data.awk,
	tp/Texinfo/XS/parsetexi/command_data.txt,
	tp/Texinfo/XS/parsetexi/commands.h (command_struct): separate the
	information on the number of arguments from the information on
	the type of command.

2022-09-25  Patrice Dumas  <pertusus@free.fr>

	microtype in texi2any parsers

	* tp/Texinfo/Common.pm (%document_settable_multiple_at_commands)
	(%line_commands), tp/Texinfo/ParserNonXS.pm
	(_parse_line_command_args), tp/Texinfo/XS/parsetexi/command_data.txt,
	tp/Texinfo/XS/parsetexi/end_line.c (parse_line_command_args),
	tp/Texinfo/XS/parsetexi/parser.c (register_global_command)
	(wipe_global_info), tp/Texinfo/XS/parsetexi/parser.h (GLOBAL_INFO):
	add @microtype to texi2any parsers.

2022-09-25  Patrice Dumas  <pertusus@free.fr>

	* TODO: mention the Emacs Info viewer bug on node name quoting.

	* doc/texinfo.texi (Macro Details): texi2any expands macros in
	@end lines except when macros are not expanded in the block command.

	* tp/Texinfo/ParserNonXS.pm: change in spacing.

2022-09-25  Gavin Smith  <gavinsmith0123@gmail.com>

	Faster font switching

	* doc/texinfo.tex (\assignfonts, \defineassignfonts):
	\defineassignfonts creates control sequences which are used
	to switch to particular font sizes.  This avoids using \csname
	to define all font styles each time the font size changes.

2022-09-25  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.tex (\frenchspacing): Only change \sfcode if
	setting is changing, by using a conditional.

2022-09-25  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Menu Example): Change menu marker from
	"* menu:" to "* Menu:" in example.

2022-09-25  Karl Berry  <karl@freefriends.org>, and
            Gavin Smith  <gavinsmith0123@gmail.com>

	microtype

	* doc/texinfo.tex (@microtype) [pdfTeX, LuaTeX]: For "@microtype on",
	use microtypographical features.  Set it on by default.

2022-09-25  Sam James  <sam@gentoo.org>  (tiny change)

	* install-info/install-info.c
	(strip_info_suffix, open_possibly_compressed_file):
	Recognize .zst file extension from the zstd compression tool.

	* info/filesys.c (compress_suffixes): Ditto.

2022-09-24  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.tex (\ifmonotype): Replace with \ifusingtt which
	is nearly identical.
	(\ifusingtt, \ifusingit): Move earlier in file.

2022-09-24  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Less Cluttered Menu Entry, Other Info Files):
	@set txicodevaristt to preserve vertical alignment.

2022-09-24  Gavin Smith  <gavinsmith0123@gmail.com>

	* info/dir.c (dir_entry_of_infodir): Always allocate enough
	memory in argument to info_check_compressed.  Crash with
	hardened_malloc for "info -a arg" reported by Tommy Nguyen.

2022-09-24  Gavin Smith  <gavinsmith0123@gmail.com>

	* README-hacking: git branch structure for after next release

2022-09-21  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.tex (\image): Begin \vtop with negative kern by
	approximate height of a line for better vertical positioning.
	Report for @image at top of page by Werner.

2022-09-20  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/ParserNonXS.pm (_end_line),
	tp/Texinfo/XS/parsetexi/end_line.c (end_line_misc_line): use
	the same error message for superfluous argument to @end command
	after the command argument as for other cases of superfluous
	argument triggered by unexpected @-commands on @end ond other
	similar commands line.

2022-09-20  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/ParserNonXS.pm (_end_line),
	tp/Texinfo/XS/parsetexi/end_line.c (end_line_misc_line): avoid
	a double error message when there are both superfluous arg and
	a bad @end argument.

2022-09-19  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/ParserNonXS.pm (_end_line): same error messages
	as the XS parser for @-commands in @end.  Change a variable name.

2022-09-18  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Transformations.pm (complete_node_menu): handle empty
	nodes.

	* tp/Texinfo/Structuring.pm (new_node_menu_entry): call confess if
	there are undef contents in node contents.

	* tp/Texinfo/ParserNonXS.pm (_parse_node_manual): remove useless
	condition.

2022-09-18  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Common.pm (parse_node_manual): return directly undef
	if there is no contents.  Code stylistic and variable names changes.

2022-09-18  Patrice Dumas  <pertusus@free.fr>

	* Pod-Simple-Texinfo/pod2texi.pl (_parsed_manual_tree): update/fix
	the code adding the manual name to added nodes with
	fill_gaps_in_sectioning, and simplify.

2022-09-18  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Transformations.pm (_new_node): build a tree
	for a node in line with the current nodes Texinfo tree.

2022-09-18  Patrice Dumas  <pertusus@free.fr>

	* Pod-Simple-Texinfo/lib/Pod/Simple/Texinfo.pm
	(_normalize_texinfo_name): 'contents' can now be undef in anchor
	argument.

2022-09-18  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/XS/misc.c (xs_abort_empty_line): remove the contents key
	if contents are empty.

2022-09-18  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/ParserNonXS.pm (_register_command_as_argument)
	(_parent_of_command_as_argument, _process_remaining_on_line),
	tp/Texinfo/XS/parsetexi/parser.c (parent_of_command_as_argument)
	(register_command_as_argument, process_remaining_on_line),
	tp/Texinfo/XS/parsetexi/separator.c (handle_close_brace):
	use a function to register a command_as_argument.  Rename
	command_with_command_as_argument as parent_of_command_as_argument.

	* tp/Texinfo/ParserNonXS.pm (_end_line): remove useless code and
	keys.

2022-09-18  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Hardcopy with TeX, Generic Translator texi2any):
	Shorten chapter titles so they fit in table of contents better.

2022-09-18  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/info-stnd.texi (Node Commands): Correct @pxref to @ref.

2022-09-18  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.tex [e-TeX]: Do not set \lastlinefit.  Karl
	reported that this led to many underful hbox warnings.

2022-09-17  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/ParserNonXS.pm (_pop_element_from_contents): use
	that function to remove the last element from contents and
	remove the contents key if contents are empty.

	* tp/Texinfo/ParserNonXS.pm (_parse_macro_command_line)
	(_gather_previous_item): do not add empty contents.

	* tp/Texinfo/ParserNonXS.pm (_begin_paragraph)
	(_parse_line_command_args): use the presence of 'contents' to
	mean a non-empty contents.

2022-09-17  Patrice Dumas  <pertusus@free.fr>

	Remove contents tree element keys if empty

	* tp/Texinfo/ParserNonXS.pm (parse_texi_line, _begin_paragraph)
	(_close_command_cleanup, _close_current, _abort_empty_line)
	(_isolate_last_space, _parse_node_manual, _parse_float_type)
	(_split_def_args, _parse_def, _convert_to_text, _end_line)
	(_register_extra_menu_entry_information, _enter_menu_entry_node)
	(_setup_document_root_and_before_node_section)
	(_process_remaining_on_line, _parse_line_command_args):
	do not add an explicit empty contents array reference.  If
	a contents is emptied, or an empty non-closed command or type appears
	at the end of the document, remove the key.  

	* p/Texinfo/XS/parsetexi/api.c (element_to_perl_hash): do not
	set 'contents' if empty.

	* tp/Texinfo/Common.pm (_add_preamble_before_content)
	(parse_node_manual), tp/Texinfo/Convert/DocBook.pm (_convert),
	tp/Texinfo/Convert/HTML.pm (command_text, _convert_row_type)
	(_convert), tp/Texinfo/Convert/Info.pm (format_image),
	tp/Texinfo/Convert/LaTeX.pm (_convert),
	tp/Texinfo/Convert/Plaintext.pm (image_formatted_text)
	(format_image, _convert), tp/Texinfo/Convert/Texinfo.pm
	(root_heading_command_to_texinfo),
	tp/Texinfo/Convert/TexinfoMarkup.pm (_convert),
	tp/Texinfo/Convert/Utils.pm (definition_arguments_content)
	(find_innermost_accent_contents), tp/Texinfo/Transformations.pm:
	handle non defined 'contents'.

	* tp/Texinfo/Common.pm (rearrange_tree_beginning): remove
	before_node_section contents if empty.

2022-09-17  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.tex (\frenchspacing): Save french spacing setting
	in \frenchspacingsetting.
	(\headline, \footline): Restore French spacing setting.
	(\output, \onepageout): Shorten some comments, including some
	about old code.

	Sentence spacing setting not always obeyed in header reported by
	Werner.

2022-09-16  Patrice Dumas  <pertusus@free.fr>

	Keep definfoenclose defined commands line numbers

	* tp/Texinfo/ParserNonXS.pm (_process_remaining_on_line),
	tp/Texinfo/XS/parsetexi/api.c (element_to_perl_hash): keep
	source info information for definfoenclose commands.

	* tp/Texinfo/ParserNonXS.pm (%keep_line_nr_brace_commands):
	remove.

	* tp/Texinfo/ParserNonXS.pm (parser, simple_parser)
	(_parse_line_command_args): add a dynamic 'brace_commands'
	hash with brace commands and added definfoenclose commands.

2022-09-16  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/ParserNonXS.pm (_pop_context, _close_current)
	(_end_line, _process_remaining_on_line),
	tp/Texinfo/XS/parsetexi/close.c (close_current),
	tp/Texinfo/XS/parsetexi/end_line.c (end_line_misc_line),
	tp/Texinfo/XS/parsetexi/separator.c (handle_close_brace):
	always check that the context and the closed command match
	and die if not.

	* tp/Texinfo/ParserNonXS.pm (_parse_texi, _init_context_stack):
	a non empty context stack at the end of parsing is a bug.
	Remove second argument of _init_context_stack().

2022-09-15  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.tex (\raggedbottom): Supply our own definition to
	avoid too small \topskip in table of contents.  Report from Werner.

2022-09-14  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/ParserNonXS.pm (_process_remaining_on_line): initialize
	'items_count' in @itemize or @enumerate to be more similar to
	XS parser, and cleaner.

	* tp/Texinfo/XS/parsetexi/handle_commands.c (handle_block_command):
	avoid a useless block, remove useless comments.

2022-09-14  Patrice Dumas  <pertusus@free.fr>

	Rename empty_* types, removing empty and adding if needed

	* tp/Texinfo/ParserNonXS.pm, tp/Texinfo/XS/misc.c,
	tp/Texinfo/XS/parsetexi/close.c,
	tp/Texinfo/XS/parsetexi/element_types.txt,
	tp/Texinfo/XS/parsetexi/indices.c,
	tp/Texinfo/XS/parsetexi/parser.c,
	tp/Texinfo/XS/parsetexi/separator.c,
	tp/Texinfo/Common.pm, tp/Texinfo/Convert/DocBook.pm,
	tp/Texinfo/Convert/HTML.pm, tp/Texinfo/Convert/LaTeX.pm,
	tp/Texinfo/Convert/NodeNameNormalization.pm,
	tp/Texinfo/Convert/Plaintext.pm, tp/Texinfo/Convert/Text.pm,
	tp/Texinfo/Convert/TextContent.pm:
	rename empty_line_after_command as ignorable_spaces_after_command,
	empty_spaces_before_paragraph as spaces_before_paragraph and
	empty_spaces_after_close_brace as spaces_after_close_brace.

2022-09-14  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Common.pm: more consistent export ok.  Do not
	export print_tree.  Rename print_tree() as debug_print_tree().
	Rename add_preamble_before_content as _add_preamble_before_content.
	Remove _collect_references, unused and doing something strange.

	* tp/Texinfo/Common.pm (texinfo_special_joint_transformation),
	tp/texi2any.pl: rename html_joint_transformation as
	texinfo_special_joint_transformation.

	* tp/Texinfo/Convert/Text.pm (text_heading),
	tp/Texinfo/Convert/Plaintext.pm: rename Texinfo::Convert::Text heading
	as text_heading.

	* tp/Texinfo/Convert/Text.pm: rename ascii_accents as _ascii_accents.

	* tp/Texinfo/Convert/Utils.pm (add_heading_number), tp/ext/epub3.pm,
	tp/init/chm.pm, tp/Texinfo/Convert/Text.pm: rename
	Texinfo::Convert::Utils numbered_heading as add_heading_number.  Do
	not chomp text in add_heading_number().

	* tp/Texinfo/ParserNonXS.pm: remove _print_tree(), unused.

2022-09-14  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Common.pm (output_files_open_out): do not set
	explicitly the :utf8 layer with binmode  as it is documented that
	binmode puts :utf8 on top of :encoding.  Also do not set the
	:bytes layer, it is documented to be incorrect with :encoding.

	* tp/Texinfo/Common.pm, configure.ac: require perl above 5.8.1
	to have binmode documented as putting :utf8 on top of :encoding.

2022-09-14  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Common.pm (locate_include_file): avoid a call to
	get_conf.  Reindent, change variable names.

2022-09-14  Gavin Smith  <gavinsmith0123@gmail.com>

	No italic correction for code @var

	* doc/texinfo.tex (\var) <@set txicodevaristt>:
	Call \smartslanted to avoid italic correction in fixed width font
	context.  Report from Vincent Lefèvre.

2022-09-13  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Common.pm (encode_file_name),
	tp/Texinfo/Convert/Converter.pm, tp/Texinfo/Convert/Utils.pm,
	tp/Texinfo/ParserNonXS.pm, tp/texi2any.pl: remove encode_file_name()
	$customization_information argument, customization should be taken
	into account in caller.

	* tp/Texinfo/Common.pm (valid_customization_option),
	tp/Texinfo/Config.pm, tp/Texinfo/Convert/Converter.pm,
	tp/Texinfo/Convert/HTML.pm: rename valid_option() as
	valid_customization_option().

	* tp/Texinfo/Convert/NodeNameNormalization.pm (convert_to_normalized),
	tp/Texinfo/Convert/HTML.pm, tp/init/highlight_syntax.pm: rename
	convert() as convert_to_normalized().

	* tp/Texinfo/Common.pm, tp/texi2any.pl: inline warn_unknown_split() in
	main program.

	* tp/Texinfo/Common.pm, tp/Texinfo/ParserNonXS.pm: remove N__ it is
	not used anywhere.

	* tp/Texinfo/Common.pm: remove unused %customization_variable_classes.

2022-09-13  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/TexinfoMarkup.pm (_convert): do not modify
	the tree when preparing a modified multitable prototype line.

	* tp/Texinfo/Convert/DocBook.pm, tp/Texinfo/Convert/HTML.pm,
	tp/Texinfo/Convert/IXINSXML.pm, tp/Texinfo/Convert/LaTeX.pm,
	tp/Texinfo/Convert/PlainTexinfo.pm, tp/Texinfo/Convert/Plaintext.pm,
	tp/Texinfo/Convert/TexinfoSXML.pm, tp/Texinfo/Convert/TexinfoXML.pm:
	Remove 'OUTFILE' and 'SUBDIR' from converter %defaults if undef
	like the default.

	* tp/Texinfo/Convert/TexinfoMarkup.pm
	(_protect_in_spaces_attribute_text): rename _protect_in_spaces as
	_protect_in_spaces_attribute_text.

2022-09-12  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/TexinfoMarkup.pm (txi_markup_convert_text),
	tp/Texinfo/Convert/TexinfoSXML.pm, tp/Texinfo/Convert/TexinfoXML.pm:
	rename txi_markup_text as txi_markup_convert_text.

	* tp/Texinfo/Convert/TexinfoMarkup.pm (txi_markup_header),
	tp/Texinfo/Convert/TexinfoSXML.pm, tp/Texinfo/Convert/TexinfoXML.pm:
	remove the txi_markup_header() arguments.

2022-09-12  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/TexinfoMarkup.pm,
	tp/Texinfo/Convert/TexinfoSXML.pm, tp/Texinfo/Convert/TexinfoXML.pm:
	use txi_markup as prefix for the functions defined in modules
	subclassing Texinfo::Convert::TexinfoMarkup.

	* tp/Texinfo/Convert/TexinfoMarkup.pm,
	tp/Texinfo/Convert/TexinfoXML.pm (%special_xml_attributes,
	_xml_attributes): do not use xml: prefix for attribute
	names in Texinfo::Convert::TexinfoMarkup, set them in
	Texinfo::Convert::TexinfoXML.

	* tp/Texinfo/Convert/TexinfoMarkup.pm (in_monospace),
	tp/Texinfo/Convert/TexinfoSXML.pm (txi_markup_text),
	tp/Texinfo/Convert/TexinfoXML.pm (txi_markup_text): add in_monospace()
	to have this information in modules subclassing
	Texinfo::Convert::TexinfoMarkup.

2022-09-12  Patrice Dumas  <pertusus@free.fr>

	Separate generic Texinfo Markup from XML formatting

	* tp/Texinfo/Convert/TexinfoMarkup.pm,
	tp/Texinfo/Convert/TexinfoSXML.pm,
	tp/Texinfo/Convert/TexinfoXML.pm, util/txixml2texi.pl,
	doc/tp_api/Makefile.am (tp_api_dependencies),
	po/POTFILES.in, tp/Makefile.am (dist_converters_DATA):
	split TexinfoXML.pm in two, the generic Markup to
	Texinfo/Convert/TexinfoMarkup.pm, the specific XML formatting
	remaining in Texinfo/Convert/TexinfoXML.pm.

	* util/txixml2texi.pl: change in spacing.

2022-09-12  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/IXINSXML.pm (converter_initialize):
	reset 'converted_format' to be 'texinfosxml', as when called
	from the main program it is (rightly) set to 'ixinsxml'.

	* tp/Texinfo/Convert/IXINSXML.pm, tp/Texinfo/Convert/IXIN.pm,
	tp/texi2any.pl: add/update comments.

2022-09-12  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/TexinfoSXML.pm (_sxml_attributes): rename
	sxml_attributes as _sxml_attributes, it is an internal function.

2022-09-12  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/TexinfoXML.pm (format_header): revert
	previous change, the TexinfoML is not a typo, the 'X' of XML is
	replaced by 'Texinfo' on purpose to obtain TexinfoML.

2022-09-11  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Common.pm (%default_converter_customization),
	tp/Texinfo/Convert/TexinfoXML.pm (%defaults),
	tp/Texinfo/Convert/TexinfoSXML.pm (%defaults),
	tp/Texinfo/Convert/IXINSXML.pm (%defaults):
	set 'TEXINFO_DTD_VERSION' in tp/Texinfo/Common.pm.

	* tp/Texinfo/Convert/TexinfoXML.pm (format_header): correct
	typo in DOCTYPE.

2022-09-11  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/XS/parsetexi/parser.c (is_end_current_command):
	remove spaces after @end argument, as it is not used anywhere
	anymore.

2022-09-11  Patrice Dumas  <pertusus@free.fr>

	Put non expanded @value flag name in extra flag

	* tp/Texinfo/ParserNonXS.pm (_process_remaining_on_line),
	tp/Texinfo/XS/parsetexi/api.c (element_to_perl_hash),
	tp/Texinfo/XS/parsetexi/parser.c (merge_text)
	(process_remaining_on_line), tp/Texinfo/Convert/HTML.pm,
	tp/Texinfo/Convert/LaTeX.pm, tp/Texinfo/Convert/Plaintext.pm,
	tp/Texinfo/Convert/Texinfo.pm: use an extra flag for non
	expandeed @value flag name.

2022-09-11  Patrice Dumas  <pertusus@free.fr>

	Prepend internal_ to internal text containers names used only for parsing

	* tp/Texinfo/ParserNonXS.pm, tp/Texinfo/XS/misc.c,
	tp/Texinfo/XS/parsetexi/close.c,
	tp/Texinfo/XS/parsetexi/element_types.txt,
	tp/Texinfo/XS/parsetexi/indices.c, tp/Texinfo/XS/parsetexi/menus.c,
	tp/Texinfo/XS/parsetexi/parser.c, tp/Texinfo/XS/parsetexi/separator.c:
	prepend internal_ to type names of text containers used in the parsing
	only that do not show up in the tree.  Rename empty_spaces_before_argument
	as internal_spaces_before_argument.

2022-09-11  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/ParserNonXS.pm(_check_empty_expansion),
	tp/Texinfo/XS/parsetexi/parser.c (check_space_element):
	do not check especially space container types, they are
	unlikely to happen where expansion is checked and should only
	contain spaces anyway.

	* tp/Texinfo/ParserNonXS.pm (_abort_empty_line),
	tp/Texinfo/XS/misc.c (xs_abort_empty_line),
	tp/Texinfo/XS/parsetexi/parser.c (abort_empty_line):
	setup associated element where needed and simplify.

2022-09-10  Patrice Dumas  <pertusus@free.fr>

	Use array references on pairs [name, value] for attributes

	* tp/Texinfo/Convert/TexinfoXML.pm (_xml_attributes, _convert),
	tp/Texinfo/Convert/TexinfoSXML.pm (sxml_attributes):
	use array references on pairs [name, value] for attributes.

2022-09-10  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/TexinfoXML.pm (_trailing_spaces_arg)
	(_leading_spaces_arg): simplify _trailing_spaces_arg,
	remove _collect_leading_trailing_spaces_arg.  Rename
	_leading_spaces_before_argument as _leading_spaces_arg.

2022-09-10  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/ParserNonXS.pm (_process_remaining_on_line),
	tp/Texinfo/XS/parsetexi/handle_commands.c (handle_line_command):
	use extra "spaces_after_argument" instead of type spaces_at_end
	for an equivalent command replacing a @set.

2022-09-10  Patrice Dumas  <pertusus@free.fr>

	Remove empty_spaces_after_command. Remove empty_spaces_before_argument
	from converters

	* tp/Texinfo/ParserNonXS.pm (_merge_text, _abort_empty_line),
	tp/Texinfo/XS/misc.c (xs_abort_empty_line, xs_merge_text),
	tp/Texinfo/XS/parsetexi/parser.c (merge_text, abort_empty_line),
	tp/Texinfo/XS/parsetexi/def.c,
	tp/Texinfo/XS/parsetexi/element_types.txt,
	tp/Texinfo/Transformations.pm (_new_node),
	tp/Texinfo/Common.pm (trim_spaces_comment_from_content)
	(move_index_entries_after_items),
	tp/Texinfo/Convert/DocBook.pm, tp/Texinfo/Convert/HTML.pm,
	tp/Texinfo/Convert/LaTeX.pm,
	tp/Texinfo/Convert/NodeNameNormalization.pm,
	tp/Texinfo/Convert/Plaintext.pm, tp/Texinfo/Convert/TexinfoXML.pm,
	tp/Texinfo/Convert/Text.pm, tp/Texinfo/Convert/TextContent.pm:
	the container empty_spaces_after_command does not appear in the
	tree anymore, remove it and remove the now unreachable code
	that set it up.  Remove empty_spaces_before_argument from
	converters as it is internal to parsers.

	* tp/Texinfo/Convert/DocBook.pm (_convert): do not test for
	empty_line_after_command in a place where it can not happen.

	* tp/Texinfo/XS/misc.c b/tp/Texinfo/XS/misc.c (xs_abort_empty_line):
	use correct extra spaces_associated_command key.

2022-09-10  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/ParserNonXS.pm (_end_line),
	tp/Texinfo/XS/parsetexi/end_line.c (end_line):
	remove reparenting of empty_line_after_command space container
	that cannot happen anymore as it is not left when at the end
	of the line.

2022-09-10  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/ParserNonXS.pm (_end_line),
	tp/Texinfo/XS/parsetexi/end_line.c (end_line_starting_block):
	remove code never used that is not relevant since there is no
	empty_line_after_command space container left in block command
	argument.

2022-09-10  Patrice Dumas  <pertusus@free.fr>

	Only use a specific space type container for skipspace commands

	* tp/Texinfo/Common.pm (move_index_entries_after_items),
	tp/Texinfo/ParserNonXS.pm (_merge_text, _abort_empty_line, _end_line)
	(_start_empty_line_after_command),
	tp/Texinfo/XS/misc.c (xs_abort_empty_line, xs_merge_text),
	tp/Texinfo/XS/parsetexi/element_types.txt,
	tp/Texinfo/XS/parsetexi/end_line.c (end_line),
	tp/Texinfo/XS/parsetexi/handle_commands.c,
	tp/Texinfo/XS/parsetexi/parser.c (merge_text, abort_empty_line)
	(start_empty_line_after_command):
	use internal_empty_line_after_command for the spaces containers
	that are to become extra space values, and empty_line_after_command
	for other spaces, in practice for skipspace commands.  Never
	use set an associated_missing_cmdname for empty_line_after_command,
	do not set associated_missing_cmdname either.  Set to 0/undef
	the third argument of start_empty_line_after_command() if called
	after a skipspace command.

2022-09-10  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/ParserNonXS.pm (_parse_texi, _process_remaining_on_line):
	add _process_remaining_on_line to match better with the XS parser.

2022-09-10  Patrice Dumas  <pertusus@free.fr>

	Remove last_raw_newline

	* tp/Texinfo/ParserNonXS.pm (_parse_texi),
	tp/Texinfo/XS/parsetexi/element_types.txt,
	tp/Texinfo/XS/parsetexi/parser.c (process_remaining_on_line)
	tp/Texinfo/Convert/Plaintext.pm (_convert): do not set
	last_raw_newline type.  It could probably have been removed earlier,
	when rawpreformatted was introduced.

2022-09-10  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/TexinfoXML.pm (_convert): no empty_line_after_command
	nor last_raw_newline in raw format command/rawpreformatted anymore.

2022-09-10  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/ParserNonXS.pm (_parse_texi),
	tp/Texinfo/XS/parsetexi/parser.c (process_remaining_on_line):
	handle separately 'raw' verbatim, ignore, (r)macro commands
	and ignored block conditional.

2022-09-10  Patrice Dumas  <pertusus@free.fr>

	Handle @end macro, verbatim and ignore line like other block commands

	* tp/Texinfo/ParserNonXS.pm (_parse_texi),
	tp/Texinfo/XS/parsetexi/parser.c (process_remaining_on_line):
	do not add explicitly an end command after a macro, verbatim or
	ignore @end, but let it be done by the code handling all the @end
	commands.

2022-09-10  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/XS/parsetexi/parser.c (process_remaining_on_line):
	collect spaces at the beginning of the line to put in the last
	raw element, not at the end of the line.

2022-09-09  Patrice Dumas  <pertusus@free.fr>

	Parse ignored raw format line like other block commands

	* tp/Texinfo/ParserNonXS.pm (_end_line, _parse_texi),
	tp/Texinfo/XS/parsetexi/end_line.c (end_line_starting_block),
	tp/Texinfo/XS/parsetexi/handle_commands.c (handle_block_command),
	tp/Texinfo/XS/parsetexi/parser.c (process_remaining_on_line, parse_texi):
	do not process ignored format content when the command is
	found, instead do it after the line has been parsed.

2022-09-09  Patrice Dumas  <pertusus@free.fr>

	Handle macro, verbatim and ignore line like other block commands

	* tp/Texinfo/ParserNonXS.pm (_end_line, _parse_texi),
	tp/Texinfo/XS/parsetexi/end_line.c (end_line_starting_block),
	tp/Texinfo/XS/parsetexi/handle_commands.c (handle_block_command),
	tp/Texinfo/XS/parsetexi/parser.c (process_remaining_on_line):
	do not make any difference among brace commands for line parsing.
	Never start a preformatted after a 'raw' macro, verbatim and ignore
	command line.

2022-09-09  Patrice Dumas  <pertusus@free.fr>

	Handle indent and noindent like other commands for following spaces

	* tp/Texinfo/ParserNonXS.pm (_abort_empty_line),
	tp/Texinfo/XS/parsetexi/parser.c (abort_empty_line): do not treat
	especially @indent and @noindent, add following spaces in extra
	spaces key.

	* tp/Texinfo/ParserNonXS.pm (_start_empty_line_after_command),
	tp/Texinfo/XS/parsetexi/handle_commands.c
	(start_empty_line_after_command),
	tp/Texinfo/XS/parsetexi/parser.c (start_empty_line_after_command):
	add extra associated_missing_cmdname field for spaces after commands
	with a command that was removed because of an error.  Pass command
	name to start_empty_line_after_command.

	* tp/Texinfo/ParserNonXS.pm (_parse_texi),
	tp/Texinfo/XS/parsetexi/handle_commands.c (handle_other_command):
	remove a if redundant with a previous condition.

2022-09-08  Patrice Dumas  <pertusus@free.fr>

	After @end macro, verbatim and ignore like other block commands

	* tp/Texinfo/ParserNonXS.pm (_end_line, _parse_texi),
	tp/Texinfo/XS/parsetexi/end_line.c (end_line),
	tp/Texinfo/XS/parsetexi/parser.c (process_remaining_on_line):
	do not start an empty line after @end macro, verbatim or
	ignore, set the current element to the line_arg and push
	ct_line on context stack.  That way, everything after the
	@end and its argument is handled similarly than other block
	commands.
	do not warn for superfluous argument after @end macro, verbatim
	and ignore, it is done when the line is processed.

	* tp/Texinfo/XS/parsetexi/parser.c (parse_texi): call end_line()
	when there is no more content, even if no newline was seen.  Allows
	to get the same output as perl Parser.

2022-09-07  Patrice Dumas  <pertusus@free.fr>

	Add extra text_arg to macro, verbatim and ignore @-commands @end

	* tp/Texinfo/ParserNonXS.pm (_parse_texi),
	tp/Texinfo/XS/parsetexi/parser.c (process_remaining_on_line):
	add command name in 'text_arg' extra @end command.

2022-09-07  Patrice Dumas  <pertusus@free.fr>

	Add @end element for macro, verbatim and ignore @-commands

	* tp/Texinfo/ParserNonXS.pm (_parse_texi),
	tp/Texinfo/XS/parsetexi/parser.c (is_end_current_command)
	(process_remaining_on_line), tp/Texinfo/XS/parsetexi/handle_commands.c
	(handle_block_command):
	collect spaces after @end for 'raw' commands, verbatim,
	ignore, or (r)macro and add an element for the @end command.
	* tp/Texinfo/Convert/Texinfo.pm (convert_to_texinfo),
	tp/Texinfo/XS/parsetexi/convert.c (convert_to_texinfo_internal):
	do not add an @end command for 'raw' block commands.

2022-09-07  Patrice Dumas  <pertusus@free.fr>

	Remove end_command extra key

	* tp/Texinfo/ParserNonXS.pm (_end_line),
	tp/Texinfo/XS/parsetexi/end_line.c (end_line_misc_line),
	tp/Texinfo/Structuring.pm (new_block_command): do not set
	end_command extra key, the end command, if existing should
	always be the last content of the block command.

2022-09-07  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/ParserNonXS.pm (_close_command_cleanup),
	tp/Texinfo/XS/parsetexi/close.c (close_command_cleanup):
	detect @end as being the last content to reparent from
	before_item to parent command, instead of using extra key
	end_command.

2022-09-07  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/TexinfoXML.pm (_convert): instead of
	extra key end_command, determine the end command of a block
	command as the last in contents.

2022-09-07  Patrice Dumas  <pertusus@free.fr>

	Remove command_argument extra key

	* tp/Texinfo/ParserNonXS.pm (_end_line), 
	tp/Texinfo/XS/parsetexi/end_line.c (end_line_misc_line),
	tp/Texinfo/Structuring.pm (new_block_command): remove
	'command_argument' extra @end command element key, it is
	redundant.

2022-09-07  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Structuring.pm (new_block_command): do a tree with
	spaces_after/before_argument instead of text space types.

2022-09-05  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.tex (\cartouche): Use \vtop instead of \vbox
	to get better spacing when cartouche appears at the top
	of a page.  Report from Werner.

2022-09-05  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/ParserNonXS.pm (_abort_empty_line, _parse_texi),
	tp/Texinfo/XS/parsetexi/handle_commands.c (handle_other_command),
	tp/Texinfo/XS/parsetexi/parser.c (abort_empty_line): do not handle
	especially @indent and @noindent, except that they are
	are never directly associated with following space.

2022-09-04  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Heading Format):
	Revise.  Mention that chapter pages might be different.

2022-09-04  Patrice Dumas  <pertusus@free.fr>

	Rename spaces type extra command as spaces_associated_command

	* tp/Texinfo/ParserNonXS.pm, tp/Texinfo/XS/parsetexi/parser.c:
	use 'spaces_associated_command' as 'extra' key for spaces
	of 'empty_spaces_before_argument' and 'empty_line_after_command'
	types.

2022-09-04  Patrice Dumas  <pertusus@free.fr>

	Abort empty line for empty @def* command line

	* tp/Texinfo/ParserNonXS.pm (_parse_def, _end_line),
	tp/Texinfo/XS/parsetexi/def.c (parse_def),
	tp/Texinfo/XS/parsetexi/end_line.c (end_line): call
	abort_empty_line before parsing definition command line to
	collect space after command in case there are no arguments at all.

	* tp/Texinfo/Convert/TexinfoXML.pm (_convert): remove end of line
	from @def* leading spaces.

2022-09-04  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/ParserNonXS.pm (_end_line): no empty content in
	'bracketed_multitable_prototype'.

	* tp/Texinfo/ParserNonXS.pm: make clear that empty_spaces_before_argument
	is a transient internal type that should be replaced by
	extra spaces_before_argument.

2022-09-04  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Generating EPUB): Edit.

2022-09-04  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (@verbatim): Use @example environment for
	examples rather than @exdent with @t.  Put actual tab characters
	in the output for the example as was shown.

2022-09-04  Patrice Dumas  <pertusus@free.fr>

	* doc/texinfo.texi (Advanced Indexing): index entries should not
	be interrupted by index brace commands.

2022-09-04  Patrice Dumas  <pertusus@free.fr>

	Space before brace special index command is a regular space if
	followed by text

	* tp/Texinfo/ParserNonXS.pm
	(_set_non_ignored_space_in_index_before_command, _end_line)
	(_parse_texi), tp/Texinfo/XS/parsetexi/element_types.txt,
	tp/Texinfo/XS/parsetexi/end_line.c (end_line_misc_line),
	tp/Texinfo/XS/parsetexi/indices.c
	(set_non_ignored_space_in_index_before_command),
	tp/Texinfo/XS/parsetexi/parser.c (check_space_element)
	(process_remaining_on_line), tp/Texinfo/XS/parsetexi/separator.c
	(check_empty_expansion): use an internal temporary space
	type "spaces_before_brace_in_index" before index brace @-commands.
	After index command or subentry is done, call
	set_non_ignored_space_in_index_before_command to go through the
	index command or subentry contents and turn internal spaces
	before index brace @-commands (@sortas...) to
	regular text if followed by text after the brace command in
	set_non_ignored_space_in_index_before_command, or to
	"spaces_at_end" otherwise.
	Split check_space_element() out of check_empty_expansion().
	Do not process spaces before index brace @-commands is they are
	not in an index command nor in a @subentry.

2022-09-04  Gavin Smith  <gavinsmith0123@gmail.com>

	ttsl @var on def line for @set txicodevaristt

	* doc/texinfo.tex (\defargs) <@set txicodevartt>:
	Reinstate code using a ttsl font for @var.  This gives
	consistency for @var between @deffn and @deftypefn.  Report
	from Vincent Lefèvre <vincent@vinc17.net>.

2022-09-03  Gavin Smith  <gavinsmith0123@gmail.com>

	\GNUTexinfonopagebreakheading

	* tp/Texinfo/Convert/LaTeX.pm (%section_map): Only use
	\GNUTexinfonopagebreakheading for @chapheading and @majorheading.
	This macro can cause broken vertical spacing, evidently due to
	the grouping characters used, and it is not necessary for these
	commands.
	(_latex_header): Output \GNUTexinfonopagebreakheading definition
	on demand with $self->{'extra_definitions'} hash.  Reword a
	comment.

2022-09-03  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Structuring Command Types):
	Correct number of groups.

2022-09-03  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Structuring Command Types):
	Minor edits for grammar and concision.

2022-09-03  Patrice Dumas  <pertusus@free.fr>

	Use spaces_at_end for spaces before @-command in index entry

	* tp/Texinfo/ParserNonXS.pm (_parse_texi),
	tp/Texinfo/XS/parsetexi/parser.c (process_remaining_on_line):
	use spaces_at_end type for space before @sortas, @subentry and
	similar @-command on index @-command lines.

2022-09-03  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.tex (\headitem): Do not call \checkenv as
	apparently this causes a row of the table to be started, and
	then \crcr creates extra vertical space.  Report from Werner.

2022-09-03  Gavin Smith  <gavinsmith0123@gmail.com>

	Shorter LaTeX preamble

	* tp/Texinfo/Convert/LaTeX.pm (_latex_header):
	Do not redefine 'plain' page style.  Condense lines in some
	definitions.  Fix a spelling error.
	($titleps_preamble): Remove unused.

2022-09-03  Gavin Smith  <gavinsmith0123@gmail.com>

	Shorter LaTeX preamble

	* tp/Texinfo/Convert/LaTeX.pm
	(_begin_document, %front_main_matter_definitions): Output commands 
	\mainmatter, \frontmatter directly using hash, rather than via
	\GNUTexinfomainmatter, \GNUTexinfofrontmatter macros.  Likewise
	for alternate 'report' definitions.
	(_latex_header): Update.

2022-09-03  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/Texinfo/Convert/LaTeX.pm (_latex_header): Fix incorrect grammar.

2022-09-03  Gavin Smith  <gavinsmith0123@gmail.com>

	Shorter LaTeX preamble

	* tp/Texinfo/Convert/LaTeX.pm (_latex_header): Only output
	\newpagestyle for 'single' and 'double' on demand.
	(_set_headings): Record use of page style in $self->{'page_styles'}
	hash.

2022-09-03  Gavin Smith  <gavinsmith0123@gmail.com>

	Shorter LaTeX preamble

	* tp/Texinfo/Convert/LaTeX.pm (_set_headings): Call \pagestyle
	directly, rather than via macros defined in preamble.

2022-09-03  Gavin Smith  <gavinsmith0123@gmail.com>

	Keep blank lines in @example

	* tp/Texinfo/Convert/LaTeX.pm (_latex_header) <GNUTexinfopreformatted>:
	Use our own definition of active newline to add \null so that empty
	lines are kept in @examples.
	(_open_preformatted), (convert) <environment commands>:
	Supply % to comment out empty line after closing brace.  Add comment
	to note that @flushleft and @flushright are anomalous.

2022-09-02  Patrice Dumas  <pertusus@free.fr>

	* tp/t/converters_tests.t: warn file_* tests with output as text returned
	from the converter.  It is most probably wrong because the empty
	directories and files are compared instead of the test returned.
	Avoid files being overwritten with -o and warn.

2022-09-01  Patrice Dumas  <pertusus@free.fr>

	Replace empty_line_after_command by block command extra spaces_after_argument

	* tp/Texinfo/ParserNonXS.pm (_isolate_last_space),
	tp/Texinfo/XS/parsetexi/parser.c (isolate_last_space):
	put last space in extra spaces_after_argument for block
	command lines, not only line commands.
	* tp/Texinfo/Convert/TexinfoXML.pm (_convert_argument_and_end_line):
	return separately the end space and the end line to be able to
	use the end space for block line arg without adding an argument
	element.  Reindent.

	* tp/Texinfo/Convert/TextContent.pm (_convert): add spaces after
	block command arguments if the arguments line is not empty.

2022-09-01  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.tex (@headings double): Put document title on all
	even-numbered pages, even chapter pages.  From Vincent Lefevre.

2022-08-31  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/ParserNonXS.pm (_end_line),
	tp/Texinfo/XS/parsetexi/end_line.c (end_line_starting_block):
	insert 'command_as_argument_inserted' in the proper
	'block_line_arg' type when default @bullet formatting command
	is added on an @itemize line.

2022-08-30  Patrice Dumas  <pertusus@free.fr>

	* doc/texinfo.texi (@code{@@caption @@shortcaption}): no multiple
	paragraph in @shortcaption, and document error in LaTeX with
	multi-paragraph @caption when there is no @shortcaption.

2022-08-30  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/Plaintext.pm (_convert),
	doc/texinfo.texi (Conventions, in @ignore block):
	keep form feeds in empty_spaces_after_close_brace only among
	ignored spaces.

2022-08-30  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/TexinfoXML.pm (_end_line_spaces): protect
	form feeds in spaces_after_argument.

2022-08-30  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/Texinfo/XS/parsetexi/parser.c (process_remaining_on_line):
	remove a check on cmd != 0 and cmd set as cmd set implies != 0.

2022-08-29  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/Texinfo/XS/parsetexi/parser.c (process_remaining_on_line):
	Add a comment.

2022-08-29  Patrice Dumas  <pertusus@free.fr>

	Hanle brace @-command before opening brace with another command

	* tp/Texinfo/ParserNonXS.pm (_parse_texi),
	tp/Texinfo/XS/parsetexi/parser.c (process_remaining_on_line):
	close brace @-command if after the command name but before the
	brace, and anther @-command is seen before handling unknown
	@-command.

2022-08-29  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.tex (\outerhsize, \outervsize, \topandbottommargin):
	Remove unused.  From Werner.

2022-08-28  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.tex [e-TeX]: Set \lastlinefit to 500.

2022-08-28  Patrice Dumas  <pertusus@free.fr>

	Handle indicatric command on table line before unknown command

	* tp/Texinfo/ParserNonXS.pm (_parse_texi),
	tp/Texinfo/XS/parsetexi/parser.c (process_remaining_on_line):
	associate indicatric command to the @*table before handling
	unknown command.

2022-08-28  Patrice Dumas  <pertusus@free.fr>

	Expand @value before processing the remaining of the line

	* tp/Texinfo/ParserNonXS.pm (_parse_texi),
	tp/Texinfo/XS/parsetexi/parser.c (process_remaining_on_line):
	expand @value that is actually expanded earlier, where macros are
	expanded as it may modify the line.

2022-08-28  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (@group): Revise.  Remove or comment out
	extraneous text.  Be clear that it cannot be used in filled
	contexts as this actually produces an error with texinfo.tex.
	* NEWS: EPUB3 -> EPUB 3.

2022-08-28  Gavin Smith  <gavinsmith0123@gmail.com>

	LaTeX list environment for indentation

	* tp/Texinfo/Convert/LaTeX.pm (_latex_header): Define
	environment using LaTeX list environment.
	(%LaTeX_environment_commands): Use this for @example, @lisp,
	@display to indent and control vertical spacing, including
	in nested environments.
	(_open_preformatted): Do not indent with \leftskip.
	(_convert) <@exdent>: No special implementation for preformatted
	context.
	<@group>: Remove implementation as it does not work any more.

2022-08-27  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/HTML.pm (_convert_email_command): add also
	\s to the spaces regexp class, could be needed on solaris.

2022-08-27  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/LaTeX.pm (_convert): no output for Unhandled
	commands (but still a warning).

2022-08-27  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/Texinfo/XS/parsetexi/parser.c(process_remaining_on_line):
	fix use of a pointer instead of value.

2022-08-27  Patrice Dumas  <pertusus@free.fr>

	Only ignore one end of line after a brace command before a brace

	* tp/Texinfo/ParserNonXS.pm (_parse_texi),
	tp/Texinfo/XS/parsetexi/parser.c(process_remaining_on_line): only
	ignore one newline after a brace command before a brace.  Report
	from Gavin.

2022-08-27  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/ParserNonXS.pm (_parse_texi): remove comment on hack
	for difference with XS parser.  Add/modify debug messages.

2022-08-27  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/Texinfo/XS/parsetexi/parser.c (process_remaining_on_line):
	really add new text after brace command.

2022-08-27  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/ParserNonXS.pm (_parse_texi),
	tp/Texinfo/XS/parsetexi/parser.c(process_remaining_on_line): avoid
	redundant code for brace commands and accent commands when not
	followed immediately by an opening brace.

2022-08-27  Patrice Dumas  <pertusus@free.fr>

	No special warning for accent command needing braces

	* tp/Texinfo/ParserNonXS.pm (_parse_texi),
	tp/Texinfo/XS/parsetexi/parser.c(process_remaining_on_line): use the
	same error message for accent command requiring braces as for other
	brace commands.

2022-08-27  Patrice Dumas  <pertusus@free.fr>

	Handle different accent commands and brace commands more similarly

	* tp/Texinfo/ParserNonXS.pm (_parse_texi),
	tp/Texinfo/XS/parsetexi/parser.c(process_remaining_on_line): handle
	accent commands more similarily to other brace commands, by treating
	them the same when on @itemize line and ignoring spaces similarly.
	Also treat accent commands with letters or one non letter character
	more similarly, since TeX treat them the same too.

2022-08-27  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/ParserNonXS.pm (_parse_texi): set $command based on
	$at_command and $single_letter_command earlier, apply alias earlier,
	to avoid code duplication and be more similar to the XS parser.

2022-08-27  Patrice Dumas  <pertusus@free.fr>

	Add spaces information for @-commands with braces followed by spaces

	* tp/Texinfo/ParserNonXS.pm (_parse_texi),
	tp/Texinfo/XS/parsetexi/parser.c (process_remaining_on_line): add spaces in extra
	for @-commands with braces followed by spaces.

	* tp/Texinfo/ParserNonXS.pm (_parse_texi): handle unknown @-commands
	earlier.

2022-08-27  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/Text.pm (_convert): handle displaymath as a block
	command

2022-08-27  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.tex (\LaTeX): Smaller font for letter A in footnotes
	and indices.

2022-08-27  Gavin Smith  <gavinsmith0123@gmail.com>

	@set txicodevaristt by default, for now

	* doc/texinfo.tex: @set txicodevaristt by default
	* NEWS, doc/texinfo.texi (@var): update
	* README-hacking, TODO: note to turn this off after next release

2022-08-26  Gavin Smith  <gavinsmith0123@gmail.com>

	* NEWS: font change for @deftype*

2022-08-26  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (@var): Add a footnote discussing fonts in
	TeX output and documenting @set txicodevaristt.

2022-08-26  Patrice Dumas  <pertusus@free.fr>

	* doc/texinfo.texi (Conventions): separate ignore block on form feeds

2022-08-26  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/LaTeX.pm (%ignorable_space_types): remove
	'empty_spaces_before_paragraph'.
	(_convert): replace form feeds by \par{} in empty_spaces_after_close_brace
	only among ignored spaces.

	* tp/Texinfo/Convert/HTML.pm (_convert_email_command): only space
	mail argument is considered empty.

2022-08-25  Gavin Smith  <gavinsmith0123@gmail.com>

	* NEWS: @set txicodevaristt.

2022-08-25  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (No Space After Definition Name),
	* NEWS: Document @set txidefnamenospace.

2022-08-25  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Conventions): Move statement about form
	feeds ending paragraph out of @ignore block.

2022-08-25  Patrice Dumas  <pertusus@free.fr>

	Replace form feeds in empty lines by \par{}

	* tp/Texinfo/Convert/LaTeX.pm (_convert): replace form feeds in
	empty_line type by \par{}.

	* doc/texinfo.texi (Conventions): form feeds end a paragraph in all
	the output formats.  Add effect in LaTeX.

2022-08-25  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/LaTeX.pm (_convert): remove unneeded \noindent
	in tabularx cell.

2022-08-25  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/LaTeX.pm: replace form feeds in ignorable
	spaces by \par{}.

2022-08-24  Patrice Dumas  <pertusus@free.fr>

	* tp/Makefile.am (dist_init_DATA): add init/documentation_examples.pm.

2022-08-24  Patrice Dumas  <pertusus@free.fr>

	When creating a node protect for all the contexts

	* tp/Texinfo/Transformations.pm (_new_node): protect in node tree
	for all the contexts, as the node name should be the same in the
	different contexts, even if some protections are not needed for the
	parsing.

2022-08-24  Patrice Dumas  <pertusus@free.fr>

	Add IGNORE_REF_TO_TOP_NODE_UP to ignore (dir), set for EPUB

	* doc/texinfo.texi(HTML Customization Variables), ../NEWS
	tp/Texinfo/Common.pm (@variable_string_settables),
	tp/Texinfo/Convert/HTML.pm (_external_node_href), tp/ext/epub3.pm:
	Add IGNORE_REF_TO_TOP_NODE_UP to ignore references to TOP_NODE_UP,
	in general (dir) if set.  For HTML.  Set for EPUB.

	* tp/Texinfo/Convert/HTML.pm
	(_default_panel_button_dynamic_direction): only output the
	node name and no <a> element if the href is an empty string.

2022-08-24  Patrice Dumas  <pertusus@free.fr>

	Pass source element command information to directions formatting

	* tp/Texinfo/Convert/HTML.pm (from_element_direction)
	(_default_panel_button_dynamic_direction*, _default_format_button)
	(_convert_tree_unit_type, _default_format_element_footer, _get_links):
	pass the command associated with the element source of the
	direction, to be able to format error messages with a line in the
	document, for now for CHECK_HTMLXREF.

	(_external_node_href): warn only once for htmlxref.cnf missing
	even if the line is known.

2022-08-23  Gavin Smith  <gavinsmith0123@gmail.com>

	 * doc/texinfo.texi: Grammar and style fixes.
	invokation -> invocation.  Associated to -> associated with.
	Provide @ after acronyms to end sentences.
	(Info Format FAQ): Note that "*note" may also be hidden for
	command-line info.

2022-08-23  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Format with texi2dvi or texi2pdf):
	Remove commentary on the difference between pdftex and pdfetex.
	(According to pdfTeX documentation, they have been synonymous
	since pdfTeX 1.40, released 2007).

2022-08-23  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Structuring Command Types): Grammar
	and style fixes.  Try to avoid confusion between type of DocBook
	element in abstract and the actual element that is output.
	Clarify that e.g. @sections would not contain following @chapters
	even if they were the last section of a chapter.

2022-08-23  Patrice Dumas  <pertusus@free.fr>

	Fix conditions on @kpdinputstyle example

	* tp/Texinfo/ParserNonXS.pm (_kbd_formatted_as_code),
	tp/Texinfo/XS/parsetexi/parser.c (kbd_formatted_as_code),
	tp/Texinfo/Convert/LaTeX.pm (_kbd_code_style): fix formatting
	of kbd in example, it does not depend on being in @code or not,
	only of being in @example or not and the condition is kbd as
	code outside of @example, not inside.

2022-08-23  Patrice Dumas  <pertusus@free.fr>

	In @r do not consider @kbd to be in code

	* tp/Texinfo/ParserNonXS.pm (_kbd_formatted_as_code),
	tp/Texinfo/XS/parsetexi/parser.c (kbd_formatted_as_code):
	if in a style_no_code brace commands, consider that kbd is not in
	code.  Use the same code in ParserNonXS as in the XS parser.

2022-08-23  Patrice Dumas  <pertusus@free.fr>

	Classify style brace commands as code/no_code/other directly

	* tp/Texinfo/Common.pm (%brace_commands), tp/Texinfo/ParserNonXS.pm
	(%full_text_commands, _in_code, _parse_line_command_args),
	tp/Texinfo/XS/parsetexi/api.c (element_to_perl_hash),
	tp/Texinfo/XS/parsetexi/command_data.txt,
	tp/Texinfo/XS/parsetexi/commands.h, tp/Texinfo/XS/parsetexi/end_line.c
	(parse_line_command_args), tp/Texinfo/XS/parsetexi/parser.c
	(kbd_formatted_as_code, check_valid_nesting): classify style brace
	commands as style_code, style_other and style_no_code directly in
	%brace_commands in perl and as command data in C.

2022-08-22  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.tex (\var): If 'txicodevaristt' is @set, then
	use \ttsl font if in monospaced font.

2022-08-22  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Common.pm (%regular_font_style_commands): only @r
	as regular_font_style_commands stopping code context.

2022-08-22  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Common.pm, tp/Texinfo/XS/parsetexi/command_data.txt:
	reorganize brace commands classifications.  Put hyphenation in
	brace commands with 1 argument.

2022-08-21  Patrice Dumas  <pertusus@free.fr>

	* doc/texinfo.texi (Invoking @command{texi2any})
	(HTML Customization Variables, Invoking @command{pod2texi})
	(HTML Translation, @command{texi2any} in Emacs):
	misc edits.

	(@command{texi2any} Environment Variables): already explain
	that specific output formats can also be set with
	TEXINFO_OUTPUT_FORMAT.

	(Other Customization Variables): update information on tree
	transformations, adding relate_index_entries_to_table_entries.

	(Creating and Installing Info Files): more links on Info
	creation and on the Info format specification.

	(Info Format FAQ): explicit that in the question on the standalone
	Info reader, it is compared with the Emacs reader.  Explain the
	differences between the readers.  Precise that another questions
	is also on the Emacs Info reader.

2022-08-21  Patrice Dumas  <pertusus@free.fr>

	No separate node for PDF output from DVI output

	* doc/texinfo.texi
	(Format with @command{texi2dvi} or @command{texi2pdf}):
	rename 'Format with @command{texi2dvi}' as
	'Format with @command{texi2dvi} or @command{texi2pdf}'
	as it is what the node is about.
	remove the 'PDF Output' node, add it as an @anchor{} in
	'Format with @command{texi2dvi} or @command{texi2pdf}'
	instead, since all the relevant information in 'PDF Output'
	is already in 'Format with @command{texi2dvi}' and there is
	additional information.
	'Format with @command{texi2dvi}' can still be used when
	referring only to texi2dvi.
	Fix places were texi2dvi was used instead of texi2pdf.

	(Format with @command{tex}/@command{texindex}): add a sentence
	information on doing pdf formerly in 'PDF Output'.


2022-08-20  Patrice Dumas  <pertusus@free.fr>

	Update DTD to have headings in most environments

	* util/texinfo.dtd: put %heading.cmds in %block.
	Remove %global.option.cmds, put index definition commands in
	%multiple.option.cmds, and @-command definitions commands
	such as alias in the newly added %define.cmds.  Move macro, rmacro
	and unmacro to %define.cmds.
	Rename %titlepage.cmds as %intitlepage.cmds.
	Add %block.cmds containing the block commands.
	Add %toplevelonly.content for @-commands appearing only in
	toplevel content, move listoffloats, copying and titlepage to
	%toplevelonly.content.

	* doc/texinfo.texi (The Body of the Document): remove the comment
	about @*heading needing to appear in main text, as it is not what
	is documented.
	(@code{@@unnumberedsec @@appendixsec @@heading}): remove @titlepage
	from context where @heading is pathological, as it should not be
	particularly problematic.
	(@code{@@listoffloats}): move @listoffloats outside of @display
	as @listoffloats should only appear in the main text.

2022-08-20  Gavin Smith  <gavinsmith0123@gmail.com>

	Fix texinfo.tex for XeTeX

	* doc/texinfo.tex (\DeclareUnicodeCharacterNative):
	Do not override any active definitions for ASCII characters.
	Broken output for hyphen reported by Werner.

2022-08-20  Patrice Dumas  <pertusus@free.fr>

	Describe formatting of chapter structuring commands only once

	* doc/texinfo.texi (Structuring Command Types, @code{@@chapter})
	(@code{@@section}, @code{@@subsection}, @code{@@subsubsection}):
	describe the formatting of all the chapter structuring commands
	in 'Structuring Command Types' and try to be somewhat less precise.

	(@code{@@subsubsection}): fix section title.

2022-08-20  Patrice Dumas  <pertusus@free.fr>

	Document that input and output file names should only be ASCII

	* doc/texinfo.texi (Minimum): state that input and output
	file names should only contain ASCII characters.  In a footnote
	precise that texi2any can handle non ASCII filenames, but that
	it will be problematic for output formats.

2022-08-20  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.tex (\need):
	End with a \penalty0 so that \safewhatsit and \dobreak do
	not remove negative skip, leading to excessive space before
	section heading.  Report from Werner Lemberg.

2022-08-20  Gavin Smith  <gavinsmith0123@gmail.com>

	@U for ASCII chars again

	* doc/texinfo.tex (\DeclareUnicodeCharacterNative):
	Do not touch the catcodes of ASCII characters.
	(\unicodechardefs): Reinstate ASCII definitions.

2022-08-20  Patrice Dumas  <pertusus@free.fr>

	Recommend UTF-8 only as encoding

	* doc/texinfo.texi (@code{@@documentencoding}): describe non
	UTF-8 encodings as being mainly for older manuals.
	(@code{@@documentencoding}, Info Format Regular Nodes): describe
	that cross-references between Info files with different character
	encodings with non-ASCII characters in node names fail in
	the '@code{@@documentencoding}' node.  Remove uneeded information
	from 'Info Format Regular Nodes'.
	Do not recommend using 7bit ASCII for portability, UTF-8 should
	be portable.
	(@code{@@euro}): remove information on the 8bit encoding since
	they should not be used anymore.

	(Internationalization of Document Strings): remove @ from
	documentlanguage and documentencoding, these are not @-commands
	in this context.

	(Other Customization Variables): update the description of defaults
	in Info for *_QUOTE_SYMBOL.

2022-08-20  Gavin Smith  <gavinsmith0123@gmail.com>

	Fix texinfo.tex with XeTeX

	* doc/texinfo.tex (\unicodechardefs): Comment out declarations of
	ASCII characters with \DeclareUnicodeCharacter.  Supply a space after
	\char argument to terminate numbers in case code is ever used again.

	Werner Lemberg reported texinfo.tex would break with XeTeX.

2022-08-20  Gavin Smith  <gavinsmith0123@gmail.com>

	* info/util.c (text_buffer_iconv): Handle E2BIG error here.
	* info/scan.c (copy_converting, scan_reference_label): Update.

2022-08-20  Gavin Smith  <gavinsmith0123@gmail.com>

	Character conversion for info reference labels

	* info/scan.c (scan_reference_label): Convert reference label
	using iconv conversion.
	(init_conversion, close_conversion): Set iconv object to (iconv_t) -1
	after calling iconv_close so we know not to use it.

	Patrice reported that index entries would not be converted and
	not found with info --apropros.

2022-08-19  Gavin Smith  <gavinsmith0123@gmail.com>

	\vtop for @group

	* tp/Texinfo/Convert/LaTeX.pm (_convert) <@group>:
	Use \vtop for the output, even though it is not perfect.

2022-08-19  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/HTML.pm (_css_string_accent)
	(_simplify_text_for_comparison, _default_format_element_footer):
	use Unicode properties and character classes that match non
	ascii letters and spaces when in regex where this is what is relevant
	and not ascii text only.

2022-08-19  Patrice Dumas  <pertusus@free.fr>

	Use gnulib wcwidth in tp/Texinfo/XS/xspara.c

	* tp/Texinfo/XS/xspara.c: remove wcwidth implementation.

	* tp/Texinfo/XS/gnulib: update and add wcwidth.

2022-08-19  Patrice Dumas  <pertusus@free.fr>

	* doc/texinfo.texi (Node Line Requirements): add in comment that
	spaces from @-commands are collapsed too.

	* doc/texinfo.texi (Node Line Requirements, Menu Parts): add
	a FIXME in comment to remove the constraint on extra space in
	Info as both the standalone and Emacs Info reader handle multiple
	spaces right now.

	* doc/texinfo.texi (HTML Xref Node Name Expansion): newlines in
	node names are correctly handled in all the output formats, remove
	the parenthesis stating that it is not the case.

	* doc/texinfo.texi (Info Format Menu): add a precision that in menu
	there is * instead of * (N|n)ote in cross-references.

2022-08-18  Gavin Smith  <gavinsmith0123@gmail.com>

	@need

	* doc/texinfo.tex (\need): Implement with vertical skips
	and penalties only, not with \vtop or \kern.  This has more
	reliable results when followed by a section title.  It also
	may work better with footnotes.  Reports from Werner Lemberg.

2022-08-18  Patrice Dumas  <pertusus@free.fr>

	Consider non ascii spaces to be characters for node name normalization

	* tp/Texinfo/Convert/NodeNameNormalization.pm (_unicode_to_protected)
	(_unicode_to_file_name, _unicode_to_transliterate):
	use /a to consider non ascii spaces as characters.  Use /s as regex
	modifier to catch special spaces considered as newlines.

	* tp/Texinfo/Convert/NodeNameNormalization.pm: remove /o regex
	modifiers.

2022-08-18  Patrice Dumas  <pertusus@free.fr>

	Multiple consecutive space transformed to one in node normalization

	* tp/Texinfo/Convert/NodeNameNormalization.pm (_unicode_to_protected)
	(_unicode_to_file_name): transform multiple spaces to one.

2022-08-18  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/XS/xspara.c (xspara__add_next),
	tp/Texinfo/Convert/ParagraphNonXS.pm (_add_next): use
	Texinfo::Convert::Unicode::string_width to get the word width in
	perl.  Re-apply Gavin change in xspara.c to use wcwidth to determine
	the width of characters.

2022-08-18  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.tex (@afivepaper): Adjust horizontal location so as
	to balance left and right margins.  Report from Werner Lemberg.

2022-08-18  Gavin Smith  <gavinsmith0123@gmail.com>

	* README-hacking: reminder to rename ChangeLog after next release

2022-08-18  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/Texinfo/XS/xspara.c (xspara__add_next):
	If character has wcwidth 0 (e.g. combining accents), count this
	as 1 to match Perl results.

2022-08-18  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/Texinfo/XS/xspara.c (xspara__add_next):
	Use wcwidth on each character, rather than assuming they
	all have display width 1.  Faulty line breaking for DEL characters
	reported by Patrice.

2022-08-18  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/t/plaintext_tests.t (del_quote_linebreaking):
	New test to track line breaking with DEL-quoting.

2022-08-17  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Common.pm (parse_node_manual): do not set text type
	if undef.

2022-08-17  Gavin Smith  <gavinsmith0123@gmail.com>

	Fix LaTeX chapter page breaks

	* tp/Texinfo/Convert/LaTeX.pm (_latex_header)
	<\GNUTexinfonopagebreakheading>:
	Wrap redefinitions in a group; otherwise, \clearpage etc.
	would be disabled for the rest of the document, leading to
	bad page breaks and excess vertical whitespace near chapter
	headings.

2022-08-17  Gavin Smith  <gavinsmith0123@gmail.com>

	* info/scan.c (scan_reference_target) <menu entry>:
	Canonicalize whitespace in node name to avoid anomaly where texi2any
	would not warn about menu entry even though it didn't work.
	From Patrice.

2022-08-17  Patrice Dumas  <pertusus@free.fr>

	Transform @* to spaces in node and menu lines in Info

	* tp/Texinfo/Convert/Plaintext.pm (new_formatter)
	(process_printindex, _convert): add 'no_added_eol' as
	formatter status to have @* transformed to space instead
	of new line in @node and menu lines.

2022-08-17  Gavin Smith  <gavinsmith0123@gmail.com>

	Recommendations on markup on @def* lines

	* doc/texinfo.texi (Marking Definition Arguments):
	Do not make its own node, including in previous node
	"Def Cmd Conventions".  Integrate with discussion of
	&keywords.  Mention the possibility of using a @macro
	but do not include any examples.  Do not promise what
	@slanted nested in @code does.

2022-08-17  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi: url -> URL throughout.

2022-08-17  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Cross Reference Commands): @ref is output
	like @pxref in Info, not @xref.
	(Four and Five Arguments, @majorheading @chapheading, @pxref)
	(@inforef): Grammar fixes (inc. similar as -> similar to).

2022-08-17  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/HTML.pm (_convert_def_line_type): replace <br>
	by $self->get_info('line_break_element').

2022-08-17  Patrice Dumas  <pertusus@free.fr>

	Improve handling of dotless i and dotless j

	* tp/Texinfo/Convert/Converter.pm (%xml_accent_entities)
	(%xml_accent_text_with_entities, xml_accent),
	tp/Texinfo/Convert/TexinfoXML.pm, tp/Texinfo/Convert/Unicode.pm
	(%unicode_accented_letters, %transliterate_map, unicode_accent):
	add dotless command to the unicode accents map, and handle
	explicitly when needed. Handle @dotless j similarly with i.

2022-08-17  Patrice Dumas  <pertusus@free.fr>

	* util/texinfo.dtd: add indentedblock and smallindentedblock.

2022-08-17  Patrice Dumas  <pertusus@free.fr>

	* doc/texinfo.texi (@code{@@inforef}): remove examples.

2022-08-16  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/HTML.pm (_convert_xref_commands): remove
	impossible case of inforef for internal reference, as it has been
	checked before.

2022-08-16  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/DocBook.pm (_convert): do not format @inforef
	especially, format similarly with @xref.

2022-08-16  Patrice Dumas  <pertusus@free.fr>

	* doc/texinfo.texi (Cross Reference Parts): update text referring to
	constraints in node names to refer to 'Info Node Names Constraints'
	with all the information on that subject being there.

	(Cross Reference Commands, Cross Reference Parts)
	(Four and Five Arguments, @code{@@ref}, @code{@@pxref}, @code{@@url})
	(Xref Link Basics): avoid naming specific formats when not needed
	or incorrect.  Use specific format when needed.

	(Four and Five Arguments): add a sentence on HTML.
	Expand on the cases of only a fourth or only a fifth argument.

	(@code{@@inforef}): add that similar formatting can be obtained with
	@*ref with a fourth argument and no fifth argument.  Remove the
	sentence stating that the converse of @inforef is @cite as it is
	not exact, @cite would be the converse of @inforef with the third
	argument only.

2022-08-16  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/Plaintext.pm (process_printindex): modify code
	slightly for xgettext parsing.

2022-08-16  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/DocBook.pm (_convert): do not use section in
	external references formatting if it is a node.

2022-08-16  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/DocBook.pm (_convert): reuse already converted
	section name in external references formatting.

2022-08-16  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/DocBook.pm (_convert): output something to refer
	to a manual without book title.

2022-08-16  Patrice Dumas  <pertusus@free.fr>

	* doc/texinfo.texi (@code{@@chapter}): use consistent chapter name
	in example.

	(@code{@@unnumbered @@appendix}): do not refer to the <title> DocBook
	element, it is not useful.

	(@code{@@majorheading @@chapheading}): do not refer to specific
	output format, but use a wording including all the remainaing
	output formats.

2022-08-16  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/DocBook.pm (%docbook_sections): use 'sect1'
	for majorheading and chapheading to be rendered as, as 'other'
	is rendered too small.

2022-08-16  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Inserting Math): Use a real formula.  State
	earlier that the argument is TeX.

2022-08-16  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Info Format Printindex): Reword to avoid
	saying "menu" too many times.

2022-08-16  Gavin Smith  <gavinsmith0123@gmail.com>

	@flushleft and @flushright for LaTeX

	* tp/Texinfo/Convert/LaTeX.pm (%LaTeX_environment_commands):
	Used nested flushleft/GNUTexinfoprefomatted environment for
	@flushleft; likewise for @flushright.

2022-08-16  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/tests/README: Advise "make -k check", which runs
	in subdirectories even if earlier tests fail.

2022-08-16  Patrice Dumas  <pertusus@free.fr>

	* doc/texinfo.texi (Node Line Requirements, Menu Parts)
	(Two Arguments, Three Arguments, @code{@@anchor})
	(Info Format Regular Nodes): add an anchor for
	'Info Node Names Constraints'.  Refer to labels in addition to
	node names in the text in 'Node Line Requirements'.
	Update texts referring to constraints in node names to refer to
	that anchor for all the information on that subject.

	(Info Format Regular Nodes): do not refer to @@-commands, it is
	confusing in the context of the Info format.

	(Info Format Printindex): refer to the menu and not to the node.


2022-08-16  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Info Format Cross Reference):
	Avoid referring to entity that is no longer in node.  Do not
	go over examples of problematic characters in node names again.

2022-08-16  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Cross References Parts, Four and Five Arguments):
	Refer to manual argument as "manual name" rather than
	"Info file name".
	(Cross References Parts): Remove unnecessary text about
	required arguments for referring to another manual.
	(@pxref): Remove unnecessary example of using @pxref with two
	arguments.

2022-08-16  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Cross References, References, Tips):
	Merge initial node "References" into chapter introduction.
	Move advice on linear manual structure to "Tips".

2022-08-16  Patrice Dumas  <pertusus@free.fr>

	Protect node names with comma in node pointers

	* tp/Texinfo/Convert/Info.pm (format_node): protect node names
	with comma in node pointers, and warn about node name containing
	a comma only for external nodes, internal nodes should have been
	warned when defined with @node.

2022-08-16  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (@xref): Raise level of subsections and
	move remainder of section before the sections for the other
	ref commands.

2022-08-16  Gavin Smith  <gavinsmith0123@gmail.com>

	Correct quoting of nodename with manual part

	* tp/Texinfo/Convert/Plaintext.pm (_convert) <DEL quote>:
	When inserting pre-quote, use saved manual part as a prefix to
	avoid quote character appearing before the manual part.
	* tp/t/plaintext_tests.t (quote_node_names): Add examples.

2022-08-16  Patrice Dumas  <pertusus@free.fr>

	Quote problematic node names in Info in the default case

	* NEWS, doc/texinfo.texi (Node Line Requirements),
	tp/Texinfo/Convert/Info.pm (%defaults),
	doc/tp_api/Makefile.am (AM_MAKEINFOFLAGS): set INFO_SPECIAL_CHARS_QUOTE
	in the default case in Info to quote problematic node names.  In the Emacs
	Info reader and in old readers, DEL character will appear, but the node
	names are problematic in those readers, so it is not such an issue to have
	them marked that way.

2022-08-16  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Cross Reference Parts): Remove examples
	to make the cross-reference parts more visible in this node.
	(There are similar examples later on in the chapter.)

2022-08-15  Patrice Dumas  <pertusus@free.fr>

	Avoid node name quoting when not needed in menu with entry name

	* tp/Texinfo/Convert/Plaintext.pm (_convert): fix nesting of
	if to quote node only if the characters requiring quoting node name
	in menu with entry name are present.

2022-08-15  Gavin Smith  <gavinsmith0123@gmail.com>

	Info output for reference commands

	* tp/Texinfo/Convert/Plaintext.pm (_convert) <ref commands>:
	Combine code handling an xref with a separate label with code
	where the node name is the label.  Both blocks of code were
	very similar apart from different requirements for DEL-quoting.
	Check for following punctuation slightly differently
	and integrate better with DEL-quoting mechanism.

2022-08-15  Patrice Dumas  <pertusus@free.fr>

	Give recommendations on markup on @def* lines

	* doc/texinfo.texi (Marking Definition Arguments): explain why
	and how to define markup for definition arguments that fit with
	languages.

2022-08-15  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi
	(Info Format Regular Nodes, Info Format Printindex):
	Do not use @kbd for DEL.  From Patrice.

2022-08-15  Patrice Dumas  <pertusus@free.fr>

	Protect node in index entry if INFO_SPECIAL_CHARS_QUOTE is set

	* tp/Texinfo/Convert/Plaintext.pm (process_printindex): protect
	node name in index if INFO_SPECIAL_CHARS_QUOTE is set.  Protect
	characters that need to be protected in menu node entry after
	menu entry name and also :, as the Info readers should consider
	text up to : to be part of the index entry.

2022-08-15  Patrice Dumas  <pertusus@free.fr>

	Set INFO_SPECIAL_CHARS_WARNING in Info to 1

	* doc/texinfo.texi (Other Customization Variables),
	tp/Texinfo/Convert/Info.pm (%defaults): set
	INFO_SPECIAL_CHARS_WARNING to 1 in Info, instead of undefined.
	To be kept as 1 as long as the Emacs Info reader does not
	support node quoting in Info files.
	
	doc/tp_api/Makefile.am (AM_MAKEINFOFLAGS): add
	-c INFO_SPECIAL_CHARS_WARNING=0

2022-08-15  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Info Format Specification): Comment out
	part about * at the beginning of a line.  Move definition
	of <separator> and <del> out of appendix introduction.

2022-08-15  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Info Format Regular Nodes): Define
	<node-spec> including DEL-quoting so it can be used later
	on in the appendix.

	(Info Format Cross Reference, Info Format Regular Nodes):
	Do not say that support for quoting mechanism is "limited"
	but do say that it isn't supported everywhere.  Do not recommend
	against its use.
	(Node Line Requirements): Be more hopeful that DEL-quoting will be
	supported by removing word "ever".

2022-08-15  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Info Format Specification):
	Do not split into two sections "General Layout" and
	"Text Constructs" as this makes it harder to navigate.

2022-08-15  Gavin Smith  <gavinsmith0123@gmail.com>

	Index format documentation

	* doc/texinfo.texi (Other Customization Variables)
	<INDEX_SPECIAL_CHARS_WARNING>: Do not describe colons in
	menu entries as "invalid".
	(Info Format Printindex): State that most of the index entry
	should occur on a single line.  Say that colons may occur in
	the entry text, and explain how to read these.

2022-08-15  Gavin Smith  <gavinsmith0123@gmail.com>

	* TODO: Remove part about allowing : in node names, as this
	is already allowed with INFO_SPECIAL_CHARS_QUOTE.  From Patrice.

2022-08-15  Patrice Dumas  <pertusus@free.fr>

	* doc/texinfo.texi (Generating EPUB, EPUB Cross-References): add
	EPUB Cross-References on cross references to external manuals in
	EPUB.  More index entries.

2022-08-15  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/HTML.pm (output): set output_init_conf after
	running the setup handler.

2022-08-15  Patrice Dumas  <pertusus@free.fr>

	* Pod-Simple-Texinfo/pod2texi.pl: add @shorttitlepage to main manual
	preamble.

2022-08-14  Gavin Smith  <gavinsmith0123@gmail.com>

	* TODO: Add tagging system for definitions.

2022-08-14  Gavin Smith  <gavinsmith0123@gmail.com>

	No \{, \} in sort key

	* tp/Texinfo/Convert/LaTeX.pm (_index_entry) <sortas>:
	Strip \{ and \} out of sort key.

2022-08-14  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/texi2any.pl (makeinfo_help): Remove --commands-in-node-names
	and --output-indent from message.

2022-08-14  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/texi2any.pl (makeinfo_help): EPUB3 -> EPUB 3

2022-08-14  Gavin Smith  <gavinsmith0123@gmail.com>

	@{, @} in index entry

	* tp/t/latex_tests.t (brace_in_index): New test.

2022-08-14  Gavin Smith  <gavinsmith0123@gmail.com>

	@{, @} in index entry

	* tp/Texinfo/Convert/LaTeX.pm (_convert) <@{, @}>:
	If in an index, use \lbrace or \rbrace in math, and
	\textbraceleft or \textbraceright otherwise.

2022-08-14  Gavin Smith  <gavinsmith0123@gmail.com>

	Better output for "maintain/all_tests.sh generate"

	* tp/maintain/all_tests.sh: Print name of each test script.
	* tp/t/test_utils.pl: Do not dump test to stderr; only print
	the name.

2022-08-14  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Optional Arguments): State that this is
	"one convention" to leave open possibility that there may
	be others.

2022-08-14  Patrice Dumas  <pertusus@free.fr>

	* doc/texinfo.texi (Typed Functions): add = in Perl Sub example.
	Gavin idea.

2022-08-14  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/LaTeX.pm (_convert): add \leavevmode{}
	for @exdent \\ to avoid an error.

2022-08-14  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/LaTeX.pm: do not use EmbracMakeKnown,
	as using it twice leads to an error.

2022-08-14  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/LaTeX.pm: simplify setting commands for
	use in table item.

	* tp/Texinfo/Convert/LaTeX.pm (_convert): convert @* as a space
	if in @def* line to avoid outputting a \\ in a tabularx line.  For
	this, set 'no_eol' on 'formatting_context'.
	rename $command_context as $command_format_context.


2022-08-14  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/LaTeX.pm: use specific strings with ctx_
	or cmd_ prepended instead of math, text and raw for text_context
	and command formatting context.

2022-08-13  Patrice Dumas  <pertusus@free.fr>

	Warn if no image file is found in LaTeX

	* tp/Texinfo/Convert/LaTeX.pm (_convert): warn if no image file
	is found, even though a file found does not modify the output.

2022-08-13  Patrice Dumas  <pertusus@free.fr>

	Do not set INDEX_SPECIAL_CHARS_WARNING with INFO_SPECIAL_CHARS_QUOTE

	* doc/texinfo.texi (Other Customization Variables),
	tp/Texinfo/Convert/Plaintext.pm (%defaults, converter_initialize):
	Set default of INFO_SPECIAL_CHARS_WARNING to be undef.  If undef,
	set if INFO_SPECIAL_CHARS_QUOTE is not set.

	* tp/Texinfo/Convert/Info.pm, tp/Texinfo/Convert/Plaintext.pm:
	cache get_conf call result of INDEX_SPECIAL_CHARS_WARNING and
	INFO_SPECIAL_CHARS_QUOTE.

2022-08-13  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/Texinfo/Convert/LaTeX.pm: Add unbalanced braces in
	index entry to TODO

2022-08-13  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo-tex-test.texi (Style commands, Definitions):
	Some tests of conditions.

2022-08-13  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.tex (\ifflagclear): New macro, to check if
	a flag has been @set or not.  Use throughout.

2022-08-13  Patrice Dumas  <pertusus@free.fr>

	* Pod-Simple-Texinfo/lib/Pod/Simple/Texinfo.pm (_protect_colon)
	(_prepare_anchor, _convert_pod): protect colons in node names
	and in references.

2022-08-13  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Structuring.pm (new_node_menu_entry): do not
	protect colons in node name, but protect in section name used as
	menu entry name.

2022-08-13  Patrice Dumas  <pertusus@free.fr>

	Do not output node menus with pod2texi in the default case

	* Pod-Simple-Texinfo/pod2texi.pl (_fix_texinfo_tree)
	(_fix_texinfo_manual): do not output menus in the default
	case, except for the main file created to include the other files,
	for the master menu.  Add a corresponding argument to _fix_texinfo_tree
	and _fix_texinfo_manual.
	(_parsed_manual_tree): excerpt from _fix_texinfo_tree to be able to
	redo a tree with a different option for menus, to be able to create
	menus if $do_master_menu is set but menus are not created.

2022-08-13  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.tex (\smartitaliccorrection): Incorporate checking
	next token in definition so as to simplify use.

2022-08-13  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.tex (\defunargs): Remove special definition for \var.

2022-08-13  Gavin Smith  <gavinsmith0123@gmail.com>

	\sl for @var

	* doc/texinfo.tex (@var): Use slanted unconditionally, not
	slanted typewriter.  This is for consistency between def header
	lines and def bodies.  This change has been made already for LaTeX,
	on 2022-08-10.
	(\ttslanted): Remove unused.

2022-08-13  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo-tex-test.texi (Style commands):
	Test end of sentence spacing after @var and @dfn.

2022-08-13  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Optional Arguments):
	Revert change stating that use of square brackets for optional
	arguments is convenient, as this is presupposing users' experiences.

2022-08-13  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (\ttstylename): Remove unused.

2022-08-13  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/Unicode.pm (unicode_point_decoded_in_encoding):
	check first if encoding is defined before calling lc().

2022-08-13  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/Unicode.pm (encoded_accents)
	(unicode_point_decoded_in_encoding): lower case the encoding argument,
	in case if was directly specified with -c OUTPUT_ENCODING_NAME
	in upper case to match with the encodings in Texinfo input, as the
	encoding names used here are lower cased.

2022-08-13  Patrice Dumas  <pertusus@free.fr>

	* doc/texinfo.texi (Sample Function Definition): move before
	or remove generic infomation from this node to focus on the example.

2022-08-13  Patrice Dumas  <pertusus@free.fr>

	* doc/texinfo.texi (Optional Arguments): do not present the use of
	brackets, parentheses and ellipses presented here as the unique
	convention, but a convenient style.  Remove information on index,
	it is not the subject of this node.

	* doc/texinfo.texi (Typed Functions): in the example with named return
	variable, add an example of referring to a variable in the definition
	body.

2022-08-12  Patrice Dumas  <pertusus@free.fr>

	@deftype* as generic commands, @deffn with simple arguments

	* doc/texinfo.texi (Definition Commands, Object-Oriented Methods):
	describe @deffn and other @-command with the whole arguments
	formatted as @var as having simple arguments.
	(Typed Functions, Object-Oriented Methods): change wording to make
	clearer that the @deftypefn and @deftypeop are generic command,
	not only suitable for typed languages.
	(Typed Functions): remove a confusing precision for the Ada example.
	Add a Perl example with named variables as return value information.

	* doc/texinfo.texi (Def Cmd Conventions): remove 'with the following
	word', as the word is already marked.

2022-08-11  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/LaTeX.pm (_convert): deftypefnnewline with
	tabularx.

2022-08-11  Patrice Dumas  <pertusus@free.fr>

	Add commands handled by embrac before tabularx

	* tp/Texinfo/Convert/LaTeX.pm (_convert): convert the def line before
	prepending commands known to embrac to avoid doing it within the
	tabularx where it causes an error.

2022-08-11  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Definition Commands):
	Move "Typed Functions" node right after "Functions Commands"
	as these naturally go together.  Re-add "@end table", deleted
	by mistake.

2022-08-11  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Definition Commands):
	Remove several redundant "templates" for the definition
	commands and statements of which index is used.

2022-08-11  Gavin Smith  <gavinsmith0123@gmail.com>

	~ for @tie

	* tp/Texinfo/Convert/LaTeX.pm (LaTeX_no_arg_brace_commands):
	Use ~ for @tie.

2022-08-11  Gavin Smith  <gavinsmith0123@gmail.com>

	tabularx for @def

	* tp/Texinfo/Convert/LaTeX.pm (_convert) <def line>:
	Use tabularx package for definition line.
	(_latex_header): Load 'tabularx' if needed.
	* tp/Texinfo/Convert/LaTeX.pm: Remove todo item.

2022-08-11  Gavin Smith  <gavinsmith0123@gmail.com>

	Protect space at start of code

	* tp/Texinfo/Convert/LaTeX.pm (_protect_text) <code>:
	Escape an initial space in case it was preceded by punctuation
	from another element.  From Patrice.

2022-08-11  Patrice Dumas  <pertusus@free.fr>

	Handle kbd in LaTeX more like other similar commands

	* tp/Texinfo/Convert/LaTeX.pm (_xtable_description_command_format)
	(%LaTeX_style_brace_commands, _convert): register distinct style
	kbd formatting LaTeX macro in %LaTeX_style_brace_commands.  Use
	code @-command style to format kbd just before the formatting instead
	of using a specific processing for kbd.

2022-08-11  Patrice Dumas  <pertusus@free.fr>

	Remove empty lines in inter item when processing the inter_item

	* tp/Texinfo/Convert/LaTeX.pm (_convert): process directly the
	inter_item content and remove empty lines directly in that
	processing.

2022-08-11  Patrice Dumas  <pertusus@free.fr>

	Rename after_description_line type as after_menu_description_line

	* tp/Texinfo/ParserNonXS.pm (_end_line),
	tp/Texinfo/XS/parsetexi/element_types.txt,
	tp/Texinfo/XS/parsetexi/end_line.c(end_line): rename
	after_description_line as after_menu_description_line.

	* tp/Texinfo/Convert/LaTeX.pm (_convert): do not check
	after_menu_description_line, menus are already ignored.

2022-08-11  Patrice Dumas  <pertusus@free.fr>

	Avoid empty line in @*table inter item formatting

	* tp/Texinfo/Convert/LaTeX.pm (_convert): ignore empty
	lines if 'nr_table_items_context' is set, as the inter item
	is formatted in a parbox which cannot contain paragraphs
	and therefore cannot contain empty lines.

2022-08-11  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Common.pm (output_files_open_out): return an
	error message based on $! if open failed, or undef.

2022-08-10  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/LaTeX.pm (_convert): only one empty line
	after @def*, resetting of embrac macros grouped with def line.

2022-08-10  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/LaTeX.pm (%roman_style_commands, _convert):
	use %roman_style_commands for @-commands that stop code context.

2022-08-10  Gavin Smith  <gavinsmith0123@gmail.com>

	@def documentation

	* doc/texinfo.texi (Definition Commands): Edit.  Move advice
	on unique names to "Def Cmd Conventions".  Remove extraneous
	text.  State in chapter intro that we are describing @deffn
	first.  Move description of location of category out of chapter
	intro and do not talk about "both output formats".

2022-08-10  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/LaTeX.pm: always use a stack for code context

2022-08-10  Patrice Dumas  <pertusus@free.fr>

	@var roman slanted everywhere @code no explicit upright in def

	* tp/Texinfo/Convert/LaTeX.pm (_convert): use a macro to define
	@var similarly to @cite, with \normalfont.  Use it in text
	context.  Set the @cite formatting with \normalfont for text
	context too.  Remove codetext context, remove 'var_slant' context.

2022-08-10  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Typed Functions): Add output of Ada example and
	state that @deftypefn does not need to be used with a type, and give
	R example.

2022-08-10  Gavin Smith  <gavinsmith0123@gmail.com>

	Avoid extra space after punctuation in \texttt

	* tp/Texinfo/Convert/LaTeX.pm (_protect_text) <code>:
	Where punctuation appears before a space, change the
	space to "\ ", control space.

2022-08-10  Gavin Smith  <gavinsmith0123@gmail.com>

	No special output for @t in def args

	* tp/Texinfo/Convert/LaTeX.pm (%var_slant_commands):
	Remove @t.  From Patrice.

2022-08-10  Patrice Dumas  <pertusus@free.fr>

	No code environment for @var on @def lines

	* tp/Texinfo/Convert/LaTeX.pm (_convert) <style commands>:
	if in var_slant context, @var stops code context.

2022-08-09  Gavin Smith  <gavinsmith0123@gmail.com>

	Special output for @var, @code, @t in def args

	* tp/Texinfo/Convert/LaTeX.pm (%var_slant_commands): New hash,
	with output for some commands when used in def args.
	(_convert) <def args>: Add a 'var_slant' formatting context.
	(_convert) <style commands>: Check %var_slant_commands and
	formatting context.

2022-08-10  Patrice Dumas  <pertusus@free.fr>

	* tp/init/highlight_syntax.pm: null input file is valid.
	Improve error handling, avoid unneeded file lexicals.

2022-08-10  Patrice Dumas  <pertusus@free.fr>

	* tp/init/chm.pm: null input file is valid.  Minor changes.

2022-08-09  Gavin Smith  <gavinsmith0123@gmail.com>

	Bold typewriter for definition name in HTML

	* tp/Texinfo/Convert/HTML.pm (_convert_def_line_type):
	Use <strong> instead of <code> for def name.
	(%css_element_class_styles) <strong.def-name>: Use monospace,
	bold, larger font.
	(_convert_def_line_type): Change 'def-meta-var-arguments' to
	'def-var-arguments'.

2022-08-09  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Inserting an Ampersand):
	Remove unnecessary @code from example.

2022-08-09  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.tex (\deftypevr, \defvr, \deftypecv, \defcv):
	Call \doind directly.  This simplifies the code path in the usual
	case when \dosubind was passed an empty subtopic.
	(\dosubind): Remove.

2022-08-09  Gavin Smith  <gavinsmith0123@gmail.com>

	@def* documentation

	* doc/texinfo.texi (Object-Oriented Variables): Remove needless
	@code from examples.
	(Inserting an Ampersand): Mark parameter with @var.

2022-08-09  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.tex (\deftypefn, \deftypeop):
	Simplify code by calling \doind directly rather than \dosubind,
	and eliminating shared code between the two commands.

2022-08-09  Gavin Smith  <gavinsmith0123@gmail.com>

	Typewriter for @deftype* line

	* doc/texinfo.tex (\defunargs): Use \tt font for @deftype*
	instead of \sl.  Remove code changing \hyphenchar for \sl font.
	Define @var to output in \sl instead of \ttsl.

2022-08-09  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.tex (\deffn, \defop):
	Simplify code by calling \doind directly rather than \dosubind,
	and eliminating shared code between the two commands.

2022-08-09  Gavin Smith  <gavinsmith0123@gmail.com>

	@def* documentation

	* doc/texinfo.tex (Def Cmds in Detail): Remove disclaimer
	that most of the examples are in Lisp.
	(Functions Commands): Edit treatment of fonts.
	(Typed Commands): State that a typewriter font is used by
	default.  Only recommend one method for distinguishing names
	of parameters.
	(Object-Oriented Variables): Add comment querying whether @code
	is necessary in the example.

2022-08-09  Patrice Dumas  <pertusus@free.fr>

	Abort above HANDLER_FATAL_ERROR_LEVEL level user handlers status 

	* tp/Texinfo/Common.pm (%default_main_program_customization_options)
	tp/Texinfo/Convert/HTML.pm (output), tp/ext/epub3.pm (epub_setup):
	if the status returned by a user defined function registered to be
	called at a specific stage is above HANDLER_FATAL_ERROR_LEVEL,
	or below -HANDLER_FATAL_ERROR_LEVEL stops the processing, otherwise
	do not stop.

2022-08-09  Patrice Dumas  <pertusus@free.fr>

	* tp/ext/tex4ht.pm (tex4ht_prepare): outputing to a null
	device is not an error.

	* tp/ext/tex4ht.pm (tex4ht_process): chdir to the processing
	directory only if there is some processing.  Add css import later,
	in tex4ht_process_format, if there was some processing.

	* tp/ext/tex4ht.pm (tex4ht_convert_command): output default
	formatting if the commands were not collected, or there is no
	result at all for a command, indicating a failure.

	* tp/ext/tex4ht.pm (tex4ht_process, tex4ht_convert_command):
	rename tex4ht_convert as tex4ht_process and tex4ht_do_tex
	as tex4ht_convert_command.

	* tp/ext/latex2html.pm (l2h_process, l2h_convert_command)
	(l2h_finish): outputing to a null device is not an error.
	Use $latex_commands_count undef to express that the commands
	were not collected.

2022-08-08  Gavin Smith  <gavinsmith0123@gmail.com>

	Block more ligatures in LaTeX

	* tp/Texinfo/Convert/LaTeX.pm (_protect_text):
	Block more ligatures in code and block several others everywhere.

2022-08-08  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/Texinfo/ParserNonXS.pm (_parse_texi),
	* tp/Texinfo/XS/parsetexi/parser.c (process_remaining_on_line):
	Remove trailing full stop from warning message.

2022-08-08  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Image Syntax): Add missing comma.

2022-08-08  Gavin Smith  <gavinsmith0123@gmail.com>

	LaTeX header

	* tp/Texinfo/Convert/LaTeX.pm (_latex_header):
	Set \parindent and \parskip inside GNUTexinfopreformatted.
	Remove unneeded \begingroup and \endgroup as environments
	are automatically within a group.  Wrap more of the header
	with \makeatletter and \makeatother.

2022-08-08  Patrice Dumas  <pertusus@free.fr>

	Reorganization of latex2html.pm code

	* tp/ext/latex2html.pm (l2h_to_latex, l2h_process): reorganize
	l2h_process and l2h_to_latex to write to the latex file only
	in l2h_to_latex, and only if some conversion is needed.
	Integrate l2h_finish_to_latex in l2h_process.

	* tp/ext/latex2html.pm (l2h_convert_command): rename l2h_do_tex
	as l2h_convert_command.

	* tp/ext/latex2html.pm (l2h_process, l2h_convert_command, l2h_finish):
	instead of setting a global status, use counters and difference
	between counters to detect that a stage failed.

	* tp/ext/latex2html.pm: avoid global commands if not needed.
	Other code cleanups.

2022-08-08  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/HTML.pm (run_stage_handlers):
	error message only if $status > 0.

2022-08-08  Gavin Smith  <gavinsmith0123@gmail.com>

	\newenvironment for preformatted

	* tp/Texinfo/Convert/LaTeX.pm (_latex_header): Define a new
	environment 'GNUTexinfopreformatted', with some of the code
	for preformatted environments.
	(_open_preformatted, _close_preformatted): Use it.  This
	makes the output a bit clearer for blocks like @example.

2022-08-08  Gavin Smith  <gavinsmith0123@gmail.com>

	@indentedblock for LaTeX

	* tp/Texinfo/Convert/LaTeX.pm (%LaTeX_environment_commands):
	Use 'quote' environment for @indentedblock and  @smallindentedblock.
	Add comment stating that right margin is incorrect.

2022-08-08  Gavin Smith  <gavinsmith0123@gmail.com>

	Remove vertical space after definition line

	* tp/Texinfo/Convert/LaTeX.pm (_convert) <def_item>:
	Avoid vertical space at beginning of 'quote' environment.

2022-08-07  Patrice Dumas  <pertusus@free.fr>

	Inverse meaning of handlers status. Re-add l2h cache

	* tp/Texinfo/Convert/HTML.pm (run_stage_handlers),
	tp/ext/epub3.pm, tp/ext/latex2html.pm, tp/ext/tex4ht.pm)
	(tp/init/book.pm, tp/init/chm.pm, tp/init/highlight_syntax.pm):
	inerse the meaning of handlers status, 0 means no error.

	* tp/ext/latex2html.pm (l2h_init_cache, l2h_store_cache):
	fix call to do and make %l2h_cache our such as it is available
	in the do.

	* tp/ext/latex2html.pm (l2h_finish_to_latex): do not call
	l2h_finish if $latex_count is 0, as it does nothing.

	* tp/texi2any.pl: add a comment.

2022-08-07  Patrice Dumas  <pertusus@free.fr>

	Init file loading errors and warning interface setup and use

	* tp/Texinfo/Config.pm (@init_file_loading_messages)
	(GNUT_load_init_file, texinfo_register_init_loading_error)
	(texinfo_register_init_loading_warning): replace
	texinfo_register_init_loading_failure by two functions,
	texinfo_register_init_loading_error and
	texinfo_register_init_loading_warning to be able to register
	errors and warnings.
	Use a stack, @init_file_loading_messages to be sure to separate
	each init file loading messages even if an init file loads another.

	* tp/init/highlight_syntax.pm: get the available languages upon
	loading and use texinfo_register_init_loading_error and
	texinfo_register_init_loading_warning for errors and warnings.

2022-08-07  Patrice Dumas  <pertusus@free.fr>

	Do not keep EPUB container directory in the default case

	* doc/texinfo.texi (Other Customization Variables)
	(Generating EPUB, Output File and Directory),
	tp/Texinfo/Common.pm (@variable_string_settables),
	tp/ext/epub3.pm (_epub_remove_container_folder)
	(epub_setup, epub_finish): remove the EPUB directory
	container unless EPUB_KEEP_CONTAINER_FOLDER is set.
	Set EPUB_KEEP_CONTAINER_FOLDER if undef and TEST or DEBUG.

	* tp/ext/epub3.pm (epub_setup): do not error out at loading
	if Archive::Zip could not be loaded, do it at the beginning
	of epub_setup() to be able to determine EPUB_CREATE_CONTAINER_FILE
	based on other customization variable.

2022-08-06  Gavin Smith  <gavinsmith0123@gmail.com>

	Add a interface to register errors from init files

	* tp/Texinfo/Config.pm (GNUT_load_init_file)
	(texinfo_register_init_loading_failure): add
	texinfo_register_init_loading_failure() to register errors
	from init files.

	* tp/ext/epub3.pm: register an error if require Archive::Zip;
	fails.

2022-08-07  Patrice Dumas  <pertusus@free.fr>

	Use CSS for horizontal alignement in table cells

	* tp/Texinfo/Convert/HTML.pm (%css_element_class_styles)
	(_convert_printindex_command, _convert_menu_comment_type)
	(_convert_def_line_type, _default_format_special_body_about):
	use CSS with classes for horizontal alignement for menu
	commnet, printindex index entries header, @def* line in table
	About table.

2022-08-07  Patrice Dumas  <pertusus@free.fr>

	Use CSS for vertical alignement in table cells

	* tp/Texinfo/Convert/HTML.pm (%css_element_class_styles)
	(_convert_printindex_command, _convert_menu_entry_type):
	use CSS with classes for vertical alignment for menu entry
	and index entry formatting.

2022-08-07  Patrice Dumas  <pertusus@free.fr>

	Percent protect manual name in external manual URLs

	* tp/Texinfo/Convert/HTML.pm (_external_node_href):
	protect urf from htmlxref and file names when relative paths to
	external manuals are used.

2022-08-07  Patrice Dumas  <pertusus@free.fr>

	Use <abbr> for acronym in HTML

	* tp/Texinfo/Convert/HTML.pm (_convert_explained_command):
	use <abbr> for @acronym, it should lead to the same formatting
	and <acronym> has been removed from HTML5.

	* doc/texinfo.texi (@code{@@abbr}, @code{@@acronym})
	(Inserting Math): do not tell explicitly which tag is used when
	it does not add useful information.

2022-08-07  Patrice Dumas  <pertusus@free.fr>

	Use <code> for table term in preformatted code context

	* tp/Texinfo/Convert/HTML.pm (_convert_item_command): use <code>
	with a class instead of <tt> for a table term in preformatted code
	such as @example.

2022-08-07  Patrice Dumas  <pertusus@free.fr>

	HTML argument formatting context for url, with conversion to UTF-8

	* tp/Texinfo/Convert/HTML.pm (%default_commands_args)
	(_convert_email_command, _convert_uref_command, _convert):
	add a new argument formatting, 'url' that always used UTF-8
	as encoding for plain text, and is otherwise the same than
	monospacetext.  It is better for percent encodded urls.

2022-08-06  Gavin Smith  <gavinsmith0123@gmail.com>

	Do not protect ] in LaTeX

	* tp/Texinfo/Convert/LaTeX.pm (_protect_text): Do nothing for ].
	Protecting it interfered with the operation of the embrac package.
	Report from Patrice.
	(_convert) <heading commands>: Wrap argument in extra layer of
	braces to avoid buggy treatment of square brackets in a section
	title.  The problems occur when the titleps package in is use.

2022-08-07  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/HTML.pm (%default_commands_args)
	(_convert_image_command): use monospacestring for
	the base image file formatted as a string instead of
	protecting plain text conversion.

2022-08-07  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/HTML.pm (%default_commands_args)
	(_convert_email_command, _convert_uref_command): use
	monospacestring for the url formatted as a string instead of
	protecting plain text conversion.

2022-08-07  Patrice Dumas  <pertusus@free.fr>

	If TEST is set, do not use system init file directories

	* tp/texi2any.pl: if TEST is set, do not use system (program) init
	directories to find init files, such that the init files are only
	found in source directory.  Report from Gavin.

2022-08-07  Patrice Dumas  <pertusus@free.fr>

	Ignore ENABLE_ENCODING for plain text in more output formats

	* tp/Texinfo/Convert/DocBook.pm, tp/Texinfo/Convert/IXIN.pm,
	tp/Texinfo/Convert/LaTeX.pm, tp/Texinfo/Convert/TexinfoXML.pm,
	tp/ext/epub3.pm: set second optional argument of
	Texinfo::Convert::Text::copy_options_for_convert_text to ignore
	the ENABLE_ENCODING setting to determine how to convert accented
	letter @-commands in plain text. 

	* tp/Texinfo/Convert/LaTeX.pm: use more systematically
	$self->{'convert_text_options'}.

2022-08-06  Gavin Smith  <gavinsmith0123@gmail.com>

	Protect ] in LaTeX

	* tp/Texinfo/Convert/LaTeX.pm (_protect_text): Output ] as {]} to
	avoid interaction with use of [, ] for optional LaTeX arguments.

	\subsection{\texttt{@float} [\textsl{type}][,\textsl{label}]}
	led to mangled output, even though the [ and ] were inside { and }.

2022-08-06  Patrice Dumas  <pertusus@free.fr>

	* tp/init/highlight_syntax.pm: encode/decode files.

2022-08-06  Patrice Dumas  <pertusus@free.fr>

	@url/@uref url independent of output encoding in HTML

	* tp/Texinfo/Convert/HTML.pm (_convert_uref_command):
	convert the url @uref/@url argument to raw text using UTF-8 encoding
	to get an url to be percent protected independent of the encoding
	and more in line with the underlying characters.

2022-08-06  Gavin Smith  <gavinsmith0123@gmail.com>

	Indent def_item in LaTeX

	* tp/Texinfo/Convert/LaTeX.pm (_convert) <def_item>:
	Wrap body of definition with \begin{quote} and \end{quote}.

	(_open_preformatted): Also do not indent @smallformat environment.
	Remove extraneous {} from output.

2022-08-06  Gavin Smith  <gavinsmith0123@gmail.com>

	@exdent in LaTeX

	* tp/Texinfo/Convert/LaTeX.pm (_convert) <@exdent>:
	Output \noindent command or a negative kern depending on the context.

2022-08-06  Patrice Dumas  <pertusus@free.fr>

	Use encoded characters in plain text from HTML if not ascii

	* tp/Texinfo/Convert/Text.pm (copy_options_for_convert_text),
	tp/Texinfo/Convert/HTML.pm: add a second argument to
	Texinfo::Convert::Text::copy_options_for_convert_text
	to ignore ENABLE_ENCODING and set enabled_encoding if
	OUTPUT_ENCODING_NAME is not us-ascii.  Set from HTML,
	where ENABLE_ENCODING unset  does not mean that encoding
	is not supported, but that entities are preferred to encoded
	characters.

2022-08-06  Patrice Dumas  <pertusus@free.fr>

	Percent encode more characters in @image file name

	* tp/Texinfo/Convert/HTML.pm (url_protect_file_text)
	(_convert_image_command), tp/ext/epub3.pm
	(epub_convert_image_command): add url_protect_file_text()
	to protect file name in url, protecting everything that
	can be special in url except ~, / and : that could appear in
	file names.

	* tp/Texinfo/Convert/HTML.pm (url_protect_url_text):
	rename protect_url_text as url_protect_url_text.

2022-08-06  Patrice Dumas  <pertusus@free.fr>

	Percent encode href or src attributes that may need it

	* tp/Texinfo/Convert/HTML.pm (protect_url_text)
	(_protect_url), tp/ext/epub3.pm (epub_convert_image_command):
	function protect_url_text() used to protect urls, both percent
	protect and protect HTML special characters with entities.
	* tp/Texinfo/Convert/HTML.pm (%default_commands_args)
	(_convert_email_command, _convert_uref_command):
	convert @uref/@url and @email first argument as simple
	text instead of string or monospace normal output, to
	use protect_url_text().

2022-08-06  Gavin Smith  <gavinsmith0123@gmail.com>

	Better environments in LaTeX

	* tp/Texinfo/Convert/LaTeX.pm (_open_preformatted):
	Set \parindent to 0pt to avoid excessive margin.  Set
	\leftskip to 0pt for @format.

2022-08-06  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.tex (\raggedleft, \raggedcenter):
	Remove, as these are not implemented in texi2any and not
	documented.

2022-08-05  Patrice Dumas  <pertusus@free.fr>

	Avoid alignment attributes in HTML when not needed

	* tp/Texinfo/Convert/HTML.pm: remove valign="middle" and
	align="left" from <td> as it is the default, except for @def*
	in table in which the align left is important.  Remove align=
	from tables with only one line, and valign= from tables with
	only one column.  Remove valign="top" from 'Jump to' in
	printindex summary letter as it is better without.

2022-08-05  Patrice Dumas  <pertusus@free.fr>

	* tp/ext/epub3.pm (epub_setup): properly reset variables.

2022-08-05  Patrice Dumas  <pertusus@free.fr>

	Set CHECK_HTMLXREF to get external manuals in EPUB

	* tp/ext/epub3.pm: external manuals need to be resolved to
	absolute URL, or the resource be present in the EPUB container
	which is not correct for another manual.  So set
	CHECK_HTMLXREF to have a warning if a manual has no absolute
	URL.
	Also set EXTERNAL_CROSSREF_EXTENSION to html.

2022-08-05  Patrice Dumas  <pertusus@free.fr>

	Replace HTMLXREF by HTMLXREF_FILE and add HTMLXREF_MODE

	* tp/Texinfo/Common.pm (@variable_string_settables),
	tp/Texinfo/Convert/HTML.pm (_parse_htmlxref_files), NEWS,
	infog/README, doc/texinfo.texi (HTML Customization Variables)
	(HTML Xref Configuration): add HTMLXREF_MODE.  Set to 'none'
	do not use of external information (useful for a collection of
	manuals), set to 'file' use the value of HTMLXREF_FILE, which
	could be useful for in source runs/tests.  HTMLXREF_FILE
	replaces HTMLXREF and is used even if TEST is not set.  If TEST
	is set and HTMLXREF_MODE is the default mode, HTMLXREF_FILE
	needs to be set to have some cross-reference information used.

2022-08-04  Patrice Dumas  <pertusus@free.fr>

	Use HTMLXREF customization variable information only if TEST

	* tp/Texinfo/Convert/HTML.pm (_load_htmlxref_files): use the
	HTMLXREF value for file name only if TEST is set.

2022-08-04  Patrice Dumas  <pertusus@free.fr>

	Remove KEEP_TOP_EXTERNAL_REF.

	* tp/Texinfo/Convert/HTML.pm (_convert_xref_commands),
	doc/texinfo.texi (HTML Customization Variables),
	tp/Texinfo/Common.pm (KEEP_TOP_EXTERNAL_REF): remove
	KEEP_TOP_EXTERNAL_REF there is no point in keeping backward
	compatibility for such an old change.

2022-08-04  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/HTML.pm (_convert_printindex_command): output
	index summary header and footer only if there is more than one
	symbol.

2022-08-04  Patrice Dumas  <pertusus@free.fr>

	* tp/ext/epub3.pm: split at chapter, no mini_toc
	(epub_convert_tree_unit_type): add an output file only once.

2022-08-04  Patrice Dumas  <pertusus@free.fr>

	Always add a language information in EPUB

	* tp/ext/epub3.pm: add en language if there is no @documentlanguage,
	as mandated by the standard.

2022-08-03  Patrice Dumas  <pertusus@free.fr>

	Copy image files in subdirectories directly in EPUB images

	* tp/Texinfo/Convert/NodeNameNormalization.pm
	(transliterate_protect_file_name, _unicode_to_file_name):
	new function transliterate_protect_file_name() that can be
	used to transliterates non ascii letters and protect characters that
	should not appear on file names.  New function _unicode_to_file_name()
	for common code of transliterate_protect_file_name and
	_unicode_to_protected.

	* tp/ext/epub3.pm (epub_convert_image_command): normalize image file
	name using transliterate_protect_file_name(), prepend a counter to
	be sure that the file names are unique and copy directly in
	EPUB/images/ even if there is a subdirectory in @image.  Do the
	formatting directly in epub_convert_image_command() to be able to
	set the url to the copied image file name.
	Report by Kurt Hornik and idea partly by Gavin.


2022-08-03  Patrice Dumas  <pertusus@free.fr>

	* tp/ext/epub3.pm: remove spurious space. Indirect report
	by Kurt Hornik.

2022-08-02  Gavin Smith  <gavinsmith0123@gmail.com>

	Manual - make "info texinfo r" work

	* doc/texinfo.texi:  Supply extra index entries for @-command
	names without extra clarificatory text.  Output these for
	Info and HTML output.  Remove other clarifications where the
	command name is longer than a byte.

	This makes it easier to look up documentation of these
	commands in Info.  For example, "info texinfo r" would not
	go to the documentation of @r, because the index entry didn't
	match exactly: it was "r (roman font)", not "r".

2022-08-01  Patrice Dumas  <pertusus@free.fr>

	EPUB conformance: version and mimetype file

	* tp/ext/epub3.pm: use 3.0 as version, as said in the
	standard.  Report from Kurt Hornik.
	No end line in mimetype file.  Report from Kurt Hornik.
	mimetype file should not be compressed.

2022-08-01  Patrice Dumas  <pertusus@free.fr>

	HTML @def* argument in <var>, not like @r{@slanted{

	* tp/Texinfo/Convert/HTML.pm (_convert_def_line_type):
	use <var> for @def* not @deftype argument.  Gavin idea.
	Replace double quotes with single quotes, reindent.

2022-08-01  Patrice Dumas  <pertusus@free.fr>

	Handle txidefnamenospace/omit_def_name_space in info/plaintext

	* tp/Texinfo/Convert/Plaintext.pm (_convert): add @def* line
	formatting cases without space between name and argument for
	the case of omit_def_name_space set.

2022-08-01  Patrice Dumas  <pertusus@free.fr>

	No omit_def_name_space in main def element

	* tp/Texinfo/ParserNonXS.pm (_parse_texi),
	tp/Texinfo/XS/parsetexi/handle_commands.c (handle_block_command):
	do not add omit_def_name_space to @def* main command.

2022-08-01  Gavin Smith  <gavinsmith0123@gmail.com>

	@firstparagraphindent in LaTeX

	* tp/Texinfo/Convert/LaTeX.pm (_convert): Use idea from
	indentfirst LaTeX package to implement @firstparagraphindent.
	* tp/Texinfo/Convert/LaTeX.pm: Remove @firstparagraphindent
	from TODO list, as well as @indent, which was different in
	texinfo.tex due to @firstparagraphindent definition.

2022-08-01  Gavin Smith  <gavinsmith0123@gmail.com>

	@dmn in LaTeX

	* tp/Texinfo/Convert/LaTeX.pm (_convert): Implement @dmn with
	\thinspace, as in texinfo.tex.

2022-07-31  Patrice Dumas  <pertusus@free.fr>

	Add omit_def_name_space to extra def_line too

	* tp/Texinfo/XS/parsetexi/handle_commands.c (handle_line_command)
	(handle_block_command), tp/Texinfo/ParserNonXS.pm (_parse_texi):
	add omit_def_name_space to extra def_line based on txidefnamenospace
	value.

	* tp/Texinfo/Convert/HTML.pm (_convert_def_line_type),
	tp/Texinfo/Convert/LaTeX.pm (_convert): use def_line
	omit_def_name_space.

2022-07-31  Patrice Dumas  <pertusus@free.fr>

	Handle txidefnamenospace/omit_def_name_space in HTML

	* tp/Texinfo/Convert/HTML.pm (_convert_def_line_type): handle
	omit_def_name_space as in LaTeX.

2022-07-31  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/HTML.pm (_convert_def_line_type): with DEF_TABLE,
	use the same class as in the default case for the category.  Enclose
	category in brackets, to be more like TeX.

2022-07-31  Patrice Dumas  <pertusus@free.fr>

	Use specific element classes for HTML @def* formatting

	* tp/Texinfo/Convert/HTML.pm (%css_element_class_styles)
	(_convert_def_line_type): use specific classes for HTML elements
	in @def* lines formatting.

2022-07-31  Patrice Dumas  <pertusus@free.fr>

	Rename to Texinfo::Convert::Utils definition_category_tree and update

	* tp/Texinfo/Convert/Utils.pm (definition_category_tree),
	tp/Texinfo/Convert/HTML.pm (_convert_def_line_type),
	tp/Texinfo/Convert/LaTeX.pm (_convert): rename
	definition_category() as definition_category_tree().
	Use code for the formatting of the class name.
	Use it in LaTeX formatting.  Do not expand the category
	tree in code context in HTML.

2022-07-31  Patrice Dumas  <pertusus@free.fr>

	Format DEF_TABLE @def* lines similarly with default case

	* tp/Texinfo/Convert/HTML.pm (_convert_def_line_type): use the
	same def call for DEF_TABLE as in the default case.  Do
	not format empty arguments.

2022-07-31  Patrice Dumas  <pertusus@free.fr>

	Use directly HTML code to format @def* line except for category

	* tp/Texinfo/Convert/HTML.pm (_convert_def_line_type): direct
	HTML format equivalent with previously used Texinfo commands
	with gdt.

2022-07-31  Patrice Dumas  <pertusus@free.fr>

	Common structure for non metasyntactic only argument def commands

	* tp/Texinfo/Common.pm (%def_no_var_arg_commands),
	tp/Texinfo/Convert/HTML.pm (_convert_def_line_type),
	tp/Texinfo/Convert/LaTeX.pm (_convert): setup %def_no_var_arg_commands
	for @def* commands with non metasyntactic variables only
	argument.

2022-07-31  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/HTML.pm (_convert_def_line_type): remove
	common code cases.

2022-07-31  Patrice Dumas  <pertusus@free.fr>

	HTML consistent @def* category formatting more similar with printed

	* tp/Texinfo/Convert/HTML.pm (_convert_def_line_type): separate
	category formatting from function line formatting for all the
	cases.  Never format category in code context.

2022-07-31  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/LaTeX.pm (_convert): analyse @anchor without
	section better and avoid debugging message if the @anchor is in
	'before_node_section'.

2022-07-31  Patrice Dumas  <pertusus@free.fr>

	@def* line conversion in HTML similar with printed output

	* tp/Texinfo/Convert/HTML.pm (_convert_def_line_type): convert @def*
	using the same formatting as for printed output, when possible.

2022-07-31  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/LaTeX.pm (_convert): @def* not @deftype* argument in @r{@slanted{

2022-07-31  Patrice Dumas  <pertusus@free.fr>

	@r resets the code context in LaTeX to have -- and --- as ligature

	* tp/Texinfo/Convert/LaTeX.pm (_push_new_context, _convert):
	turn 'code' context to an array, such that @r can reset the state
	by pushing on the array.

2022-07-31  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.tex (\r): Output -- and --- as ligature even if in code.

2022-07-31  Patrice Dumas  <pertusus@free.fr>

	No @deftypefnnewline effect on typed variable definitions in Info

	* tp/Texinfo/Convert/Plaintext.pm (_convert): effect of
	@deftypefnnewline on for deftypefn and deftypeop only.

2022-07-31  Patrice Dumas  <pertusus@free.fr>

	No @deftypefnnewline effect on typed variable definitions in LaTeX

	* tp/Texinfo/Convert/LaTeX.pm (_convert): effect of
	@deftypefnnewline on for deftypefn and deftypeop only.

2022-07-31  Patrice Dumas  <pertusus@free.fr>

	No @deftypefnnewline effect on typed variable definitions in HTML

	* tp/Texinfo/Convert/HTML.pm (_convert_def_line_type): effect of
	@deftypefnnewline on for deftypefn and deftypeop only.

2022-07-30  Patrice Dumas  <pertusus@free.fr>

	Document EPUB_CREATE_CONTAINER_FILE

	* doc/texinfo.texi (Other Customization Variables): document
	EPUB_CREATE_CONTAINER_FILE.
	* doc/texinfo.texi (EPUB Output File and Directory, EPUB HTML):
	edit.

2022-07-30  Patrice Dumas  <pertusus@free.fr>

	Document EPUB in more details

	* doc/texinfo.texi (Generating EPUB, EPUB Output File and Directory)
	(EPUB HTML): document in more details the generation of EPUB.
	(Invoking @command{texi2any}): explain how --output directory is
	used in EPUB.

	* tp/Texinfo/Common.pm, tp/ext/epub3.pm: rename
	EPUB_CREATE_CONTAINER as EPUB_CREATE_CONTAINER_FILE.

	* doc/texinfo.texi (@code{@@documentdescription}): move
	before HTML Xref.

2022-07-30  Patrice Dumas  <pertusus@free.fr>

	Distinguish output and converted format, case of epub3/html

	* tp/Texinfo/Convert/Converter.pm, tp/Texinfo/Convert/DocBook.pm,
	tp/Texinfo/Convert/HTML.pm, tp/Texinfo/Convert/IXINSXML.pm,
	tp/Texinfo/Convert/LaTeX.pm, tp/Texinfo/Convert/Plaintext.pm,
	tp/Texinfo/Convert/TexinfoSXML.pm, tp/Texinfo/Convert/TexinfoXML.pm,
	tp/texi2any.pl b/tp/texi2any.pl (set_format, %formats_table):
	distinguish converted_format and output_format.  output_format
	is the format being output.  converted_format corresponds to the
	converter being used, it is the format of the conversion.  In the
	case of epub3, epub3 is the output_format and html is the
	converted_format.
	Change loading of epub3 to go through set_format, such that it may
	be loaded with TEXINFO_OUTPUT_FORMAT too.

	* tp/Texinfo/Common.pm (@variable_string_settables, tp/ext/epub3.pm):
	make EPUB_CREATE_CONTAINER a valid customization in any case, such
	that it can be set on the command line before the init file is loaded.

2022-07-30  Patrice Dumas  <pertusus@free.fr>

	Separate directory and loading function for init files used internally

	* tp/texi2any.pl (locate_and_load_extension_file), tp/Makefile.am
	(extensionsdir): use a different function to load init files used
	in texi2any, to search only in code directory.  Put those init
	files in tp/ext, installed in $(datadir)/texinfo/.  Use the directory
	last in user init files search such that the files can still be
	loaded with --init.  Call those init files 'extensions'.

2022-07-30  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.tex (\makedefun): Edit comment.  No functional change.

2022-07-30  Patrice Dumas  <pertusus@free.fr>

	Explicit data dir for modules in ModulePath

	* tp/texi2any.pl (BEGIN), tp/Texinfo/ModulePath.pm.in (init),
	tp/Texinfo/Convert/HTML.pm (output): add a third argument to
	ModulePath init() to be able to distinguish data dir from modules
	library dir and XS object files directory.  Do not use our for
	directory name variables that are not supposed to be reused in
	other code, but only used to add to @INC.  If uninstalled, do
	not add to @INC directories that are only needed when installed.
	use pkgdatadir for js $jssrcdir.

	* tp/texi2any.pl: changes in spacing.

2022-07-29  Patrice Dumas  <pertusus@free.fr>

	Document that &word should be marked explicitly on @def* lines

	* doc/texinfo.texi (Def Cmd Conventions, Sample Function Definition):
	document that &word should be marked explicitly on the @def*
	line if it is to be strongly emphasized.  It is only done
	automatically in TeX and this feature will be removed in the future.

2022-07-29  Patrice Dumas  <pertusus@free.fr>

	Only @r stops upright. Propagate upright in non slanted

	* tp/Texinfo/Convert/LaTeX.pm (%need_known_embrac, _convert):
	embrac is not propagated to \texttt and similar non slanted
	command.  We want to propagate, so use \EmbracMakeKnown{}.
	We do it locally because \textt redefinition, for example
	breaks \hyperref.  To do it more than once, we need to undefine
	symbols set by \EmbracMakeKnown{}.

2022-07-29  Gavin Smith  <gavinsmith0123@gmail.com>

	@r and @t in def line

	* doc/texinfo.tex (\r, \t): Cancel special definitions made
	for ( ) [ ] & on def line.
	* doc/texinfo-tex-test.texi (Definitions): Add example.

2022-07-29  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/LaTeX.pm (_convert): when ignoring
	Top node, generate @float and @anchor \label if in a
	paragraph in main document (or in a float).

2022-07-29  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/LaTeX.pm (_convert): when ignoring
	Top node, generate @float and @anchor \label if directly
	in main document.

2022-07-29  Patrice Dumas  <pertusus@free.fr>

	Fix NO_TOP_NODE_OUTPUT and title page formatting reference

	* tp/Texinfo/Convert/HTML.pm (register_footnote)
	(_convert_printindex_command): really skip footnotes and
	index entries in Top node when NO_TOP_NODE_OUTPUT is set.

	* tp/Texinfo/Convert/HTML.pm (_convert_printindex_command):
	do not output letters that have no index entries associated.

	* tp/Texinfo/Convert/HTML.pm (_default_format_title_titlepage):
	(%available_converter_info, output, convert): replace
	_print_title by format_title_titlepage formatting reference.
	Call format_title_titlepage after setting the
	current_filename, but before starting to format the document.  The
	title based on @titlepage or simpletitle formatted by
	format_title_titlepage is a new global info 'title_titlepage'.

2022-07-29  Gavin Smith  <gavinsmith0123@gmail.com>

	More isolation for @r

	* doc/texinfo.tex (\r):
	Cancel special definition of & used on def line.
	* doc/texinfo-tex-test.texi (Definitions): Add example.

	Patrice reported that input like @r{@b{&rest}} led to an error
	"Argument of & has an extra }", which was due to the need for a
	space to delimit the argument of &.

2022-07-28  Patrice Dumas  <pertusus@free.fr>

	LaTeX @deftype* not in slanted, only in code

	* tp/Texinfo/Convert/LaTeX.pm (%deftype_commands, _convert):
	put @deftype* command names in %deftype_commands.  Do not consider
	@deftype* arguments to be metasyntactic variables in code, but only
	code.

2022-07-28  Patrice Dumas  <pertusus@free.fr>

	LaTeX @def* in code, upright brackets and parentheses

	* tp/Texinfo/Convert/LaTeX.pm (_protect_text): do not protect
	brackets.  It is needed for embrac package to work, but it
	is also useless to protect brackets as we already protect \
	such that there cannot be a situation where [ ] can be interpreted
	as macro optional argument.
	* tp/Texinfo/Convert/LaTeX.pm (_latex_header, _stop_embrac)
	(_restart_embrac_if_needed, _convert): use the embrac package
	to format upright parentheses and brackets on @def* line.  Turn
	off embrac when opening a style commands.
	remove _only_slanted_no_code_contents and associated types.

2022-07-28  Patrice Dumas  <pertusus@free.fr>

	Have @r isolate formatting from surrounding text for fonts

	* tp/Texinfo/Convert/LaTeX.pm (%LaTeX_style_brace_commands),
	tp/Texinfo/Convert/HTML.pm (%css_element_class_styles):
	use \textnormal for @r in LaTeX, and add font-style: normal
	to @r CSS style in HTML.  This allows isolating @r argument
	formatting from surrounding text formatting.

2022-07-27  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/LaTeX.pm (_latex_header, _convert): protect
	only the most problematic characters in image file name.  Use
	\detokenize in argument of \fbox to be sure that the non escaped
	characters in image file name have no special meaning, when TEST
	is set.

2022-07-27  Gavin Smith  <gavinsmith0123@gmail.com>

	@set txidefnamenospace in LaTeX

	* tp/Texinfo/Convert/LaTeX.pm (_convert) <@def*>:
	Correct check for whether txidefnamenospace was in effect for
	block.

2022-07-27  Patrice Dumas  <pertusus@free.fr>

	Text for contents for @*ref in section title in LaTeX

	* tp/Texinfo/Convert/LaTeX.pm (_convert): if in a section heading
	formatting use \texorpdfstring to provide with a textual
	representation of @*ref, instead of \hyperref, which, understandably
	breaks the contents.

2022-07-27  Gavin Smith  <gavinsmith0123@gmail.com>

	Document EPUB

	* doc/texinfo.texi (Output Formats, Generic Translator texi2any)
	(Invoking texi2any): Document EPUB3 output.

2022-07-27  Patrice Dumas  <pertusus@free.fr>

	Output Top node label in LaTeX

	* tp/Texinfo/Convert/LaTeX.pm (_convert): process the command
	normally even if the Top node was seen in order to have the Top
	label added.

	* tp/Texinfo/Convert/LaTeX.pm: update TODO comment for definitions.

2022-07-27  Gavin Smith  <gavinsmith0123@gmail.com>

	texi2any --help

	* tp/texi2any.pl: Fix help message so that default settings
	(including the fill column) are interpolated correctly.

2022-07-27  Gavin Smith  <gavinsmith0123@gmail.com>

	texi2any --epub3

	* NEWS, TODO: Update.
	* tp/texi2any.pl: Add --epub3 to usage message.  Edit
	usage message for format selectors to remove "rather than Info".

2022-07-27  Gavin Smith  <gavinsmith0123@gmail.com>

	texi2any --epub3

	* tp/texi2any.pl: Add an option --epub3, which sets the output
	format to HTML and loads the 'epub3.pm' init file.

2022-07-27  Gavin Smith  <gavinsmith0123@gmail.com>

	@set txidefnamenospace in LaTeX

	* tp/Texinfo/Convert/LaTeX.pm (_convert) <@def*>:
	Implement txidefnamenospace flag to omit space between def
	name and arguments.  This rearranges and condenses the code,
	and uses gdt much less.

2022-07-27  Gavin Smith  <gavinsmith0123@gmail.com>

	Save txidefnamenospace

	* tp/Texinfo/ParserNonXS.pm (_parse_texi) <def command>,
	* tp/Texinfo/XS/parsetexi/handle_commands.c
	(handle_block_command) <def command>: If txidefnamenospace flag
	is set, set 'omit_def_name_space' extra value.
	* tp/t/19def.t (omit_def_space): New test.

2022-07-27  Gavin Smith  <gavinsmith0123@gmail.com>

	@set txidefnamenospace

	* doc/texinfo.tex (\defname):
	Use '@set txidefnamenospace' instead of '@clear txidefnamespace'
	to omit space.  This will ease implementation in the XS parser as
	it means we don't need to have flags set by default.

2022-07-27  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/Texinfo/Convert/LaTeX.pm (_convert) <@def*>:
	Combine code setting strings argument to gdt, for concision.

2022-07-27  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/Texinfo/Convert/LaTeX.pm (_convert) <deftypefnnewline>:
	Remove extra @* command at beginning of line.
	<@def*>: Use { and } for font change instead of \bgroup and \egroup.
	Reformat some code.

2022-07-26  Gavin Smith  <gavinsmith0123@gmail.com>

	@clear txidefnamespace

	* doc/texinfo.tex: Implement txidefnamespace conditional to
	allow omitting a space after a definition name.  This is important
	for m4 where the space is incorrect.  Report from Eric Blake.

2022-07-26  Patrice Dumas  <pertusus@free.fr>

	* doc/texinfo.texi (Conventions): use 'Texinfo processors' instead
	of listing them.
	(@code{@@code}): use @command{texi2any} instead of 'Texinfo processors'
	as the customization variables are specific of texi2any.
	(Inserting Math): mandate the use of \ for math commands.
	(@samp{#line} and @TeX{}): use texi2any instead of makeinfo as there
	is already a reference to a node with texi2any in the reference node name.

	* doc/texinfo.texi: use @command instead of @code for commands.

2022-07-25  Patrice Dumas  <pertusus@free.fr>

	LaTeX cross-ref manual in slanted

	* tp/Texinfo/Convert/LaTeX.pm (_convert): use slanted for book
	argument of @*ref.

2022-07-25  Gavin Smith  <gavinsmith0123@gmail.com>

	Allow @{, @} in @copying block

	* doc/texinfo.tex (\macrobodyctxt): Move call to \usembodybackslash
	to sole calling site.
	(\copying): Call \macrobodyctxt instead of \scanctxt in order to
	change catcodes of { and }.  Use "other" space to find
	"@end copying" string.
	* doc/texinfo-tex-test.texi (Copying and captions): Test @{ and
	@} inside @copying.

2022-07-25  Gavin Smith  <gavinsmith0123@gmail.com>

	texinfo.tex scanning contexts

	* doc/texinfo.tex (\scanctxt):
	Set active backslash.  This means that active backslash is
	used instead of the "other" catcode when scanning arguments to
	@copying and @caption, but this appears not to make a difference
	as the arguments are not being expanded or executed straight away.
	(\scanargctxt): Remove this and replace calls with \scanctxt.

2022-07-25  Gavin Smith  <gavinsmith0123@gmail.com>

	texinfo.tex scanning contexts

	* doc/texinfo.tex (\scanctxt, \scanargctxt, \macrobodyctxt)
	(\macroargctxt, \macrolineargctxt): Simplify slightly by
	setting active newline in \scanctxt and "other" catcode for @,
	as \scanctxt is used by the other macros that need these changes.

	* doc/texinfo-tex-test.texi (Special characters in macro argument):
	New example, as this change may have affected braceless macro
	invocations.

2022-07-25  Patrice Dumas  <pertusus@free.fr>

	LaTeX @def* argument and category formated more like in TeX

	* tp/Texinfo/Convert/LaTeX.pm (_only_slanted_no_code_contents)
	(_convert): convert @def* line in code context, @def* category
	class to @code, and argument to slanted, not in code context,
	not in typewriter.

2022-07-25  Patrice Dumas  <pertusus@free.fr>

	Correct LaTeX output to be slanted when needed, and documentation

	* tp/Texinfo/Convert/LaTeX.pm (register_style_format_command)
	(%style_brace_format_command_new_commands)
	(%LaTeX_style_brace_commands, _latex_header, _convert):
	use slanted for @dfn, @var, as in texinfo.tex.  Also slanted
	for @cite, and, for @cite, not typewriter even in code context.

	* doc/texinfo.texi (@code{@@cite}, @code{@@dfn}): @dfn and
	@cite are slanted, not italic.

2022-07-25  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.tex (\unicodechardefs): Define the
	non-alphanumeric ASCII characters using \char TeX primitive.

2022-07-25  Patrice Dumas  <pertusus@free.fr>

	* doc/texinfo.tex (\unicodechardefs): Provide definitions
	for many of the ASCII characters.
	(\DeclareUnicodeCharacter): Lower limit for definition
	from U+00A0 to U+0020.

2022-07-24  Patrice Dumas  <pertusus@free.fr>

	No @-commands in file names except for @@, @{ and @}

	* doc/texinfo.texi (@code{@@setfilename}, Using Include Files)
	(@code{@@verbatiminclude}): document that @value and @@, @{, @}
	and associated @-commands such as @atchar are the only @-commands
	allowed on @setfilename, @include and @verbatiminclude lines.

2022-07-24  Patrice Dumas  <pertusus@free.fr>

	* NEWS, tp/Texinfo/Convert/DocBook.pm (_convert),
	doc/texinfo.texi (@code{@@definfoenclose}): in DocBook,
	replace definfoenclose defined @-command by its argument
	as-is (as in LaTeX).  This is consistent with DocBook formatting
	in general, which matches better with printed output.

2022-07-24  Patrice Dumas  <pertusus@free.fr>

	Avoid Texinfo processor name when not needed, prefere texi2any

	* doc/texinfo.texi (Contents, Writing a Menu, Image Syntax)
	(Conditional Commands, Defining Macros, Invoking Macros)
	(Macro Details, HTML CSS, @code{@@documentdescription})
	(Command Contexts): do not name a Texinfo
	processor when features of the language or output expected from
	all the processors are described.
	(Macro Details): put information on @, in the by design limitations,
	not in TeX caveats, as it is also relevant for texi2any.
	(@code{@@alias}): use a similar wording with Macros for @alias
	identifiers.
	(Image Syntax): ignore text on compatibility for Info reader
	not compatible with a feature introduced in 2003.
	(@code{@@definfoenclose}): use @alias in TeX example, in order
	to use Texinfo @-commands and not TeX only commands.
	Remove the second definfoenclose example.
	(Formatting Partial Documents, Updating Nodes and Menus)
	(@command{texi2any} in Emacs, @code{texinfo-format} commands)
	(Texinfo Mode Summary, Running @code{Info-validate})
	(Info Format Indirect Table): use texi2any instead of makeinfo if
	there is already texi2any or a reference to a node with texi2any in
	the reference node name.  Use @command instead of @code for texi2any
	and makeinfo.  For some Emacs related nodes, use texi2any
	preferentially as those nodes are not often updated.
	(@command{texi2any} in Emacs, @command{texi2any} Preferred): prefer
	texi2any in node names.

2022-07-24  Gavin Smith  <gavinsmith0123@gmail.com>

	* README-hacking: tab instead of spaces in git hook

2022-07-24  Gavin Smith  <gavinsmith0123@gmail.com>

	@def* in LaTeX

	* tp/Texinfo/Convert/LaTex.pm (_convert) <def_line>:
	Float category to end of line and typeset in typewriter font, as
	is done in texinfo.tex.

2022-07-24  Gavin Smith  <gavinsmith0123@gmail.com>

	* NEWS: Update for variable renaming.

2022-07-24  Patrice Dumas  <pertusus@free.fr>

	Focus less on Info for Footnote Styles

	* doc/texinfo.texi (Footnote Styles): always use lower case end
	and separate styles names.  Focus less on Info, mix HTML information
	with Info information.
	(HTML Translation): remove the paragraph on Footnote styles, there
	is no reason to emphasize that feature here.  Remove an obsolete
	@ignore glock.
	(@code{@@settitle}): no need to refer to the Texinfo processor
	name.
	(Generating HTML, Escaping to HTML, HTML Splitting): use texi2any
	instead of makeinfo, if texi2any is already used or in a reference
	node name.

2022-07-24  Patrice Dumas  <pertusus@free.fr>

	Document LOCALE_ENCODING

	* doc/texinfo.texi (Other Customization Variables): add an entry
	for LOCALE_ENCODING.

2022-07-24  Patrice Dumas  <pertusus@free.fr>

	* doc/texinfo.texi: fix the @detailmenu.

2022-07-23  Patrice Dumas  <pertusus@free.fr>

	Describe output file and encoding early. More semantic @title, etc.

	* doc/texinfo.texi (Minimum, @code{@@setfilename}): state the
	default output file name when the input file name extension is
	described, in 'Minimum'.
	texi2any does not need \input texinfo nor @bye, do not implicitly
	say that.
	(Minimum): give the information on the default encoding here, to
	have this information early in the manual.
	(Minimum, Texinfo File Header): treat @settitle as any other
	preamble @-command.
	(Texinfo File Header, @code{@@documentencoding}): use consistently
	'preamble' and not 'Texinfo preamble'.
	(@code{@@titlepage}, @code{@@title @@subtitle @@author}): insist
	less on the formatting of @title, @subtitle and @author, using wording
	less definitive on the formatting, as it is semantic and formatting
	could change over time or across formats.

2022-07-23  Gavin Smith  <gavinsmith0123@gmail.com>

	INPUT_FILE_NAME_ENCODING, OUTPUT_FILE_NAME_ENCODING documentation

	* doc/texinfo.texi (Other Customization Variables): Elaborate.

2022-07-23  Gavin Smith  <gavinsmith0123@gmail.com>

	INPUT_FILE_NAME_ENCODING, OUTPUT_FILE_NAME_ENCODING documentation

	* doc/texinfo.texi (Other Customization Variables): Update.

2022-07-23  Gavin Smith  <gavinsmith0123@gmail.com>

	Give INPUT_FILE_NAME_ENCODING, OUTPUT_FILE_NAME_ENCODING priority

	* tp/Texinfo/Common.pm (@variable_string_settables):
	Add LOCALE_ENCODING.
	* tp/texi2any.pl: Save locale in LOCALE_ENCODING configuration
	variable.  Do not set INPUT_FILE_NAME_ENCODING or
	OUTPUT_FILE_NAME_ENCODING.  Do not provide a UTF-8 default value
	for the locale encoding.

	* tp/Texinfo/Convert/Converter.pm (encoded_input_file_name),
	* tp/Texinfo/Convert/Utils.pm
	(expand_verbatiminclude, encoded_output_file_name),
	* tp/Texinfo/ParserNonXS.pm (_encode_file_name),
	* tp/Texinfo/XS/parsetexi/input.c (encode_file_name):
	First check INPUT_FILE_NAME_ENCODING, then the document encoding
	if DOC_ENCODING_FOR_INPUT_FILE_NAME is set, and thirdly the locale
	encoding saved in LOCALE_ENCODING.  Likewise for
	OUTPUT_FILE_NAME_ENCODING and DOC_ENCODING_FOR_OUTPUT_FILE_NAME.
	(Note that Texinfo::Common::encode_file_name can be called
	with an undefined encoding argument, so things will likely work
	even if LOCALE_ENCODING ends up being undefined.)

	* tp/Texinfo/XS/parsetexi/input.c (locale_encoding),
	* tp/Texinfo/XS/parsetexi/api.c, tp/Texinfo/XS/parsetexi/Parsetexi.xs
	(set_locale_encoding): New.
	* tp/Texinfo/XS/parsetexi/Parsetexi.pm (parser):
	Propagate LOCALE_ENCODING setting.

	* tp/Texinfo/XS/parsetexi/input.c
	(locale_input_file_name_encoding, input_file_name_encoding),
	* tp/Texinfo/XS/parsetexi/api.c, tp/Texinfo/XS/parsetexi/Parsetexi.xs
	(set_locale_input_file_name_encoding, set_input_file_name_encoding):
	Rename.

	* tp/tests/formatting/list-of-tests
	(manual_include_accented_file_name_latin1_explicit_encoding)
	(manual_include_accented_file_name_latin1_use_locale_encoding):
	Remove now unnecessary -c DOC_ENCODING_FOR_INPUT_FILE_NAME=0
	setting.
	(non_ascii_test_epub, non_ascii_test_rawtext): Delete duplicate
	COMMAND_LINE_ENCODING setting.

2022-07-23  Patrice Dumas  <pertusus@free.fr>

	Separate information on formatting directly Info files

	* doc/texinfo.texi (Formatting Info files, Unsplit and Tagify):
	Add 'Formatting Info files' at the section level to contain
	information on direct processing of Info files with Emacs.  It
	contains 'Tagifying' and 'Splitting', keeping from 'Tagifying'
	only the part about Tagifying, not the part about Info file
	validation.  Merge 'Unsplit' and 'Tagifying' as 'Unsplit and Tagify'
	in 'Running @code{Info-validate}' keeping only the information
	relevant for Info file validation.

2022-07-22  Gavin Smith  <gavinsmith0123@gmail.com>

	Rename LOCALE_INPUT_FILE_NAME_ENCODING

	* doc/texinfo.texi (Other Customization Variables):
	Rename LOCALE_INPUT_FILE_NAME_ENCODING and
	LOCALE_OUTPUT_FILE_NAME_ENCODING by removing LOCALE_ prefix.

2022-07-22  Gavin Smith  <gavinsmith0123@gmail.com>

	Rename LOCALE_INPUT_FILE_NAME_ENCODING

	* tp/Texinfo/Common.pm (@variable_string_settables):
	Rename LOCALE_INPUT_FILE_NAME_ENCODING and
	LOCALE_OUTPUT_FILE_NAME_ENCODING by removing LOCALE_ prefix.
	All uses updated.

2022-07-22  Patrice Dumas  <pertusus@free.fr>

	Update Emacs related documentation, other changes

	* doc/texinfo.texi (Printing with Emacs, Emacs Shell Printing): add
	the 'Printing with Emacs', rename 'Within Emacs' as 'Emacs Shell
	Printing', and put 'Emacs Shell Printing', 'Texinfo Mode Printing'
	and 'Compile-Command' in 'Printing with Emacs'.
	(Tag and Split Files, Splitting): update based on changes in Emacs,
	thanks to Robert Pluim information, texinfo-format-buffer always create a
	tag table.
	(Splitting): move up to the same level of 'Catching Mistakes'.
	(Installing Dir Entries, GNU Sample Texts): inform that @dircategory
	specify a manual category in addition to being used in Info (dir).
	(Running @code{Info-validate}, @code{Info-validate}): describe the
	use of CHECK_NORMAL_MENU_STRUCTURE to make more checks with makeinfo,
	and that makeinfo never checks that a Next pointer corresponds to
	a Prev pointer.  Write explicitly that a Next pointer always
	corresponding to a Prev pointer is not a strict requirement, but
	for 'standard' documents.

	* doc/texinfo.texi: other minor changes.

2022-07-21  Patrice Dumas  <pertusus@free.fr>

	Move Emacs multiple file updates nodes to Emacs mode node

	* doc/texinfo.texi (Update Multiple Files, Include Files Requirements)
	(Include Files, Other Updating Commands):
	rename '@code{texinfo-multiple-files-update}' as 'Update Multiple
	Files'.  Move 'Update Multiple Files' and 'Include Files Requirements'
	out of 'Include Files' to 'Updating Nodes and Menus' in Emacs
	Texinfo mode description.
	Move information related to texinfo-multiple-files-update from
	'Other Updating Commands' to 'Update Multiple Files'.

	* doc/texinfo.texi (Sample Include File): update and simplify the
	example.

2022-07-20  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Texinfo Preamble): Rename to "Preamble" and edit.

2022-07-20  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi
	(@setfilename): "Tell the name" -> "Give the name" in menu entries
	leading to this node.  Do not separate sentences with commas.  Other
	edits for grammar.
	(Titlepage & Copyright Page): "similar with" -> "similar to"
	(small): Remove mention of Texinfo-XML transliteration as not much
	information is given here.

2022-07-20  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi
	(Nodes): No need to compare cross-references with the "document
	structure".
	(Node Line Requirements): Avoid obscure word "unicity".  Tweak
	reference to node name quoting support.
	(Cross Reference Parts): Consistent referencing to xref targets.

2022-07-20  Gavin Smith  <gavinsmith0123@gmail.com>

	Edit recent changes for grammar and style and make other minor edits.

	* doc/texinfo.texi (Reporting Bugs, Histroy, Minimum, @settitle)
	(Image Syntax, @dmn, Inserting Math, Inserting Unicode, Line Breaks)
	(@- @hyphenation, @w, @documentencoding, @need)
	(Defining New Texinfo Commands, @definfoenclose, Hardcopy with TeX)
	(Texinfo Mode Printing, Command List, Tips, @setchapternewpage)
	(@headings, Custom Headings, A4 Paper): Various fixes:

	- "Cause TeX to" was changed in some places to "Cause to" but the
	  result of this was ungrammatical in many places.
	- Do not use commas to separate sentences.
	- non printed -> non-printed

	(Hardcopy with TeX): Add anchor for old name.

	* NEWS: Remove entry about generating menus as this is not a
	new feature.

2022-07-20  Patrice Dumas  <pertusus@free.fr>

	Input/output encoding is used irrespective of @documentencoding

	* doc/texinfo.texi (@code{@@documentencoding}): the output of
	encoding information does not depends on @documentencoding being
	set.  Emphasize more than UTF-8 is the default encoding.
	Explain what --enable-encoding does for LaTeX.
	Correct the description for XML and DocBook, they are affected by
	@documentencoding and --enable-encoding.

	* doc/texinfo.texi (Invoking @command{texi2any}), tp/texi2any.pl:
	document what --enable-encoding does for HTML, TexinfoXML and DocBook.

2022-07-20  Patrice Dumas  <pertusus@free.fr>

	Describe @-commands roles in Command List, not formatting

	* doc/texinfo.texi (Command List): explain the role of the
	@-commands, not the formatting.  Avoid details on output
	format specificities when it is not crucial for the understanding
	of the @-command role.  Move or duplicate some information to the main
	nodes describing some @-commands.  Update some @-commands descriptions.
	(Command Contexts): explain @shortcaption context along with
	@caption.

2022-07-20  Patrice Dumas  <pertusus@free.fr>

	No HTML features list, explain how HTML evolves

	* doc/texinfo.texi (HTML Translation): do not list explicitly
	HTML features used, but rather explain how makeinfo implements
	latest standard features while trying to be backward compatible
	as best as possible too.

2022-07-20  Patrice Dumas  <pertusus@free.fr>

	* doc/texinfo.texi (@code{@@setfilename}): state clearly that
	@setfilename is optionnal, and give some example where it could
	still be relevant.  Add an @anchor{Setting the Output File Name}
	and use it everywhere the reference is to the output fine name set,
	be it from @setfilename or from the input file name, and not
	directly about the @setfilename @-command.
	(@code{@@settitle}): advertise NO_TOP_NODE_OUTPUT as the best way
	to get a title similar with printed manuals in HTML.
	(Node Line Requirements): readd a sentence on constraints on
	spaces in menu entry node names, after testing that what matters
	are the internal spaces.
	(Menu Location): remove obsolete @ignore'ed block text.
	(Floats, @code{@@float}, @code{@@listoffloats}): information on
	floats with LaTeX.
	(Inserting Accents): adapt for changes in default encoding.
	(HTML Customization Variables): move USE_TITLEPAGE_FOR_TITLE and
	SHORT_TOC_LINK_TO_TOC to HTML Customization Variables.
	Explain why INDEX_SPECIAL_CHARS_WARNING is set to false in
	INDEX_SPECIAL_CHARS_WARNING explanation, refer to
	INDEX_SPECIAL_CHARS_WARNING in INFO_SPECIAL_CHARS_WARNING.
	(Generating HTML): mention that initialization files can be used
	to customize even more the HTML output. Give example of such files
	in Texinfo.  Link to the draft customization_api manual.
	(HTML CSS): @ignore text about texinfo-bright-colors.css as it
	is not in Texinfo anymore.

	* doc/texinfo.texi: misc other changes, in particular remove
	information on Texinfo XML transliteration when it is simply said that
	a transliteration is produced.

2022-07-18  Patrice Dumas  <pertusus@free.fr>

	* doc/texinfo.texi: add additional information on DocBook output.
	(Generating HTML): remove the sentence saying that DocBook and
	XML output are not described in detail, they are correctly described.

2022-07-18  Patrice Dumas  <pertusus@free.fr>

	* doc/texinfo.texi (@command{latex2html} Customization Variables):
	write only once that the customization variables are only relevant
	if using latex2html.

2022-07-18  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Common.pm (%default_main_program_command_line_options):
	add 'SILENT' for --silent for completeness.  It is not used anywhere.

2022-07-18  Patrice Dumas  <pertusus@free.fr>

	Simplify node names information, add more on explicit pointers

	* doc/texinfo.texi (Node Line Requirements): simplify information
	on node names requirements to match with current implementation
	and avoid implementation details.
	(First Node): Top Prev node is not set in the usual case.
	(Texinfo Document Structure, Node Menu Illustration): move the
	information from the Note in Node Menu Illustration to
	Texinfo Document Structure to explain better that Next and Prev
	at the same hierarchical level earlier.  Remove the Note as it
	is redundant with other explanations (before and after).
	Be more explicit in the examples on the differences between
	automatic and explicit node pointers.  Add a paragraph to explain
	that technically explicit node pointers can lead anywhere, but
	that it is a bad idea to use that feature.
	(Menus): be more explicit that menus need not to be written in
	a hierarchically organized manual with automatic pointers unless
	specific formatting is wanted.

2022-07-17  Patrice Dumas  <pertusus@free.fr>

	Document float labels and anchors are used like nodes, other changes

	* doc/texinfo.texi (Nodes, Node Line Requirements, References)
	(Cross Reference Parts, @code{@@anchor})
	(HTML Xref Node Name Expansion): document systematically
	that anchor and float labels are equivalent with
	node names and unicity is for all of those names usable
	as cross references locations.
	(Node Names): instead of telling never to change a node name,
	propose to replace by an anchor here too, as in the @anchor
	section.
	(Nodes, Writing a Node, Writing a Menu): recommend less
	prominently the usual structuring following the sectioning
	structure, as other structures such as guide/topic structure
	would be relevant.
	(Node Line Requirements): link to INFO_SPECIAL_CHARS_QUOTE
	to state that the limitation in node names will be removed some day.

2022-07-17  Patrice Dumas  <pertusus@free.fr>

	Documentation: LaTeX output, move Emacs related info, other changes

	* doc/texinfo.texi: edit to use printed output instead of @TeX{}
	if also relevant for LaTeX, and add specific informations
	for LaTeX output.
	(Hardcopy with @TeX{}): rename Hardcopy as Hardcopy with @TeX{}.
	(Minimum, Emacs Editing, Sample Include File)
	(Invoking @command{texi2any}): discourage using .tex as extension
	for Texinfo documents, encourage .texi.  Remove duplicate
	information on extensions in Emacs Editing node.
	(Texinfo File Header, Writing a Node, Texinfo Mode Printing)
	(Updating Commands, @code{@@smallbook}, Preferred): remove or
	move Emacs specific information.  Also recall that using automatic
	pointers and menus is possible and usually better.
	(Start of Header, End of Header): merge as Start and End of Header
	and put after Texinfo Preamble node.
	(Reporting Bugs): link to GNU Coding Standards
	instead of Emacs manual, and propose diff -u too.
	(Output Formats, Short Sample, The Top Node, Master Menu Parts)
	(Nodes, @code{@@top} Command, Fonts, PDF Output): remove some
	text with erroneous, redundant or useless information.
	(Adding Output Formats): link to tp_api.
	(History): update on Multilingual support, to take into account
	that there is now C again.  Add a sentence to describe that there
	was no back-end contribution.
	(Texinfo Document Structure, Node Menu Illustration): do not
	present the usual structuring following the sectioning structure
	as the only one recommended.  Other structures (for example the
	guide/topic structure of the Mallard language) would be equally
	relevant.

	* tp/texi2any.pl, doc/texinfo.texi (Invoking @command{texi2any}):
	add --iflatex and --no-iflatex.

	* doc/texinfo.texi (Menus), NEWS: document that a menu in Info output
	is automatically added if there is no @menu at all in a node with
	automatic directions.

2022-07-05  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/Texinfo/Convert/ParagraphNonXS.pm (set_space_protection),
	* tp/Texinfo/XS/xspara.c (xs_set_space_protection):
	Remove code making end of sentence up to two spaces as it is not
	clear that this is necessary or correct.

2022-06-05  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi: Change all Wikipedia links to use https.
	From Tzvetelin Katchov <katchov@gnu.org>.

2022-06-04  Patrice Dumas  <pertusus@free.fr>

	Document strict API use in comments when the API is not used

	* tp/Texinfo/Convert/HTML.pm: use # API info: comments to
	document what strict API use would have been when the API is not
	used for speed.

	* doc/customization_api.texi (Init File Basics, Basic Formatting
	Customization): document # API info: comments. Document that
	customized format_protect_text function may not be called everywhere.

2022-06-04  Gavin Smith  <gavinsmith0123@gmail.com>

	Cast for isalpha and isalnum arguments

	* Texinfo/XS/parsetexi/end_line.c (end_line_starting_block)
	(end_line_misc_line),
	* Texinfo/XS/parsetexi/parser.c (read_command_name):
	Cast arguments to isalnum and isalpha to unsigned char.

2022-06-04  Gavin Smith  <gavinsmith0123@gmail.com>

	New XS override

	* tp/Texinfo/Convert/HTML.pm (_convert_text, _entity_text):
	Split out _entity_text, used for USE_ISO.

	* tp/Texinfo/XS/MiscXS.xs,
	* tp/Texinfo/XS/misc.c (xs_entity_test): New function.
	* tp/Texinfo/Convert/HTML.pm: Override _entity_text
	with XS implementation.

2022-06-04  Gavin Smith  <gavinsmith0123@gmail.com>

	Joint tree transformation

	* tp/Texinfo/Common.pm (html_joint_transformation):
	Peform both the 'move_index_entries_after_items' and the
	'relate_index_entries_to_table_entries_in_tree' transformations
	together.
	* tp/texi2any.pl: Use this for HTML and also LaTeX.

	This is much faster because of the slowness of recursively
	traversing the parse tree with Perl subroutine calls.  It means
	we traverse the tree one fewer time.

2022-06-04  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/Texinfo/Convert/HTML.pm (_convert_text):
	Call _default_format_protect_text without method call syntax.

2022-06-04  Gavin Smith  <gavinsmith0123@gmail.com>

	texi2any --html performance improvements

	* tp/Texinfo/Convert/HTML.pm
	(html_attribute_class): Change a method call to a regular call.
	(_protect_class_name): Call _default_format_protect_text directly.
	(_default_format_navigation_panel):
	Access 'formatting_function' hash instead of calling
	'formatting_function' function.

2022-06-04  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/Texinfo/Convert/HTML.pm (html_attribute_class):
	Hard-code access to 'conf' array rather than calling get_conf.

2022-06-04  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/Texinfo/Convert/HTML.pm (_conversion_contents):
	Simplify and inline at call sites.

2022-06-04  Gavin Smith  <gavinsmith0123@gmail.com>

	Inline some method calls

	* tp/Texinfo/Convert/HTML.pm (_convert_text):
	Inline calls to in_verbatim, in_raw, in_math, in_upper_case and
	in_non_breakable_space.

2022-06-04  Gavin Smith  <gavinsmith0123@gmail.com>

	Override _default_format_protect_text instead

	* tp/Texinfo/XS/misc.c, tp/Texinfo/XS/MiscXS.xs
	(xs_xml_protect_text, xs_default_format_protect_text): Rename and
	also handle form feeds.
	* tp/Texinfo/Convert/HTML.pm: Override _default_format_protect_text.
	* tp/Texinfo/Convert/Converter.pm: Do not override xml_protect_text.
	* tp/texi2any.pl: Call import method on dynamically loaded modules.

2022-06-04  Gavin Smith  <gavinsmith0123@gmail.com>

	texi2any --html performance improvement - XS override

	* tp/Texinfo/XS/MiscXS.xs,
	* tp/Texinfo/XS/misc.c (xs_xml_protect_text): New function.
	* tp/Texinfo/Convert/Converter.pm: Override xml_protect_text
	with XS implementation.

2022-06-04  Gavin Smith  <gavinsmith0123@gmail.com>

	texi2any --html performance improvement

	* tp/Texinfo/Convert/HTML.pm (_convert_text):
	Call _default_format_protect_text directly instead of via
	formatting_function, as this is a heavily used function.

	Note: init/html32.pm overrode this function so as not to
	use the &quot entity, so this likely is ineffectual now.

2022-06-04  Gavin Smith  <gavinsmith0123@gmail.com>

	texi2any --html performance improvement

	* tp/Texinfo/Convert/HTML.pm (_convert_text):
	Hard-code access to 'conf' array rather than calling
	get_conf method.  This is a heavily used function.
	Profiled with Devel::NYTProf.

2022-06-03  Gavin Smith  <gavinsmith0123@gmail.com>

	texi2any --html performance improvement

	* tp/Texinfo/Convert/HTML.pm (_convert): Cache debug flag
	as get_conf was being called many times.  Profiled with
	Devel::NYTProf.

2022-06-03  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (HTML Translation): Edit and trim.

2022-06-03  Gavin Smith  <gavinsmith0123@gmail.com>

	Minor manual modernizations

	* doc/texinfo.texi
	(Output Formats): Remove list of browser names.
	(HTML Translation): Remove reference to Lynx, Emacs W3, and
	HTML 1.0.  (Tzvetelin Katchov suggested updating this list.)
	(Output Formats, PDF Output): Remove words "some years ago".
	(Invoking texi2any): Capitalize Cascading Style Sheets.

2022-06-03  Tzvetelin Katchov <katchov@gnu.org>  (tiny change)

	* doc/texinfo.texi (Formay with texi2dvi): remove extra space

2022-06-03  Gavin Smith  <gavinsmith0123@gmail.com>

	Link updates in manual.

	* doc/texinfo.texi
	(Output Formats): Remove obsolete link to XHTML2 Working Group
	page on w3.org.
	(PDF Output): Update link to xpdf homepage.

	Reports from Tzvetelin Katchov <katchov@gnu.org>.

2022-06-01  Patrice Dumas  <pertusus@free.fr>

	Same empty expansion check in perl and XS parser

	* tp/Texinfo/ParserNonXS.pm (_check_empty_expansion, _parse_texi):
	new function _check_empty_expansion based on XS parser function.

2022-06-01  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/Info.pm (output): add missing second
	argument of create_destination_directory().

2022-06-01  Patrice Dumas  <pertusus@free.fr>

	C locale for remaining tests

	* tp/init/tex4ht.pm (tex4ht_process_format): use already
	encoded file name on the command line.

	* tp/tests/many_input_files/input_dir_non_ascii.sh,
	tp/tests/many_input_files/output_dir_file_non_ascii.sh,
	tp/tests/many_input_files/output_dir_non_ascii.sh,
	tp/tests/many_input_files/tex_l2h_output_dir_non_ascii.sh,
	tp/tests/many_input_files/tex_t4ht_output_dir_non_ascii.sh:
	Set LC_ALL to C and LANG to en, both previously
	en_US.UTF-8 (last changed on 2022-02-14).  Set extra variables
	on tests to use UTF-8 encoding where required.
	* tp/tests/tex_html/list-of-tests: Set extra variables on
	tests to use UTF-8 encoding where required.

2022-05-31  Gavin Smith  <gavinsmith0123@gmail.com>

	Documentation of whitespace

	* doc/texinfo.texi (Conventions): Consolidate treatment
	of whitespace characters expanding on ASCII vs. Unicode
	spaces and comment out some excessive detail about
	form feeds.

2022-05-31  Gavin Smith  <gavinsmith0123@gmail.com>

	C locale for some tests

	* tp/tests/run_parser_all.sh: Set LC_ALL to C and LANG to en,
	both previously en_US.UTF-8 (last changed on 2022-02-14).
	* tp/tests/formatting/list-of-tests: Set extra variables on
	tests to use UTF-8 encoding where required.

2022-05-31  Gavin Smith  <gavinsmith0123@gmail.com>

	Consistent test results

	* tp/Texinfo/XS/parsetexi/api.c (element_to_perl_hash):
	Output empty contents array for ET_menu_entry_node, to
	be consistent with pure Perl module.

2022-05-30  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.tex: Give vertical tab the category code
	of a space.

2022-05-30  Patrice Dumas  <pertusus@free.fr>

	* tp/tests/many_input_files/tex_l2h_output_dir_non_ascii.sh,
	tests/many_input_files/tex_t4ht_output_dir_non_ascii.sh:
	Change LC_ALL and LANGUAGE from C.UTF-8 to en_US.UTF-8,
	Gavin idea.

2022-05-29  Gavin Smith  <gavinsmith0123@gmail.com>

	Rename LOCALE_OUTPUT_ENCODING_NAME to MESSAGE_ENCODING. 

	* tp/Texinfo/Common.pm (@variable_string_settables):
	Rename LOCALE_OUTPUT_ENCODING_NAME to MESSAGE_ENCODING. 
	* NEWS, doc/texinfo.texi: Update.

2022-05-29  Gavin Smith  <gavinsmith0123@gmail.com>

	Rename DATA_INPUT_ENCODING_NAME to COMMAND_LINE_ENCODING.

	* NEWS, doc/texinfo.texi: Do the needful.

2022-05-29  Gavin Smith  <gavinsmith0123@gmail.com>

	Rename DATA_INPUT_ENCODING_NAME to COMMAND_LINE_ENCODING.

	* tp/Texinfo/Common.pm (@variable_string_settables):
	Rename DATA_INPUT_ENCODING_NAME to COMMAND_LINE_ENCODING.

2022-05-29  Gavin Smith  <gavinsmith0123@gmail.com>

	* NEWS: Mention DATA_INPUT_ENCODING_NAME.

2022-05-29  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi: Remove link to old SVN repository in comment.

2022-05-08  Gavin Smith  <gavinsmith0123@gmail.com>

	Line breaking fix in test suite

	* tp/tests/coverage_macro.texi:
	Add blank line in attempt to get consistent line breaking
	decisions on Solaris, where wcwidth returns 2 for more characters.

2022-05-08  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/t/plaintext_tests.t (non_break_spaces):
	Skip test on older Perl.

2022-05-07  Gavin Smith  <gavinsmith0123@gmail.com>

	Reinstate empty contents

	Reverse the following change, from 2022-04-20.

	* tp/Texinfo/Common.pm (parse_node_manual), tp/Texinfo/ParserNonXS.pm
	(_isolate_last_space, _parse_node_manual, _end_line, _parse_texi):
	do not set contents for type 'menu_entry_name' and 'menu_entry_node'
	if empty.

	With this reversion, I have run the test suite to pass both under
	TEXINFO_XS=omit and TEXINFO_XS_PARSER=0.

	There were various test failures with TEXINFO_XS=omit and
	TEXINFO_XS_PARSER=0 due to inconsistent results.

	Where an element can have contents, it will be simplest if
	it always has the contents element, as in the C code there
	is no distinction between an empty contents array and no
	contents at all.

2022-05-07  Gavin Smith  <gavinsmith0123@gmail.com>

	Fix segfault for empty contents

	* tp/Texinfo/XS/misc.c (xs_merge_text): Check if the
	contents array was defined.
	* tp/Texinfo/XS/end_line.c (parse_node_manual): Remove confusing
	comment.

	Since recent change, there could be a segfault under
	TEXINFO_XS_PARSER=0 due to the contents array not being defined.

2022-04-20  Patrice Dumas  <pertusus@free.fr>

	Fix both parsers to do the same tree with empty menu entry nodes

	* tp/Texinfo/XS/parsetexi/menus.c
	(register_extra_menu_entry_information): to determine that there
	is no node content returned by parse_node_manual(), check that
	manual_content and node_content fields are both null, as
	parsed_entry_node is never null.  parsed_entry_node cannot be null
	because the return of parse_node_manual() can be used in nodes_manuals
	which is null delimited.

	* tp/Texinfo/Common.pm (parse_node_manual), tp/Texinfo/ParserNonXS.pm
	(_isolate_last_space, _parse_node_manual, _end_line, _parse_texi):
	do not set contents for type 'menu_entry_name' and 'menu_entry_node'
	if empty.

	* tp/Texinfo/ParserNonXS.pm (_register_extra_menu_entry_information):
	do not call Texinfo::Convert::NodeNameNormalization::normalize_node
	to check if node is empty, simply check that it has contents as is
	done in the XS Parser.

2022-04-19  Gavin Smith  <gavinsmith0123@gmail.com>

	vertical tab

	* tp/Texinfo/XS/parsetexi/parser.c
	(whitespace_chars, whitespace_chars_except_newline):
	Add \v in order to be consistent with \s regex class in
	newer Perl.  From Patrice.

2022-04-18  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Structuring.pm (associate_internal_references): check
	reference only if there is a 'node_content'.

2022-04-18  Gavin Smith  <gavinsmith0123@gmail.com>

	Remove special treatment of \r in paragraph formatter

	* tp/Texinfo/Convert/ParagraphNonXS.pm (add_text),
	* tp/Texinfo/XS/xspara.c (xspara_add_text)
	<space not at end of sentence>: Remove special handling of
	carriage return.  The code is somewhat hard to follow and it
	should be unlikely that a carriage return makes it to this code.

2022-04-18  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Structuring.pm (new_node_menu_entry)
	(new_complete_node_menu): handle node with {'extra'}->{'node_content'}
	undef, as happens for node with empty argument.

2022-04-18  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/ParagraphNonXS.pm (add_text): consider \r
	to end a line, as in the XS code.

2022-04-17  Patrice Dumas  <pertusus@free.fr>

	Avoid duplication in @detailmenu master menu output by pod2texi

	* Pod-Simple-Texinfo/pod2texi.pl (_fix_texinfo_tree): call
	Texinfo::Structuring::associate_internal_references() to have
	'normalized' keys set for menu entries.

	* tp/Texinfo/Transformations.pm
	(_normalized_entry_associated_internal_node): add a function for
	similar code.

	* tp/Texinfo/ParserNonXS.pm (_register_extra_menu_entry_information):
	no need to delete menu entry 'normalized' as it is not set.

	* tp/Texinfo/Structuring.pm, tp/Texinfo/ParserNonXS.pm: minor changes
	in code style, comments and POD.

2022-04-14  Gavin Smith  <gavinsmith0123@gmail.com>

	ASCII_PUNCTUATION for some tests

	* tp/tests/layout/list-of-tests
	(formatting_info, formatting_plaintext): Set ASCII_PUNCTUATION for
	these tests in an attempt to make line breaking decisions more
	consistent across platforms in the results.

2022-04-14  Gavin Smith  <gavinsmith0123@gmail.com>

	Change locale for tp/tests

	* tp/tests/many_input_files/input_dir_non_ascii.sh,
	* tp/tests/many_input_files/output_dir_file_non_ascii.sh,
	* tp/tests/many_input_files/output_dir_non_ascii.sh:
	Change LC_ALL and LANGUAGE from C.UTF-8 to en_US.UTF-8.

2022-04-14  Gavin Smith  <gavinsmith0123@gmail.com>

	Change locale for tp/tests

	* tp/tests/run_parser_all.sh: Change LC_ALL and LANGUAGE
	from C.UTF-8 to en_US.UTF-8.  This is an attempt to make the
	tests run on more systems.  On one system without a C.UTF-8
	locale, Perl printed:

	  perl: warning: Setting locale failed.
	  perl: warning: Please check that your locale settings:
	         LC_ALL = "C.UTF-8",
	         LC_COLLATE = "",
	         LC_CTYPE = "",
	         LC_MESSAGES = "",
	         LC_MONETARY = "",
	         LC_NUMERIC = "",
	         LC_TIME = "",
	         LANG = "en_US.UTF-8"
	      are supported and installed on your system.
	  perl: warning: Falling back to the standard locale ("C").

	The previous values were given on 2022-02-22 (not in ChangeLog).

2022-04-14  Gavin Smith  <gavinsmith0123@gmail.com>

	Conditionally skip a test

	* tp/t/test_utils.pl (test): Check for 'skip' setting in options
	and skip test if it is set.
	* tp/t/21multitable.t (multitable_figure_space): Skip test
	for Perl older than 5.14.

2022-04-14  Patrice Dumas  <pertusus@free.fr>

	Improve test results optional output files

	* tp/Texinfo/Convert/HTML.pm (css_get_info): handle undef
	'css_rule_lines' and 'css_import_lines'.

	* tp/t/test_utils.pl: dynamic CSS in HTML preamble.  Other
	cleanups.

2022-04-14  Gavin Smith  <gavinsmith0123@gmail.com>

	Avoid divergent test results due to wcwidth

	* tp/t/plaintext_tests.t,
	* t/input_files/punctuation_small_case_accents_latin1.texi,
	* t/input_files/punctuation_small_case_accents_us_ascii.texi,
	* t/input_files/punctuation_small_case_accents_utf8.texi:
	Add extra blank lines to tests to avoid divergent line wrapping
	on Solaris due to use of en and em dashes in output.

2022-04-14  Gavin Smith  <gavinsmith0123@gmail.com>

	Avoid divergent test results due to wcwidth

	* tp/t/02coverage.t (commands),
	* tp/t/03coverage_braces.t (abbr_acronym):
	Add blank lines in test to avoid divergent line wrapping on Solaris,
	where wcwidth returns 2 instead of 1 for the UTF-8 en dash.  This
	sequence occurs more often in the test results than before since
	ASCII_PUNCTUATION changes on 2021-12-29.

2022-04-14  Gavin Smith  <gavinsmith0123@gmail.com>

	unsigned char for isspace

	* tp/Texinfo/XS/parsetexi/end_line.c (end_line_misc_line),
	* tp/Texinfo/XS/xspara.c (xspara_add_text):
	Cast argument to isspace to unsigned char.  This avoids varying
	test results on Solaris 10 and 11.

2022-04-12  Gavin Smith  <gavinsmith0123@gmail.com>

	CONVERT_TO_LATEX_IN_MATH

	* tp/Texinfo/Common.pm (@variable_string_settables):
	Rename CONVERT_TEXINFO_MATH_TO_LATEX to CONVERT_TO_LATEX_IN_MATH.
	* NEWS, doc/texinfo.texi: Update.

2022-04-11  Gavin Smith  <gavinsmith0123@gmail.com>

	* install-info/tests/defs.in, util/texi2dvi:
	Assign EGREP variable using quotes for better
	shell portability.

2022-04-11  Gavin Smith  <gavinsmith0123@gmail.com>

	grep instead of List::Util::any

	* tp/Texinfo/Transformations.pm (_reassociate_to_node):
	Use grep operator instead of List::Util::any in an attempt
	to be compatible with older Perls.  Reverses change on
	Mon Jan 3 21:15:21 2022 +0100 (not in ChangeLog).

2022-04-11  Gavin Smith  <gavinsmith0123@gmail.com>

	use re '/a';

	* tp/Texinfo/ParserNonXS.pm, tp/Texinfo/Convert/Plaintext.pm, 
	tp/Texinfo/Convert/ParagraphNonXS.pm, tp/Texinfo/Convert/HTML.pm:
	Add a use directive turning on /a flag for regexes.  Make it
	conditional on using at least Perl 5.14, when this flag was
	introduced. Remove /a flags from regexes throughout.
	* tp/Texinfo/Convert/HTML.pm (_convert_printindex_command):
	Use \p{Alpha} instead of [[:alpha:]].
	* tp/Texinfo/Convert/Plaintext.pm (_convert):
	Use \p{Upper} instead of [[:upper:]].

	This is intended to increase compatibility with older Perls.

2022-04-11  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (The Top Node):
	Avoid unnecessary non-ASCII quotes in Info index.

2022-04-11  Gavin Smith  <gavinsmith0123@gmail.com>

	wrapper for asprintf

	* info/util.c (xasprintf): New function to wrap asprintf and
	avoid compiler warnings due to unused return values.  Use everywhere.

2022-04-11  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi
	(HTML Customization Variables) <CONVERT_TEXINFO_MATH_TO_LATEX>:
	Elaborate slightly.

2022-04-11  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Invoking texi2any)
	(Customization Variables and Options, Other Customization Variables):
	Refer to the program consistently as texi2any rather than makeinfo
	throughout the chapter.

2022-04-11  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Texinfo Mode Summary): Remove text implying
	that makeinfo is written in C.

2022-04-10  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Using texinfo-show-structure):
	Remove duplicate index entry.

2022-04-10  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Using texinfo-show-structure, Using occur):
	Subordinate to Showing the Structure.
	(Catching Mistakes): Delete extraneous text.

2022-04-10  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Info Formatting): Remove documentation
	that is duplicated elsewhere.

2022-04-10  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Creating an Info File):
	Remove node.  Replace links to this node.
	(makeinfo in Emacs, texinfo-format commands):
	Subordinate to Info Formatting node in appendix.

2022-04-10  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi: Comment out credit for cover art, which
	is not included in this version of the manual.

2022-04-10  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Tag and Split Files): Move up a level.
	(Info Formatting): Remove an unnecessary cross-reference.

2022-04-10  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Catching Mistakes): Lower all section
	commands a level and remove use of @lowersections/@raisesections.

2022-04-10  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Batch Processing):
	Move node to Texinfo mode appendix.
	(Creating an Info File): Remove unnecessary cross-reference.

2022-04-10  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (makeinfo Advantages): Remove node.
	(Info Formatting): Move some text here.
	(Printing): Delete a useless comment.

2022-04-10  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.tex: Remove or disambiguate many duplicate
	index entries to ease lookup.
	(Invoking texi2any): List latex as a permissible value of
	TEXINFO_OUTPUT_FORMAT.

2022-04-10  Gavin Smith  <gavinsmith0123@gmail.com>

	* README-hacking: Add note to check for index duplicates.

2022-04-10  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Conditional Commands, Conditional Not Commands)
	(Raw Formatter Commands, Inline Conditionals):
	Document conditionals for LaTeX.
	(Raw Formatter Commands): Revise node.  Remove duplicate @ifhtml etc.
	index entries.

2022-04-10  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.tex (@iflatex, @ifnotlatex, @latex): Implement.

2022-04-10  Gavin Smith  <gavinsmith0123@gmail.com>

	<code> for @verb

	* tp/Texinfo/Convert/HTML.pm (%style_attribute_commands):
	Output @verb with <code> instead of <tt>.
	* NEWS: Mention.

	@verb is a rarely used command and this was one of the last uses
	of non-HTML5 tags.

2022-04-10  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Fonts): More on possible uses for @t.
	Comment out rationale for longer command names.

2022-04-10  Gavin Smith  <gavinsmith0123@gmail.com>

	* NEWS: Revise.
	* TODO: Remove entry about reference card creation as nobody is
	likely to ask about this.

2022-04-09  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/DocBook.pm (_convert), tp/Texinfo/Convert/HTML.pm
	(_convert_heading_command), tp/Texinfo/Convert/LaTeX.pm (output)
	(_convert): stop skipping node Top output at a @part.

	* tp/Texinfo/Convert/DocBook.pm (_convert): process non output commands
	when skipping Top node, in particular put the same lang on top of
	lang_stack.

2022-04-09  Gavin Smith  <gavinsmith0123@gmail.com>

	user- prefix for @example args

	* tp/Texinfo/Convert/HTML.pm (_convert_preformatted_command):
	Prefix HTML class name from @example arg with 'user-'.
	* doc/texinfo.texi (@example): Document.
	* NEWS: Edit and update.

2022-04-09  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.tex (\domultitable): Zero \rightskip but keep
	stretch.  This is intended to allow @multitable to be nested
	inside @quotation, the formatting of which was broken by change
	on 2022-04-04 for @raggedright.  Report from Werner.
	* doc/texinfo-tex-test.texi (@multitable): Add test case.

2022-04-08  Gavin Smith  <gavinsmith0123@gmail.com>

	Avoid undefined hash key access in get_file_information

	* tp/Texinfo/Convert/HTML.pm (get_file_information):
	Account for the possibility that there is no current filename.
	This is the case when node redirection pages are being output.
	Use filename argument as intended.

	Many errors were printed when "make -C doc wwwdoc-build" was done.

2022-04-08  Gavin Smith  <gavinsmith0123@gmail.com>

	Msys2 OS detection in texi2dvi

	* util/texi2dvi: Do not set MSYSTEM via OSTYPE environment
	variable before calling uname, as this is not working on
	Msys2.  Reverses change on 2015-09-23.  Instead, check the value of
	OSTYPE directly as well as calling uname.

	Report and testing by Tomas Kalibera <tomas.kalibera@gmail.com>.

2022-04-08  Gavin Smith  <gavinsmith0123@gmail.com>

	Fix MathJax referencing in docs build.

	* doc/Makefile.am (wwwdoc-build): Set MATHJAX_SCRIPT and
	MATHJAX_SOURCE to absolute URLs rather than relative paths.
	This means that gendocs.sh produces working references in
	both split and non-split output.
	* README-hacking: Update.

2022-04-08  Gavin Smith  <gavinsmith0123@gmail.com>

	* README-hacking: Mention infog subdirectory.

2022-04-04  Gavin Smith  <gavinsmith0123@gmail.com>

	Fix @multitable inside @raggedright

	* doc/texinfo.tex (\domultitable): Do not set \rightskip to 0pt
	as this interferes with the \rightskip setting in @raggedright.
	* doc/texinfo-tex-test.texi (@multitable): Add test case.

	Werner Lemberg reported that @multitable inside @raggedright led
	to 'Underful \hbox' warnings.

2022-04-04  Patrice Dumas  <pertusus@free.fr>

	Update po files

	* po/Makevars (XGETTEXT_OPTIONS): add --from-code=UTF-8 for
	tp/init/epub3.pm which has still an encoded character in a comment.

	* tp/init/epub3.pm: remove an encoded character in a comment.

2022-04-04  Gavin Smith  <gavinsmith0123@gmail.com>

	* po/POTFILES.in: Update.

2022-03-20  Patrice Dumas  <pertusus@free.fr>

	@part without sectioning command associated with following node

	* tp/Texinfo/ParserNonXS.pm (_end_line),
	tp/Texinfo/XS/parsetexi/end_line.c (end_line_misc_line),
	tp/Texinfo/Convert/DocBook.pm (_convert), tp/Texinfo/Convert/HTML.pm
	(_convert_heading_command), tp/Texinfo/Convert/LaTeX.pm (output)
	(_convert), tp/Texinfo/Structuring.pm (split_by_node):
	Add extra key 'node_preceding_part' to a @part tree element
	followed directly by a node and 'part_following_node' to the node.
	When ignoring Top node content use part_following_node information
	to group a part before a node with the node.
	In split_by_node() associate a part with the following sectioning
	command or node tree unit.

2022-03-20  Gavin Smith  <gavinsmith0123@gmail.com>

	* TODO.HTML: Update to state location where HTML files are
	sought.

2022-03-20  Gavin Smith  <gavinsmith0123@gmail.com>

	* util/texi2dvi (xref_file_p): Remove unused.

2022-03-20  Gavin Smith  <gavinsmith0123@gmail.com>

	* util/texi2dvi (list_dir_to_abs):
	Remove unused function (not used since the code was added
	in 2005-11-18.)

2022-03-18  Gavin Smith  <gavinsmith0123@gmail.com>

	Handle index entries beginning (

	* info/scan.c (scan_reference_label): If label is in an index, do
	not check for a bracketed filename.  This supports index entries
	beginning with a '(' character.  This should allow practically
	any character to appear anywhere in an index entry.
	* info/t/index-paren.sh: New test.
	* info/t/README: Edit.

2022-03-16  Gavin Smith  <gavinsmith0123@gmail.com>

	Move functions between files

	* info/scan.c, info/util.c (ansi_escape, printed_representation):
	Move to util.c.

2022-03-16  Gavin Smith  <gavinsmith0123@gmail.com>

	Rename info/info-utils.c

	* info/info-utils.c, info/scan.c: Rename file.

2022-03-16  Gavin Smith  <gavinsmith0123@gmail.com>

	Split info/info-utils.c

	* info/info-utils.c, info/util.c:
	(file_buffer_of_window, node_printed_rep, filename_non_directory)
	(internal_info_node_p, name_internal_node, get_internal_info_window)
	(text_buffer_init, text_buffer_free, text_buffer_vprintf)
	(text_buffer_alloc, text_buffer_space_left, text_buffer_iconv)
	(text_buffer_add_string, text_buffer_fill, text_buffer_add_char)
	(text_buffer_printf, fncmp):
	New file util.c to hold some of the functions from info-utils.c.
	Include new header file where required.

2022-03-16  Gavin Smith  <gavinsmith0123@gmail.com>

	Move functions

	* info/info-utils.c, info/session.c
	(struct info_namelist_entry, info_namelist_add, info_namelist_free):
	Move to session.c as this is the only place these are used.

2022-03-13  Gavin Smith  <gavinsmith0123@gmail.com>

	Top node ends at @part.

	* doc/texinfo.tex (\ignorenode): Stop ignoring Top node at a
	@part line, in case one immediately follows the Top node.  Report
	from Patrice.

2022-03-13  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/DocBook.pm (convert, output): call convert_tree()
	instead of convert_document_sections().

2022-03-13  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/DocBook.pm (_convert): start a sectioning
	command associated with both a part and a node with the first
	appearing.  Do not add partinfo if the part is associated with a
	sectioning command, the content of the part will be at the beginning
	of the sectioning command.  This is erroneous to have non empty part
	anyway.

2022-03-12  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/DocBook.pm (_convert): open the @path associated
	to a sectioning command right before opening the sectioning command.

2022-03-12  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/DocBook.pm (convert, output, _convert): close
	sectioning command where the tree element is closed, not based on
	the unit element, in order to have the top level elements processed
	in the right order.
	Fix and simplify the code related to in_skipped_node_top, to not
	output Top node.

2022-03-12  Patrice Dumas  <pertusus@free.fr>

	Do not output Top node in DocBook

	* NEWS, doc/texinfo.texi (The Top Node, HTML Customization Variables)
	(Other Customization Variables), tp/Texinfo/Convert/DocBook.pm
	(%defaults, _convert): do not output Top node in DocBook.  If
	NO_TOP_NODE_OUTPUT is set to false, the Top node is output.  This
	possibility may be temporary.

2022-03-11  Patrice Dumas  <pertusus@free.fr>

	Do not output text before node or sections in DocBook

	* NEWS, doc/texinfo.texi (First Node), tp/Texinfo/Convert/DocBook.pm
	(_convert): do not output text before the first @node or sectioning
	command, in 'before_node_section' element type.

2022-03-11  Patrice Dumas  <pertusus@free.fr>

	* doc/texinfo.texi @code{@@settitle}): no title in the
	document anymore in the default case in HTML.

2022-03-11  Patrice Dumas  <pertusus@free.fr>

	* NEWS, doc/texinfo.texi (HTML Customization Variables)
	(Other Customization Variables), tp/Texinfo/Convert/HTML.pm
	(%defaults, output, _set_variables_texi2html): set SHOW_TITLE
	to undef, and have NO_TOP_NODE_OUTPUT set SHOW_TITLE to 1
	if SHOW_TITLE is undef.  Set USE_TITLEPAGE_FOR_TITLE to 1.
	That way, there is no title in the default case, as it is
	redundant with the @top header, there is a title only if
	NO_TOP_NODE_OUTPUT is set.

2022-03-10  Patrice Dumas  <pertusus@free.fr>

	* doc/texinfo.texi (Other Customization Variables): expand
	on NO_TOP_NODE_OUTPUT corresponding more to book formatting
	if set, or to browsing if not set.

2022-03-10  Patrice Dumas  <pertusus@free.fr>

	* tp/tests/Makefile.am (input_file_names_recoded_stamp.txt):
	record in the file if the recoding succeeded or failed.

	* tp/tests/run_parser_all.sh: if 'Need recoded file names'
	appears on a test line, skip the test if the recoding of
	file names failed.

	* tp/tests/run_parser_all.sh: if a prerequisite for a test is
	missing, such as not recoded file names needed, or latex2html
	or tex4ht not present, and only one test is run, return 77 to
	have the test marked as skipped instead of succeeding.

2022-03-10  Patrice Dumas  <pertusus@free.fr>

	* tp/tests/Makefile.am (check_DATA): copy and change file name
	encoding from utf8 to latin1 for latin1 encoded file name for tests.

2022-03-10  Patrice Dumas  <pertusus@free.fr>

	Add NO_TOP_NODE_OUTPUT to discard Top node for "book like" styles

	* NEWS, doc/texinfo.texi (Other Customization Variables),
	tp/Texinfo/Common.pm (@variable_string_settables),
	tp/Texinfo/Convert/HTML.pm (%defaults, _convert_heading_command)
	(output), tp/init/book.pm, tp/init/epub3.pm: add NO_TOP_NODE_OUTPUT
	customization variable.  If set, the Top node content output is
	discarded.  If set and USE_TITLEPAGE_FOR_TITLE is undef (the default
	now), set USE_TITLEPAGE_FOR_TITLE.  Set NO_TOP_NODE_OUTPUT in
	tp/init/book.pm and tp/init/epub3.pm.

2022-03-09  Gavin Smith  <gavinsmith0123@gmail.com>

	Document index node name requirement

	* doc/texinfo.texi (Printing Indices & Menus): Document
	requirement for "Index" to appear in node name.  Edit and
	trim extraneous language.
	(Advanced Indexing): Edit slightly.

2022-03-09  Gavin Smith  <gavinsmith0123@gmail.com>

	Find first index entry under initial substring search

	* info/indices.c (next_index_match): Reset index search by
	setting index to -1 index instead of 0.  Otherwise the first
	index entry is skipped when checking for initial substrings.
	The very first index entry in an Info file would not be found
	with a non-exact search.

	Report from Sergey Matveev <stargrave@stargrave.org>.

2022-03-06  Patrice Dumas  <pertusus@free.fr>

	* tp/init/latex2html.pm (l2h_process, l2h_to_html)
	(l2h_change_image_file_names, l2h_finish, l2h_from_cache): do
	not use a volume, consistently with the HTML converter.
	Do not force encoding variables to UTF-8, but instead encode
	separately the directory as in the HTML Converter and the files
	related to latex2html in UTF-8, such that the files output by
	latex2html only contains UTF-8.  Also encode separately
	the file names in the latex2html command line and the remaining
	of the command line.  Based on Gavin report.

2022-03-06  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/TODO: Move winning latex2html test cases.

2022-03-06  Gavin Smith  <gavinsmith0123@gmail.com>

	Attempt to fix latex2html init file under Latin-1 locale

	* tp/init/latex2html.pm: Force several encoding variables to
	UTF-8.  Otherwise incorrect image paths are used in the output file.

2022-03-06  Gavin Smith  <gavinsmith0123@gmail.com>

	Fix latex2html init file under Latin-1 locale

	* tp/init/latex2html.pm (l2h_change_image_file_name):
	Hardcode the use of UTF-8 to encode image file names, as the
	calling code in l2h_init_from_html set a ':utf8' filter on the
	file the file names were taken from.  Call File::Spec->catpath
	on already-encoded strings rather than encoding afterwards.

2022-03-06  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Common.pm (%default_parser_common_customization):
	set DOC_ENCODING_FOR_INPUT_FILE_NAME as a parser customization
	variable.  Report from Gavin.

2022-03-06  Patrice Dumas  <pertusus@free.fr>

	Document that some functions are getting or returning binary strings

	* doc/customization_api.texi (Dynamic Converter Formatting
	Information): update html_image_file_location_name() returned
	values documentation.

	* tp/Texinfo/Common.pm: change variable names, document in
	comments which strings are binary strings.

2022-03-06  Patrice Dumas  <pertusus@free.fr>

	* doc/texinfo.texi (Other Customization Variables), NEWS: document
	DATA_INPUT_ENCODING_NAME, DOC_ENCODING_FOR_INPUT_FILE_NAME,
	DOC_ENCODING_FOR_OUTPUT_FILE_NAME, LOCALE_INPUT_FILE_NAME_ENCODING,
	LOCALE_OUTPUT_FILE_NAME_ENCODING and LOCALE_OUTPUT_ENCODING_NAME.

2022-03-06  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/Texinfo/Convert/Converter.pm (determine_files_and_directory):
	Use '?' as replacement character when decoding input filename.

2022-03-06  Patrice Dumas  <pertusus@free.fr>

	Decode init file names in messages

	* tp/Texinfo/Config.pm (_GNUT_decode_input, GNUT_load_init_file),
	tp/texi2any.pl (locate_and_load_init_file): add _GNUT_decode_input()
	in Texinfo::Config duplicating _decode_input() from texi2any.pl.
	Decode init file names in messages both in texi2any.pl and
	Texinfo::Config.

	Changes in comments in other files.

2022-03-05  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/init/latex2html.pm (l2h_to_html): Do not call
	encoded_input_file_name with an undefined or empty argument.

2022-03-05  Gavin Smith  <gavinsmith0123@gmail.com>

	Fix man page bold, italic, underline for Debian man

	* info/man.c (get_manpage_from_formatter): Set MAN_KEEP_FORMATTING=1
	and GROFF_SGR=1 in environment.
	* doc/info-stnd.texi (Invoking Info) <-R>: Comment out text about
	GROFF_SGR as it is hardcoded now.

2022-03-05  Patrice Dumas  <pertusus@free.fr>

	Encode file names in Parser and Text Converter

	* tp/Texinfo/Common.pm (%default_parser_common_customization),
	tp/Texinfo/ParserNonXS.pm (parse_texi_file),
	tp/Texinfo/XS/parsetexi/Parsetexi.pm (parser, parse_texi_file):
	add DATA_INPUT_ENCODING_NAME as a Parser configuration variable
	and use it to decode the file name in error message for not
	opened input file.

	* tp/Texinfo/Convert/Converter.pm (encoded_output_file_name),
	tp/Texinfo/Convert/Text.pm (converter, output, set_conf),
	tp/Texinfo/Convert/Utils.pm (encoded_output_file_name):
	move encoded_output_file_name from Texinfo::Convert::Converter
	to Texinfo::Convert::Utils, but keep a wrapper to be able
	to call the function from converters in object oriented style.
	in Texinfo::Convert::Text, call set_output_encodings,
	encoded_output_file_name, decode command line strings and encode 
	file names and output file contents.  Define set_conf() for
	Texinfo::Common::set_output_encodings() call.

2022-03-05  Patrice Dumas  <pertusus@free.fr>

	Pass created directory charcter string for error messages

	* tp/Texinfo/Convert/Converter.pm (create_destination_directory):
	add an argument for created directory name as character string for
	use in error message.

2022-03-05  Patrice Dumas  <pertusus@free.fr>

	Encode more file names for epub

	* tp/init/epub3.pm: set OUTPUT_ENCODING_NAME and
	LOCALE_OUTPUT_FILE_NAME_ENCODING to utf-8 as mandated by the
	specification.

	* tp/init/epub3.pm (epub_setup, epub_finish): encode file and
	directory names.  Check more errors from Archive::Zip.

2022-03-04  Gavin Smith  <gavinsmith0123@gmail.com>

	File name encoding variables for XS parser

	* tp/Texinfo/XS/parsetexi/input.c
	(doc_encoding_for_input_file_name, locale_input_file_name_encoding):
	Put these variables in this file, to represent
	DOC_ENCODING_FOR_INPUT_FILE_NAME and LOCALE_OUTPUT_ENCODING_NAME.
	(encode_file_name): Obey these variables as is done in ParserNonXS.pm.

	* tp/Texinfo/XS/parsetexi/api.c (reset_parser): Reset both of these
	variables.
	(set_DOC_ENCODING_FOR_INPUT_FILE_NAME): Renamed and moved function.

2022-03-03  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/Texinfo/XS/parsetexi/input.c (set_input_encoding): Reset
	reverse_iconv conversion used in encode_name.  Report from Patrice.

2022-03-03  Gavin Smith  <gavinsmith0123@gmail.com>

	* NEWS: List new customization variables for filename encoding.

2022-03-02  Gavin Smith  <gavinsmith0123@gmail.com>

	Fix #line directive early in file.

	* tp/Texinfo/XS/parsetexi/input.c (input_pushback): New function.
	(next_text): Return string passed to input_pushback before any
	other input.
	* tp/Texinfo/XS/parsetexi/parser.c (parse_texi_document): Call
	input_pushback after collecting 'preamble_before_beginning' element.
	This preserves the source line information when a #line directive
	appears immediately after the \input line.

2022-03-01  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/Info.pm (output): encode directory name
	before creating.

2022-03-01  Gavin Smith  <gavinsmith0123@gmail.com>

	Encoding of #line argument in XS parser.

	* tp/Texinfo/XS/parsetexi/input.c (encode_file_name): Save
	return value with save_string.
	* tp/Texinfo/XS/parsetexi/end_line.c (end_line_misc_line):
	Update call to encode_file_name.
	* tp/Texinfo/XS/parsetexi/input.c (save_line_directive):
	Call encode_file_name on argument. Do not save reference to
	argument.
	* tp/Texinfo/XS/parsetexi/parser.c (check_line_directive):
	Update code calling save_line_directive so not to allocate
	unneeded string.

	Patrice reported that encode_file_name should be used here.

2022-03-01  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/HTML.pm (_parse_htmlxref_files)
	(_load_htmlxref_files, _prepare_css): decode file names for messages,
	encode file names for filesystem access.  Other minor changes in the
	code.

	* tp/Texinfo/Convert/HTML.pm (_parse_htmlxref_files, _process_css_file)
	(output), tp/Texinfo/Convert/Info.pm (output), tp/Texinfo/Report.pm
	(line_warn, line_error), tp/texi2any.pl: use
	Texinfo::Report::line_warn instead of Texinfo::Report::file_line_warn
	and similarly for error, by setting up $error_location_info using the
	file name and line number.

2022-03-01  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/ParserNonXS.pm (parse_texi_file, _save_line_directive)
	(_next_text, _end_line): use a structure similar with source_info
	within the input for the current file informations. Like in the XS
	parser.  Add the information on the @include file name encoding.
	Use this information to decode the file name in an error message.

	* tp/Texinfo/XS/parsetexi/Parsetexi.pm (parse_texi_line): reindent.

2022-03-01  Patrice Dumas  <pertusus@free.fr>

	Rename line_nr as source_info except when a line number

	* tp/Texinfo/Convert/Converter.pm, tp/Texinfo/Convert/DocBook.pm,
	tp/Texinfo/Convert/HTML.pm, tp/Texinfo/Convert/Info.pm,
	tp/Texinfo/Convert/NodeNameNormalization.pm,
	tp/Texinfo/Convert/Plaintext.pm, tp/Texinfo/Convert/Utils.pm,
	tp/Texinfo/ParserNonXS.pm, tp/Texinfo/Report.pm,
	tp/Texinfo/Structuring.pm, tp/Texinfo/Transformations.pm,
	tp/Texinfo/XS/parsetexi/Parsetexi.pm, tp/Texinfo/XS/parsetexi/api.c,
	tp/Texinfo/XS/parsetexi/end_line.c, tp/Texinfo/XS/parsetexi/errors.c,
	tp/Texinfo/XS/parsetexi/handle_commands.c,
	tp/Texinfo/XS/parsetexi/input.c (current_source_info),
	tp/Texinfo/XS/parsetexi/macro.c, tp/Texinfo/XS/parsetexi/menus.c,
	tp/Texinfo/XS/parsetexi/parser.c, tp/Texinfo/XS/parsetexi/separator.c,
	tp/Texinfo/XS/parsetexi/tree_types.h (SOURCE_INFO):
	rename line_nr variables and structures as source_info.
	rename global line_nr as current_source_info in XS parser.
	rename the LINE_NR type as SOURCE_INFO.

	* tp/Texinfo/Report.pm: change in spacing.

2022-02-28  Patrice Dumas  <pertusus@free.fr>

	Allow customization of input file name and output file name encoding

	* tp/Texinfo/Common.pm, tp/Texinfo/Convert/Converter.pm
	(encoded_input_file_name, encoded_output_file_name),
	tp/Texinfo/Convert/Utils.pm (expand_verbatiminclude),
	tp/Texinfo/ParserNonXS.pm (_encode_file_name),
	tp/Texinfo/XS/parsetexi/Parsetexi.pm (parser),
	tp/Texinfo/XS/parsetexi/Parsetexi.xs, tp/Texinfo/XS/parsetexi/api.c,
	tp/Texinfo/XS/parsetexi/conf.c
	(conf_set_DOC_ENCODING_FOR_INPUT_FILE_NAME)
	(set_locale_input_file_name_encoding), tp/texi2any.pl: 
	rename customization variable
	MESSAGE_OUTPUT_ENCODING_NAME as LOCALE_OUTPUT_ENCODING_NAME.
	Add DOC_ENCODING_FOR_INPUT_FILE_NAME,
	DOC_ENCODING_FOR_OUTPUT_FILE_NAME,
	LOCALE_INPUT_FILE_NAME_ENCODING, LOCALE_OUTPUT_FILE_NAME_ENCODING.
	separate functions for input and output file names and use
	the customization variables to determine if @documentencoding
	is used or locale encoding.  In the default case, the locale
	encoding is used for output, the @documentencoding for input, except
	on windows.

2022-02-28  Patrice Dumas  <pertusus@free.fr>

	Decode/encode fixes

	* tp/Texinfo/Convert/HTML.pm (output): set 'destination_directory'
	global info to a decoded string.

	* tp/Texinfo/Convert/HTML.pm (html_image_file_location_name):
	return the image path encoding.

	* tp/init/epub3.pm, tp/init/latex2html.pm, tp/init/tex4ht.pm:
	more decoding/encoding fixes.

2022-02-27  Patrice Dumas  <pertusus@free.fr>

	Output and read latex2html files in utf-8

	* tp/init/latex2html.pm: read and write files as utf-8, which
	is in line with what is output or expected by latex2html.

2022-02-27  Patrice Dumas  <pertusus@free.fr>

	Encode file names when needed

	* tp/DebugTexinfo/DebugTree.pm (output),
	tp/Texinfo/Convert/Converter.pm (output), 
	tp/Texinfo/Convert/DocBook.pm (output),
	tp/Texinfo/Convert/HTML.pm (output),
	tp/Texinfo/Convert/IXIN.pm (output_ixin),
	tp/Texinfo/Convert/Info.pm (output, _register_closed_info_file),
	tp/Texinfo/Convert/LaTeX.pm (output),
	tp/Texinfo/Convert/TexinfoXML.pm (output),
	tp/init/chm.pm, tp/init/epub3.pm, tp/init/highlight_syntax.pm,
	tp/init/latex2html.pm, tp/init/tex4ht.pm, tp/texi2any.pl:
	encode file names and command calls when needed.
	In texi2any.pl, decode INTERNAL_LINKS and MACRO_EXPAND for
	error message.

	* tp/Texinfo/Convert/Converter.pm (output_no_split): remove.

	* tp/DebugTexinfo/DebugTree.pm: general improvements.

2022-02-27  Patrice Dumas  <pertusus@free.fr>

	Decode more inputs as perl character strings

	* tp/Texinfo/Convert/Converter.pm (determine_files_and_directory):
	do not encode setfilename, instead decode input file name.
	* tp/Texinfo/Convert/HTML.pm (html_image_file_location_name):
	do not return the encoded file name.
	* tp/Texinfo/Convert/HTML.pm (encoded_file_name): call
	encoded_file_name to encode file name just before calling
	output_files_open_out().


2022-02-26  Gavin Smith  <gavinsmith0123@gmail.com>

	Attempt to fix copying image for epub3 test

	* tp/Texinfo/Convert/HTML.pm (html_image_file_location_name):
	Use the return value from Texinfo::Common::encode_file_name
	for the image file name.
	* tp/tests/formatting/list-of-tests (non_ascii_test_epub):
	Enable test and commit results.

2022-02-26  Gavin Smith  <gavinsmith0123@gmail.com>

	Encode @setfilename argument

	* tp/Texinfo/Convert/Converter.pm (determine_files_and_directory):
	Call Texinfo::Common::encode_file_name on @setfilename argument.

	This mean that @setfilename works properly for a
	'@documentencoding ISO-8859-1' and also means that
	the OUTDIR customization variable works correctly.

2022-02-24  Gavin Smith  <gavinsmith0123@gmail.com>

	UTF-8 flag on strings for XS parser

	* tp/Texinfo/XS/parsetexi/api.c (newSVpv_utf8): New function.
	(element_to_perl_hash, build_single_index_data, build_line_nr_hash)
	(convert_error): Use it in many more places where the string being
	created should be "Perl-internal".  Suggestion from Patrice.

2022-02-24  Patrice Dumas  <pertusus@free.fr>

	One function in Texinfo::Common to handle file name encoding

	* tp/Texinfo/Common.pm (encode_file_name),
	tp/Texinfo/Convert/Converter.pm (encoded_file_name),
	tp/Texinfo/Convert/DocBook.pm, tp/Texinfo/Convert/HTML.pm,
	tp/Texinfo/Convert/IXIN.pm, tp/Texinfo/Convert/Info.pm,
	tp/Texinfo/Convert/LaTeX.pm, tp/Texinfo/Convert/Utils.pm
	(expand_verbatiminclude), tp/Texinfo/ParserNonXS.pm: put the
	main function encode_file_name() doing file name encoding
	in Texinfo::Common and use encoded_file_name for Converters.
	Return the file name encoding if there is a need to decode
	the file name for error messages.

	* tp/Texinfo/ParserNonXS.pm (_save_line_directive): encode CPP
	line directive file name.

2022-02-24  Gavin Smith  <gavinsmith0123@gmail.com>

	Include file name encoding for XS parser

	* tp/Texinfo/XS/parsetexi/input.c
	(set_input_encoding): Save input encoding name.
	(encode_file_name): New function to re-encode using the input
	encoding.
	(encode_with_iconv): Split out from convert_to_utf8.

	* tp/Texinfo/XS/parsetexi/end_line.c (end_line_misc_line):
	Call it before calling locate_include_file.

	Suggestion from Patrice.

2022-02-24  Gavin Smith  <gavinsmith0123@gmail.com>

	Fix XS configure check

	* tp/Texinfo/XSLoader.pm: Put 'require Texinfo::ModulePath'
	inside an eval block and provide default values if the module
	wasn't loaded successfully.  This will be the case for the
	configure check using TestXS.pm.  Report from Patrice.

2022-02-23  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Common.pm (locate_include_file),
	tp/Texinfo/Convert/Converter.pm (encode_file_name, txt_image_text),
	tp/Texinfo/Convert/DocBook.pm (_convert),
	tp/Texinfo/Convert/HTML.pm (html_image_file_location_name),
	tp/Texinfo/Convert/IXIN.pm (output_ixin),
	tp/Texinfo/Convert/Info.pm (format_image),
	tp/Texinfo/Convert/LaTeX.pm (_convert),
	tp/Texinfo/Convert/Utils.pm (expand_verbatiminclude),
	tp/Texinfo/ParserNonXS.pm (_end_line): encode file name before
	calling locate_include_file() in order to be able to pass file
	names already encoded (case of CSS_FILES) and find the information
	in different structures in converters and NonXS Parser.
	Note in comments that no information source is available in
	Texinfo/Convert/Utils.pm expand_verbatiminclude().

2022-02-23  Gavin Smith  <gavinsmith0123@gmail.com>

	Recode filenames into input encoding

	* tp/Texinfo/Common.pm (locale_include_file): Recode
	the filename into the input encoding even if it is not UTF-8.

2022-02-23  Gavin Smith  <gavinsmith0123@gmail.com>

	Get errors from XS code without using eval

	* tp/Texinfo/XS/parsetexi/api.c, tp/Texinfo/XS/parsetexi/Parsetexi.xs
	(get_errors): New function to create error list.
	* tp/Texinfo/XS/parsetexi/errors.c (dump_errors): Function removed.
	* tp/Texinfo/XS/parsetexi/Parsetexi.pm: Call it to get the errors
	and warnings from the XS module.

	This allows better control of string encodings for messages
	and filenames.  It may also be faster than calling eval.

2022-02-23  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/XS/parsetexi/Parsetexi.pm (_get_errors): encode
	file name for consistency with file names being bytes, as a temporary
	measure before a better interface is implemented.

	* tp/Texinfo/Report.pm: rename variables.

2022-02-22  Patrice Dumas  <pertusus@free.fr>

	Decode inputs for encoded characters

	* doc/texinfo.texi (HTML CSS), tp/Texinfo/Convert/HTML.pm
	(_process_css_file): process @charset to get the encoding, and use
	utf-8 as default as described.

	* tp/texi2any.pl: decode more input from command line that are
	combined with messages or strings from document.
	Import Encode symbols explicitly.

2022-02-22  Gavin Smith  <gavinsmith0123@gmail.com>

	Avoid double encoding error messages with XS parser

	* tp/Texinfo/XS/parsetexi/Parsetexi.pm (_get_errors): Call
	utf8::decode before eval-ing error message output from XS parser.

2022-02-22  Gavin Smith  <gavinsmith0123@gmail.com>

	Fix test failures under non-English locale

	* tp/t/test_parse_texi_line.t, tp/t/test_parser_registrar.t:
	Set LC_ALL and LANGUAGE for consistent error messages.

2022-02-22  Gavin Smith  <gavinsmith0123@gmail.com>

	Always use installed translated messages

	* tp/Texinfo/XS/parsetexi/api.c (init),
	* tp/texi2any.pl: Unconditionally use installed messages regardless
	of whether the program is installed or not.  Although it would be
	better to use uninstalled messages for this, this hasn't been
	implemented, and having access to translated messages when uninstalled
	will make testing the translations easier.  Remove reference to
	a non-existent 'maintain/regenerate_perl_module_files.sh' script.

2022-02-22  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/Texinfo/ModulePath.pm.in: Add a comment warning against
	using the module more than once.

2022-02-22  Gavin Smith  <gavinsmith0123@gmail.com>

       Fix translation of messages with XS modules

       * tp/Texinfo/XSLoader.pm: require rather than use Texinfo::ModulePath
       to prevent initialization being done again, incorrectly.  This led
       to incorrect locale dirs being used due to
       $Texinfo::ModulePath::texinfo_uninstalled being reset.

2022-02-22  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/XS/parsetexi/api.c (build_texinfo_tree): return
	an empty element instead of segfaulting if build_texinfo_tree()
	is called without any Root set, although this should never happen
	with the current code.

2022-02-22  Gavin Smith  <gavinsmith0123@gmail.com>

	Avoid segfault in XS code for missing input file

	* tp/Texinfo/XS/parsetexi/api.c (parse_file): Correctly propagate
	return value of file open.

2022-02-21  Patrice Dumas  <pertusus@free.fr>

	* tp/texi2any.pl (handle_errors): print line_nr if 0. Although
	it should not happen in practice.

	* tp/t/test_parse_texi_line.t, tp/t/test_parser_registrar.t,
	tp/t/test_protect_hashchar_at_line_beginning.t: check line error
	messages line numbers.

2022-02-21  Gavin Smith  <gavinsmith0123@gmail.com>

	No encoding for filenames in error messages.

	* tp/Texinfo/Report.pm (line_warn, line_error):
	Do not prepend filename or line number to error messages.
	* tp/texi2any.pl (handle_errors): Do it here, without encoding
	the filename.  Handle stripping directories from the filenames
	for the test suite here.
	* tp/t/test_parse_texi_line.t, tp/t/test_parser_registrar.t,
        tp/t/test_protect_hashchar_at_line_beginning.t: Remove line numbers
	from reference error lines.

2022-02-21  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/LaTeX.pm (_latex_header): readd framemethod=tikz
	option for mdframed for roundcorners for @cartouche formatting
	now that the \fbox in sectioning command issue has been solved.

2022-02-21  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/LaTeX.pm (_convert): add a context if
	in heading formatting.  In heading formating, use 'error'
	as a string instead of a \fbox for @error formatting in
	contents bookmark string using \texorpdfstring{}.
	Based on Ulrike Fischer suggestion:
	https://github.com/latex3/hyperref/issues/207#issuecomment-920712424

2022-02-20  Patrice Dumas  <pertusus@free.fr>

	* tp/texi2any.pl: call get_conf() only after conf is setup.

2022-02-20  Patrice Dumas  <pertusus@free.fr>

	Decode input data to perl internal and encode messages

	* tp/Texinfo/Common.pm (@variable_string_settables),
	tp/Texinfo/Config.pm (_GNUT_encode_message, _GNUT_document_warn),
	tp/texi2any.pl ($main_program_set_options, _decode_i18n_string)
	(_encode_message, document_warn, handle_errors, _decode_input)
	(Getopt::Long::GetOptions): add DATA_INPUT_ENCODING_NAME and
	MESSAGE_OUTPUT_ENCODING_NAME set in the default case to the
	locale encoding, to decode from environment, command line and
	translated messages and encode messages.  Add FILE_NAMES_ENCODING_NAME
	for file names encoding but do not use it yet.

2022-02-20  Gavin Smith  <gavinsmith0123@gmail.com>

	@include file name encoding

	* tp/Texinfo/Common.pm (locate_include_file):
	Call utf8::encode on the argument, as otherwise an include
	file may not be found.
	Report from Gaël Bonithon <trash.paradise@protonmail.com> of
	failure building under non-ASCII directory name.

2022-02-19  Patrice Dumas  <pertusus@free.fr>

	* configure.ac (TEXINFO_DTD_VERSION), util/texinfo.dtd:
	update the DTD with new @-commands (latex, displaymath,
	subentry, seeentry, seealso). Remove definition. Some
	fixes. Define lt and amp predefined entities exactly as
	shown on the XML specification.

2022-02-19  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Common.pm (%close_paragraph_commands),
	tp/Texinfo/XS/parsetexi/commands.c (close_paragraph_command):
	have @need close paragraph/preformatted.

2022-02-18  Patrice Dumas  <pertusus@free.fr>

	* tp/Makefile.am, tp/Texinfo/ParserNonXS.pm (_encoding_alias)
	(%canonical_texinfo_encodings): remove Texinfo::Encoding, put
	the code directly in tp/Texinfo/ParserNonXS.pm.

2022-02-18  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Encoding.pm (encoding_alias): use Encode::find_encoding,
	both for the perl name, and, with mime_name() lower cased for the
	output/HTML/input encoding name.  Remove %encoding_aliases and
	%perl_charset_to_html.

2022-02-18  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/Unicode.pm (%unicode_to_eight_bit)
	(_eight_bit_and_unicode_point, encoded_accents)
	(unicode_point_decoded_in_encoding): use directly the input encodings
	names.  Separate mappings of koi8-u and koi8-r.

	* tp/Texinfo/Encoding.pm (encoding_alias): remove
	%eight_bit_encoding_aliases.  Use my, not our for variables not used
	elsewhere.

	* util/txixml2texi.pl: use directly Encode::resolve_alias() instead of
	Texinfo::Encoding::encoding_alias().

	* tp/Texinfo/XS/parsetexi/end_line.c (end_line_misc_line): add latin-1
	mapping.  Remove impossible or incorrect mappings from encoding_map.

	* doc/tp_api/Makefile.am: do not document Texinfo::Encoding.

2022-02-18  Patrice Dumas  <pertusus@free.fr>

	* Pod-Simple-Texinfo/pod2texi.pl: do not ignore an input file that
	cannot be searched for the manual name.

	* doc/tp_api/Makefile.am (tp_api_TEXINFOS): add tp_api_indices.texi.

2022-02-18  Patrice Dumas  <pertusus@free.fr>

	* Pod-Simple-Texinfo/pod2texi.pl (--setfilename): add --setfilename
	option to be able to pass @setfilename argument for top boilerplate,
	in particular if outputting on stdout.

	* doc/tp_api/Makefile.am, doc/tp_api/tp_api_indices.texi: prepend
	tp_api_indices.texi to tp_api.texi to output indices.

2022-02-18  Patrice Dumas  <pertusus@free.fr>

	Title page info specific handling in DocBook

	* tp/Texinfo/Convert/DocBook.pm (%ignored_block_commands, output)
	(_convert): determine title based on more @-commands than @settitle.
	Get only title, subtitle and authors informations from @titlepage.
	Get title, author and legal notice informations in headers, afterwards
	ignore @copying, @titlepage.  Ignore @documentdescription.
	Set @documentlanguage to the end of preamble value for the header
	formatting.

2022-02-17  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/DocBook.pm (%docbook_misc_elements_with_arg_map)
